/* NOTE: Do not edit this file, it is generated by a script:
   Export.py --api gl 4.4 --api wgl 4.4 --api glx 4.4 --api cgl 1.4 --api egl 1.0 --outdir .
*/

/*
  Copyright (c) 2011-2013 NVIDIA Corporation
  Copyright (c) 2011-2013 Cass Everitt
  Copyright (c) 2012-2013 Scott Nations
  Copyright (c) 2012 Mathias Schott
  Copyright (c) 2012-2013 Nigel Stewart
  Copyright (c) 2012-2013 Google Inc.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification,
  are permitted provided that the following conditions are met:

    Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.

    Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
  OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
  Intended formatting conventions:
  $ astyle --style=allman --indent=spaces=2 --indent-switches
*/

#include "pch.h" /* For MS precompiled header support */

#include "RegalUtil.h"

#if REGAL_DRIVER && REGAL_SYS_PPAPI
REGAL_GLOBAL_BEGIN

#include <string>
using namespace std;

#include "RegalLog.h"
#include "RegalBreak.h"
#include "RegalPush.h"
#include "RegalToken.h"
#include "RegalHelper.h"
#include "RegalPrivate.h"
#include "RegalContext.h"
#include <ppapi/c/ppb_opengles2.h>

REGAL_GLOBAL_END

REGAL_NAMESPACE_BEGIN

using namespace ::REGAL_NAMESPACE_INTERNAL::Logging;
using namespace ::REGAL_NAMESPACE_INTERNAL::Token;

static void REGAL_CALL ppapi_glBlendFunc(GLenum sfactor, GLenum dfactor)
{
  Internal("ppapi_glBlendFunc","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BlendFunc)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BlendFunc(rCtx->ppapiResource, sfactor, dfactor);
}

static void REGAL_CALL ppapi_glClear(GLbitfield mask)
{
  Internal("ppapi_glClear","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Clear)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Clear(rCtx->ppapiResource, mask);
}

static void REGAL_CALL ppapi_glClearColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
  Internal("ppapi_glClearColor","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ClearColor)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ClearColor(rCtx->ppapiResource, red, green, blue, alpha);
}

static void REGAL_CALL ppapi_glClearStencil(GLint s)
{
  Internal("ppapi_glClearStencil","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ClearStencil)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ClearStencil(rCtx->ppapiResource, s);
}

static void REGAL_CALL ppapi_glColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha)
{
  Internal("ppapi_glColorMask","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ColorMask)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ColorMask(rCtx->ppapiResource, red, green, blue, alpha);
}

static void REGAL_CALL ppapi_glCullFace(GLenum mode)
{
  Internal("ppapi_glCullFace","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CullFace)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->CullFace(rCtx->ppapiResource, mode);
}

static void REGAL_CALL ppapi_glDepthFunc(GLenum func)
{
  Internal("ppapi_glDepthFunc","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DepthFunc)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DepthFunc(rCtx->ppapiResource, func);
}

static void REGAL_CALL ppapi_glDepthMask(GLboolean flag)
{
  Internal("ppapi_glDepthMask","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DepthMask)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DepthMask(rCtx->ppapiResource, flag);
}

static void REGAL_CALL ppapi_glDisable(GLenum cap)
{
  Internal("ppapi_glDisable","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Disable)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Disable(rCtx->ppapiResource, cap);
}

static void REGAL_CALL ppapi_glEnable(GLenum cap)
{
  Internal("ppapi_glEnable","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Enable)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Enable(rCtx->ppapiResource, cap);
}

static void REGAL_CALL ppapi_glFinish(void)
{
  Internal("ppapi_glFinish","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Finish)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Finish(rCtx->ppapiResource);
}

static void REGAL_CALL ppapi_glFlush(void)
{
  Internal("ppapi_glFlush","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Flush)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Flush(rCtx->ppapiResource);
}

static void REGAL_CALL ppapi_glFrontFace(GLenum mode)
{
  Internal("ppapi_glFrontFace","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->FrontFace)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->FrontFace(rCtx->ppapiResource, mode);
}

static void REGAL_CALL ppapi_glGetBooleanv(GLenum pname, GLboolean *params)
{
  Internal("ppapi_glGetBooleanv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetBooleanv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetBooleanv(rCtx->ppapiResource, pname, params);
}

static GLenum REGAL_CALL ppapi_glGetError(void)
{
  Internal("ppapi_glGetError","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetError)
  RegalAssert(rCtx->ppapiResource)
  GLenum  ret = rCtx->ppapiES2->GetError(rCtx->ppapiResource);
  return ret;
}

static void REGAL_CALL ppapi_glGetFloatv(GLenum pname, GLfloat *params)
{
  Internal("ppapi_glGetFloatv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetFloatv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetFloatv(rCtx->ppapiResource, pname, params);
}

static void REGAL_CALL ppapi_glGetIntegerv(GLenum pname, GLint *params)
{
  Internal("ppapi_glGetIntegerv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetIntegerv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetIntegerv(rCtx->ppapiResource, pname, params);
}

static const GLubyte *REGAL_CALL ppapi_glGetString(GLenum name)
{
  Internal("ppapi_glGetString","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetString)
  RegalAssert(rCtx->ppapiResource)
  const GLubyte * ret = rCtx->ppapiES2->GetString(rCtx->ppapiResource, name);
  return ret;
}

static void REGAL_CALL ppapi_glGetTexParameterfv(GLenum target, GLenum pname, GLfloat *params)
{
  Internal("ppapi_glGetTexParameterfv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetTexParameterfv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetTexParameterfv(rCtx->ppapiResource, target, pname, params);
}

static void REGAL_CALL ppapi_glGetTexParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetTexParameteriv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetTexParameteriv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetTexParameteriv(rCtx->ppapiResource, target, pname, params);
}

static void REGAL_CALL ppapi_glHint(GLenum target, GLenum mode)
{
  Internal("ppapi_glHint","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Hint)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Hint(rCtx->ppapiResource, target, mode);
}

static GLboolean REGAL_CALL ppapi_glIsEnabled(GLenum cap)
{
  Internal("ppapi_glIsEnabled","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsEnabled)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsEnabled(rCtx->ppapiResource, cap);
  return ret;
}

static void REGAL_CALL ppapi_glLineWidth(GLfloat width)
{
  Internal("ppapi_glLineWidth","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->LineWidth)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->LineWidth(rCtx->ppapiResource, width);
}

static void REGAL_CALL ppapi_glPixelStorei(GLenum pname, GLint param)
{
  Internal("ppapi_glPixelStorei","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->PixelStorei)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->PixelStorei(rCtx->ppapiResource, pname, param);
}

static void REGAL_CALL ppapi_glReadPixels(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels)
{
  Internal("ppapi_glReadPixels","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ReadPixels)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ReadPixels(rCtx->ppapiResource, x, y, width, height, format, type, pixels);
}

static void REGAL_CALL ppapi_glScissor(GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("ppapi_glScissor","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Scissor)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Scissor(rCtx->ppapiResource, x, y, width, height);
}

static void REGAL_CALL ppapi_glStencilFunc(GLenum func, GLint ref, GLuint mask)
{
  Internal("ppapi_glStencilFunc","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->StencilFunc)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->StencilFunc(rCtx->ppapiResource, func, ref, mask);
}

static void REGAL_CALL ppapi_glStencilMask(GLuint mask)
{
  Internal("ppapi_glStencilMask","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->StencilMask)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->StencilMask(rCtx->ppapiResource, mask);
}

static void REGAL_CALL ppapi_glStencilOp(GLenum fail, GLenum zfail, GLenum zpass)
{
  Internal("ppapi_glStencilOp","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->StencilOp)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->StencilOp(rCtx->ppapiResource, fail, zfail, zpass);
}

static void REGAL_CALL ppapi_glTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("ppapi_glTexImage2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->TexImage2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->TexImage2D(rCtx->ppapiResource, target, level, internalformat, width, height, border, format, type, pixels);
}

static void REGAL_CALL ppapi_glTexParameterf(GLenum target, GLenum pname, GLfloat param)
{
  Internal("ppapi_glTexParameterf","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->TexParameterf)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->TexParameterf(rCtx->ppapiResource, target, pname, param);
}

static void REGAL_CALL ppapi_glTexParameterfv(GLenum target, GLenum pname, const GLfloat *params)
{
  Internal("ppapi_glTexParameterfv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->TexParameterfv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->TexParameterfv(rCtx->ppapiResource, target, pname, params);
}

static void REGAL_CALL ppapi_glTexParameteri(GLenum target, GLenum pname, GLint param)
{
  Internal("ppapi_glTexParameteri","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->TexParameteri)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->TexParameteri(rCtx->ppapiResource, target, pname, param);
}

static void REGAL_CALL ppapi_glTexParameteriv(GLenum target, GLenum pname, const GLint *params)
{
  Internal("ppapi_glTexParameteriv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->TexParameteriv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->TexParameteriv(rCtx->ppapiResource, target, pname, params);
}

static void REGAL_CALL ppapi_glViewport(GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("ppapi_glViewport","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Viewport)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Viewport(rCtx->ppapiResource, x, y, width, height);
}

static void REGAL_CALL ppapi_glBindTexture(GLenum target, GLuint texture)
{
  Internal("ppapi_glBindTexture","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BindTexture)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BindTexture(rCtx->ppapiResource, target, texture);
}

static void REGAL_CALL ppapi_glCopyTexImage2D(GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border)
{
  Internal("ppapi_glCopyTexImage2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CopyTexImage2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->CopyTexImage2D(rCtx->ppapiResource, target, level, internalformat, x, y, width, height, border);
}

static void REGAL_CALL ppapi_glCopyTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height)
{
  Internal("ppapi_glCopyTexSubImage2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CopyTexSubImage2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->CopyTexSubImage2D(rCtx->ppapiResource, target, level, xoffset, yoffset, x, y, width, height);
}

static void REGAL_CALL ppapi_glDeleteTextures(GLsizei n, const GLuint *textures)
{
  Internal("ppapi_glDeleteTextures","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DeleteTextures)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DeleteTextures(rCtx->ppapiResource, n, textures);
}

static void REGAL_CALL ppapi_glDrawArrays(GLenum mode, GLint first, GLsizei count)
{
  Internal("ppapi_glDrawArrays","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DrawArrays)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DrawArrays(rCtx->ppapiResource, mode, first, count);
}

static void REGAL_CALL ppapi_glDrawElements(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices)
{
  Internal("ppapi_glDrawElements","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DrawElements)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DrawElements(rCtx->ppapiResource, mode, count, type, indices);
}

static void REGAL_CALL ppapi_glGenTextures(GLsizei n, GLuint *textures)
{
  Internal("ppapi_glGenTextures","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GenTextures)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GenTextures(rCtx->ppapiResource, n, textures);
}

static GLboolean REGAL_CALL ppapi_glIsTexture(GLuint texture)
{
  Internal("ppapi_glIsTexture","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsTexture)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsTexture(rCtx->ppapiResource, texture);
  return ret;
}

static void REGAL_CALL ppapi_glPolygonOffset(GLfloat factor, GLfloat units)
{
  Internal("ppapi_glPolygonOffset","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->PolygonOffset)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->PolygonOffset(rCtx->ppapiResource, factor, units);
}

static void REGAL_CALL ppapi_glTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels)
{
  Internal("ppapi_glTexSubImage2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->TexSubImage2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->TexSubImage2D(rCtx->ppapiResource, target, level, xoffset, yoffset, width, height, format, type, pixels);
}

static void REGAL_CALL ppapi_glBlendColor(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha)
{
  Internal("ppapi_glBlendColor","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BlendColor)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BlendColor(rCtx->ppapiResource, red, green, blue, alpha);
}

static void REGAL_CALL ppapi_glBlendEquation(GLenum mode)
{
  Internal("ppapi_glBlendEquation","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BlendEquation)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BlendEquation(rCtx->ppapiResource, mode);
}

static void REGAL_CALL ppapi_glActiveTexture(GLenum texture)
{
  Internal("ppapi_glActiveTexture","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ActiveTexture)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ActiveTexture(rCtx->ppapiResource, texture);
}

static void REGAL_CALL ppapi_glCompressedTexImage2D(GLenum target, GLint level, GLenum internalformat, GLsizei width, GLsizei height, GLint border, GLsizei imageSize, const GLvoid *data)
{
  Internal("ppapi_glCompressedTexImage2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CompressedTexImage2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->CompressedTexImage2D(rCtx->ppapiResource, target, level, internalformat, width, height, border, imageSize, data);
}

static void REGAL_CALL ppapi_glCompressedTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLsizei imageSize, const GLvoid *data)
{
  Internal("ppapi_glCompressedTexSubImage2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CompressedTexSubImage2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->CompressedTexSubImage2D(rCtx->ppapiResource, target, level, xoffset, yoffset, width, height, format, imageSize, data);
}

static void REGAL_CALL ppapi_glSampleCoverage(GLclampf value, GLboolean invert)
{
  Internal("ppapi_glSampleCoverage","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->SampleCoverage)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->SampleCoverage(rCtx->ppapiResource, value, invert);
}

static void REGAL_CALL ppapi_glBlendFuncSeparate(GLenum sfactorRGB, GLenum dfactorRGB, GLenum sfactorAlpha, GLenum dfactorAlpha)
{
  Internal("ppapi_glBlendFuncSeparate","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BlendFuncSeparate)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BlendFuncSeparate(rCtx->ppapiResource, sfactorRGB, dfactorRGB, sfactorAlpha, dfactorAlpha);
}

static void REGAL_CALL ppapi_glBindBuffer(GLenum target, GLuint buffer)
{
  Internal("ppapi_glBindBuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BindBuffer)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BindBuffer(rCtx->ppapiResource, target, buffer);
}

static void REGAL_CALL ppapi_glBufferData(GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage)
{
  Internal("ppapi_glBufferData","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BufferData)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BufferData(rCtx->ppapiResource, target, size, data, usage);
}

static void REGAL_CALL ppapi_glBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid *data)
{
  Internal("ppapi_glBufferSubData","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BufferSubData)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BufferSubData(rCtx->ppapiResource, target, offset, size, data);
}

static void REGAL_CALL ppapi_glDeleteBuffers(GLsizei n, const GLuint *buffers)
{
  Internal("ppapi_glDeleteBuffers","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DeleteBuffers)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DeleteBuffers(rCtx->ppapiResource, n, buffers);
}

static void REGAL_CALL ppapi_glGenBuffers(GLsizei n, GLuint *buffers)
{
  Internal("ppapi_glGenBuffers","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GenBuffers)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GenBuffers(rCtx->ppapiResource, n, buffers);
}

static void REGAL_CALL ppapi_glGetBufferParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetBufferParameteriv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetBufferParameteriv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetBufferParameteriv(rCtx->ppapiResource, target, pname, params);
}

static GLboolean REGAL_CALL ppapi_glIsBuffer(GLuint buffer)
{
  Internal("ppapi_glIsBuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsBuffer)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsBuffer(rCtx->ppapiResource, buffer);
  return ret;
}

static void REGAL_CALL ppapi_glAttachShader(GLuint program, GLuint shader)
{
  Internal("ppapi_glAttachShader","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->AttachShader)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->AttachShader(rCtx->ppapiResource, program, shader);
}

static void REGAL_CALL ppapi_glBindAttribLocation(GLuint program, GLuint index, const GLchar *name)
{
  Internal("ppapi_glBindAttribLocation","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BindAttribLocation)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BindAttribLocation(rCtx->ppapiResource, program, index, name);
}

static void REGAL_CALL ppapi_glBlendEquationSeparate(GLenum modeRGB, GLenum modeAlpha)
{
  Internal("ppapi_glBlendEquationSeparate","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BlendEquationSeparate)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BlendEquationSeparate(rCtx->ppapiResource, modeRGB, modeAlpha);
}

static void REGAL_CALL ppapi_glCompileShader(GLuint shader)
{
  Internal("ppapi_glCompileShader","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CompileShader)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->CompileShader(rCtx->ppapiResource, shader);
}

static GLuint REGAL_CALL ppapi_glCreateProgram(void)
{
  Internal("ppapi_glCreateProgram","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CreateProgram)
  RegalAssert(rCtx->ppapiResource)
  GLuint  ret = rCtx->ppapiES2->CreateProgram(rCtx->ppapiResource);
  return ret;
}

static GLuint REGAL_CALL ppapi_glCreateShader(GLenum type)
{
  Internal("ppapi_glCreateShader","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CreateShader)
  RegalAssert(rCtx->ppapiResource)
  GLuint  ret = rCtx->ppapiES2->CreateShader(rCtx->ppapiResource, type);
  return ret;
}

static void REGAL_CALL ppapi_glDeleteProgram(GLuint program)
{
  Internal("ppapi_glDeleteProgram","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DeleteProgram)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DeleteProgram(rCtx->ppapiResource, program);
}

static void REGAL_CALL ppapi_glDeleteShader(GLuint shader)
{
  Internal("ppapi_glDeleteShader","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DeleteShader)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DeleteShader(rCtx->ppapiResource, shader);
}

static void REGAL_CALL ppapi_glDetachShader(GLuint program, GLuint shader)
{
  Internal("ppapi_glDetachShader","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DetachShader)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DetachShader(rCtx->ppapiResource, program, shader);
}

static void REGAL_CALL ppapi_glDisableVertexAttribArray(GLuint index)
{
  Internal("ppapi_glDisableVertexAttribArray","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DisableVertexAttribArray)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DisableVertexAttribArray(rCtx->ppapiResource, index);
}

static void REGAL_CALL ppapi_glEnableVertexAttribArray(GLuint index)
{
  Internal("ppapi_glEnableVertexAttribArray","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->EnableVertexAttribArray)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->EnableVertexAttribArray(rCtx->ppapiResource, index);
}

static void REGAL_CALL ppapi_glGetActiveAttrib(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
{
  Internal("ppapi_glGetActiveAttrib","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetActiveAttrib)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetActiveAttrib(rCtx->ppapiResource, program, index, bufSize, length, size, type, name);
}

static void REGAL_CALL ppapi_glGetActiveUniform(GLuint program, GLuint index, GLsizei bufSize, GLsizei *length, GLint *size, GLenum *type, GLchar *name)
{
  Internal("ppapi_glGetActiveUniform","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetActiveUniform)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetActiveUniform(rCtx->ppapiResource, program, index, bufSize, length, size, type, name);
}

static void REGAL_CALL ppapi_glGetAttachedShaders(GLuint program, GLsizei maxCount, GLsizei *count, GLuint *shaders)
{
  Internal("ppapi_glGetAttachedShaders","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetAttachedShaders)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetAttachedShaders(rCtx->ppapiResource, program, maxCount, count, shaders);
}

static GLint REGAL_CALL ppapi_glGetAttribLocation(GLuint program, const GLchar *name)
{
  Internal("ppapi_glGetAttribLocation","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetAttribLocation)
  RegalAssert(rCtx->ppapiResource)
  GLint  ret = rCtx->ppapiES2->GetAttribLocation(rCtx->ppapiResource, program, name);
  return ret;
}

static void REGAL_CALL ppapi_glGetProgramInfoLog(GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
  Internal("ppapi_glGetProgramInfoLog","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetProgramInfoLog)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetProgramInfoLog(rCtx->ppapiResource, program, bufSize, length, infoLog);
}

static void REGAL_CALL ppapi_glGetProgramiv(GLuint program, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetProgramiv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetProgramiv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetProgramiv(rCtx->ppapiResource, program, pname, params);
}

static void REGAL_CALL ppapi_glGetShaderInfoLog(GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog)
{
  Internal("ppapi_glGetShaderInfoLog","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetShaderInfoLog)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetShaderInfoLog(rCtx->ppapiResource, shader, bufSize, length, infoLog);
}

static void REGAL_CALL ppapi_glGetShaderSource(GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *source)
{
  Internal("ppapi_glGetShaderSource","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetShaderSource)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetShaderSource(rCtx->ppapiResource, shader, bufSize, length, source);
}

static void REGAL_CALL ppapi_glGetShaderiv(GLuint shader, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetShaderiv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetShaderiv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetShaderiv(rCtx->ppapiResource, shader, pname, params);
}

static GLint REGAL_CALL ppapi_glGetUniformLocation(GLuint program, const GLchar *name)
{
  Internal("ppapi_glGetUniformLocation","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetUniformLocation)
  RegalAssert(rCtx->ppapiResource)
  GLint  ret = rCtx->ppapiES2->GetUniformLocation(rCtx->ppapiResource, program, name);
  return ret;
}

static void REGAL_CALL ppapi_glGetUniformfv(GLuint program, GLint location, GLfloat *params)
{
  Internal("ppapi_glGetUniformfv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetUniformfv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetUniformfv(rCtx->ppapiResource, program, location, params);
}

static void REGAL_CALL ppapi_glGetUniformiv(GLuint program, GLint location, GLint *params)
{
  Internal("ppapi_glGetUniformiv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetUniformiv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetUniformiv(rCtx->ppapiResource, program, location, params);
}

static void REGAL_CALL ppapi_glGetVertexAttribPointerv(GLuint index, GLenum pname, GLvoid **pointer)
{
  Internal("ppapi_glGetVertexAttribPointerv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetVertexAttribPointerv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetVertexAttribPointerv(rCtx->ppapiResource, index, pname, pointer);
}

static void REGAL_CALL ppapi_glGetVertexAttribfv(GLuint index, GLenum pname, GLfloat *params)
{
  Internal("ppapi_glGetVertexAttribfv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetVertexAttribfv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetVertexAttribfv(rCtx->ppapiResource, index, pname, params);
}

static void REGAL_CALL ppapi_glGetVertexAttribiv(GLuint index, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetVertexAttribiv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetVertexAttribiv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetVertexAttribiv(rCtx->ppapiResource, index, pname, params);
}

static GLboolean REGAL_CALL ppapi_glIsProgram(GLuint program)
{
  Internal("ppapi_glIsProgram","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsProgram)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsProgram(rCtx->ppapiResource, program);
  return ret;
}

static GLboolean REGAL_CALL ppapi_glIsShader(GLuint shader)
{
  Internal("ppapi_glIsShader","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsShader)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsShader(rCtx->ppapiResource, shader);
  return ret;
}

static void REGAL_CALL ppapi_glLinkProgram(GLuint program)
{
  Internal("ppapi_glLinkProgram","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->LinkProgram)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->LinkProgram(rCtx->ppapiResource, program);
}

static void REGAL_CALL ppapi_glShaderSource(GLuint shader, GLsizei count, const GLchar * const *string, const GLint *length)
{
  Internal("ppapi_glShaderSource","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ShaderSource)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ShaderSource(rCtx->ppapiResource, shader, count,const_cast<const GLchar **>(string), length);
}

static void REGAL_CALL ppapi_glStencilFuncSeparate(GLenum face, GLenum func, GLint ref, GLuint mask)
{
  Internal("ppapi_glStencilFuncSeparate","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->StencilFuncSeparate)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->StencilFuncSeparate(rCtx->ppapiResource, face, func, ref, mask);
}

static void REGAL_CALL ppapi_glStencilMaskSeparate(GLenum face, GLuint mask)
{
  Internal("ppapi_glStencilMaskSeparate","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->StencilMaskSeparate)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->StencilMaskSeparate(rCtx->ppapiResource, face, mask);
}

static void REGAL_CALL ppapi_glStencilOpSeparate(GLenum face, GLenum fail, GLenum zfail, GLenum zpass)
{
  Internal("ppapi_glStencilOpSeparate","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->StencilOpSeparate)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->StencilOpSeparate(rCtx->ppapiResource, face, fail, zfail, zpass);
}

static void REGAL_CALL ppapi_glUniform1f(GLint location, GLfloat v0)
{
  Internal("ppapi_glUniform1f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform1f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform1f(rCtx->ppapiResource, location, v0);
}

static void REGAL_CALL ppapi_glUniform1fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("ppapi_glUniform1fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform1fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform1fv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform1i(GLint location, GLint v0)
{
  Internal("ppapi_glUniform1i","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform1i)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform1i(rCtx->ppapiResource, location, v0);
}

static void REGAL_CALL ppapi_glUniform1iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("ppapi_glUniform1iv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform1iv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform1iv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform2f(GLint location, GLfloat v0, GLfloat v1)
{
  Internal("ppapi_glUniform2f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform2f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform2f(rCtx->ppapiResource, location, v0, v1);
}

static void REGAL_CALL ppapi_glUniform2fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("ppapi_glUniform2fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform2fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform2fv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform2i(GLint location, GLint v0, GLint v1)
{
  Internal("ppapi_glUniform2i","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform2i)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform2i(rCtx->ppapiResource, location, v0, v1);
}

static void REGAL_CALL ppapi_glUniform2iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("ppapi_glUniform2iv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform2iv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform2iv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform3f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2)
{
  Internal("ppapi_glUniform3f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform3f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform3f(rCtx->ppapiResource, location, v0, v1, v2);
}

static void REGAL_CALL ppapi_glUniform3fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("ppapi_glUniform3fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform3fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform3fv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform3i(GLint location, GLint v0, GLint v1, GLint v2)
{
  Internal("ppapi_glUniform3i","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform3i)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform3i(rCtx->ppapiResource, location, v0, v1, v2);
}

static void REGAL_CALL ppapi_glUniform3iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("ppapi_glUniform3iv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform3iv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform3iv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform4f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3)
{
  Internal("ppapi_glUniform4f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform4f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform4f(rCtx->ppapiResource, location, v0, v1, v2, v3);
}

static void REGAL_CALL ppapi_glUniform4fv(GLint location, GLsizei count, const GLfloat *value)
{
  Internal("ppapi_glUniform4fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform4fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform4fv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniform4i(GLint location, GLint v0, GLint v1, GLint v2, GLint v3)
{
  Internal("ppapi_glUniform4i","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform4i)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform4i(rCtx->ppapiResource, location, v0, v1, v2, v3);
}

static void REGAL_CALL ppapi_glUniform4iv(GLint location, GLsizei count, const GLint *value)
{
  Internal("ppapi_glUniform4iv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->Uniform4iv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->Uniform4iv(rCtx->ppapiResource, location, count, value);
}

static void REGAL_CALL ppapi_glUniformMatrix2fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("ppapi_glUniformMatrix2fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->UniformMatrix2fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->UniformMatrix2fv(rCtx->ppapiResource, location, count, transpose, value);
}

static void REGAL_CALL ppapi_glUniformMatrix3fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("ppapi_glUniformMatrix3fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->UniformMatrix3fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->UniformMatrix3fv(rCtx->ppapiResource, location, count, transpose, value);
}

static void REGAL_CALL ppapi_glUniformMatrix4fv(GLint location, GLsizei count, GLboolean transpose, const GLfloat *value)
{
  Internal("ppapi_glUniformMatrix4fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->UniformMatrix4fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->UniformMatrix4fv(rCtx->ppapiResource, location, count, transpose, value);
}

static void REGAL_CALL ppapi_glUseProgram(GLuint program)
{
  Internal("ppapi_glUseProgram","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->UseProgram)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->UseProgram(rCtx->ppapiResource, program);
}

static void REGAL_CALL ppapi_glValidateProgram(GLuint program)
{
  Internal("ppapi_glValidateProgram","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ValidateProgram)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ValidateProgram(rCtx->ppapiResource, program);
}

static void REGAL_CALL ppapi_glVertexAttrib1f(GLuint index, GLfloat x)
{
  Internal("ppapi_glVertexAttrib1f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib1f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib1f(rCtx->ppapiResource, index, x);
}

static void REGAL_CALL ppapi_glVertexAttrib1fv(GLuint index, const GLfloat *v)
{
  Internal("ppapi_glVertexAttrib1fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib1fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib1fv(rCtx->ppapiResource, index, v);
}

static void REGAL_CALL ppapi_glVertexAttrib2f(GLuint index, GLfloat x, GLfloat y)
{
  Internal("ppapi_glVertexAttrib2f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib2f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib2f(rCtx->ppapiResource, index, x, y);
}

static void REGAL_CALL ppapi_glVertexAttrib2fv(GLuint index, const GLfloat *v)
{
  Internal("ppapi_glVertexAttrib2fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib2fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib2fv(rCtx->ppapiResource, index, v);
}

static void REGAL_CALL ppapi_glVertexAttrib3f(GLuint index, GLfloat x, GLfloat y, GLfloat z)
{
  Internal("ppapi_glVertexAttrib3f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib3f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib3f(rCtx->ppapiResource, index, x, y, z);
}

static void REGAL_CALL ppapi_glVertexAttrib3fv(GLuint index, const GLfloat *v)
{
  Internal("ppapi_glVertexAttrib3fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib3fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib3fv(rCtx->ppapiResource, index, v);
}

static void REGAL_CALL ppapi_glVertexAttrib4f(GLuint index, GLfloat x, GLfloat y, GLfloat z, GLfloat w)
{
  Internal("ppapi_glVertexAttrib4f","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib4f)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib4f(rCtx->ppapiResource, index, x, y, z, w);
}

static void REGAL_CALL ppapi_glVertexAttrib4fv(GLuint index, const GLfloat *v)
{
  Internal("ppapi_glVertexAttrib4fv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttrib4fv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttrib4fv(rCtx->ppapiResource, index, v);
}

static void REGAL_CALL ppapi_glVertexAttribPointer(GLuint index, GLint size, GLenum type, GLboolean normalized, GLsizei stride, const GLvoid *pointer)
{
  Internal("ppapi_glVertexAttribPointer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->VertexAttribPointer)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->VertexAttribPointer(rCtx->ppapiResource, index, size, type, normalized, stride, pointer);
}

static void REGAL_CALL ppapi_glClearDepthf(GLclampf d)
{
  Internal("ppapi_glClearDepthf","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ClearDepthf)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ClearDepthf(rCtx->ppapiResource, d);
}

static void REGAL_CALL ppapi_glDepthRangef(GLclampf n, GLclampf f)
{
  Internal("ppapi_glDepthRangef","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DepthRangef)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DepthRangef(rCtx->ppapiResource, n, f);
}

static void REGAL_CALL ppapi_glGetShaderPrecisionFormat(GLenum shadertype, GLenum precisiontype, GLint *range, GLint *precision)
{
  Internal("ppapi_glGetShaderPrecisionFormat","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetShaderPrecisionFormat)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetShaderPrecisionFormat(rCtx->ppapiResource, shadertype, precisiontype, range, precision);
}

static void REGAL_CALL ppapi_glReleaseShaderCompiler(void)
{
  Internal("ppapi_glReleaseShaderCompiler","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ReleaseShaderCompiler)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ReleaseShaderCompiler(rCtx->ppapiResource);
}

static void REGAL_CALL ppapi_glShaderBinary(GLsizei count, const GLuint *shaders, GLenum binaryformat, const GLvoid *binary, GLsizei length)
{
  Internal("ppapi_glShaderBinary","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->ShaderBinary)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->ShaderBinary(rCtx->ppapiResource, count, shaders, binaryformat, binary, length);
}

static void REGAL_CALL ppapi_glBindFramebuffer(GLenum target, GLuint framebuffer)
{
  Internal("ppapi_glBindFramebuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BindFramebuffer)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BindFramebuffer(rCtx->ppapiResource, target, framebuffer);
}

static void REGAL_CALL ppapi_glBindRenderbuffer(GLenum target, GLuint renderbuffer)
{
  Internal("ppapi_glBindRenderbuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->BindRenderbuffer)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->BindRenderbuffer(rCtx->ppapiResource, target, renderbuffer);
}

static GLenum REGAL_CALL ppapi_glCheckFramebufferStatus(GLenum target)
{
  Internal("ppapi_glCheckFramebufferStatus","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->CheckFramebufferStatus)
  RegalAssert(rCtx->ppapiResource)
  GLenum  ret = rCtx->ppapiES2->CheckFramebufferStatus(rCtx->ppapiResource, target);
  return ret;
}

static void REGAL_CALL ppapi_glDeleteFramebuffers(GLsizei n, const GLuint *framebuffers)
{
  Internal("ppapi_glDeleteFramebuffers","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DeleteFramebuffers)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DeleteFramebuffers(rCtx->ppapiResource, n, framebuffers);
}

static void REGAL_CALL ppapi_glDeleteRenderbuffers(GLsizei n, const GLuint *renderbuffers)
{
  Internal("ppapi_glDeleteRenderbuffers","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->DeleteRenderbuffers)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->DeleteRenderbuffers(rCtx->ppapiResource, n, renderbuffers);
}

static void REGAL_CALL ppapi_glFramebufferRenderbuffer(GLenum target, GLenum attachment, GLenum renderbuffertarget, GLuint renderbuffer)
{
  Internal("ppapi_glFramebufferRenderbuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->FramebufferRenderbuffer)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->FramebufferRenderbuffer(rCtx->ppapiResource, target, attachment, renderbuffertarget, renderbuffer);
}

static void REGAL_CALL ppapi_glFramebufferTexture2D(GLenum target, GLenum attachment, GLenum textarget, GLuint texture, GLint level)
{
  Internal("ppapi_glFramebufferTexture2D","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->FramebufferTexture2D)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->FramebufferTexture2D(rCtx->ppapiResource, target, attachment, textarget, texture, level);
}

static void REGAL_CALL ppapi_glGenFramebuffers(GLsizei n, GLuint *framebuffers)
{
  Internal("ppapi_glGenFramebuffers","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GenFramebuffers)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GenFramebuffers(rCtx->ppapiResource, n, framebuffers);
}

static void REGAL_CALL ppapi_glGenRenderbuffers(GLsizei n, GLuint *renderbuffers)
{
  Internal("ppapi_glGenRenderbuffers","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GenRenderbuffers)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GenRenderbuffers(rCtx->ppapiResource, n, renderbuffers);
}

static void REGAL_CALL ppapi_glGenerateMipmap(GLenum target)
{
  Internal("ppapi_glGenerateMipmap","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GenerateMipmap)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GenerateMipmap(rCtx->ppapiResource, target);
}

static void REGAL_CALL ppapi_glGetFramebufferAttachmentParameteriv(GLenum target, GLenum attachment, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetFramebufferAttachmentParameteriv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetFramebufferAttachmentParameteriv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetFramebufferAttachmentParameteriv(rCtx->ppapiResource, target, attachment, pname, params);
}

static void REGAL_CALL ppapi_glGetRenderbufferParameteriv(GLenum target, GLenum pname, GLint *params)
{
  Internal("ppapi_glGetRenderbufferParameteriv","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->GetRenderbufferParameteriv)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->GetRenderbufferParameteriv(rCtx->ppapiResource, target, pname, params);
}

static GLboolean REGAL_CALL ppapi_glIsFramebuffer(GLuint framebuffer)
{
  Internal("ppapi_glIsFramebuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsFramebuffer)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsFramebuffer(rCtx->ppapiResource, framebuffer);
  return ret;
}

static GLboolean REGAL_CALL ppapi_glIsRenderbuffer(GLuint renderbuffer)
{
  Internal("ppapi_glIsRenderbuffer","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->IsRenderbuffer)
  RegalAssert(rCtx->ppapiResource)
  GLboolean  ret = rCtx->ppapiES2->IsRenderbuffer(rCtx->ppapiResource, renderbuffer);
  return ret;
}

static void REGAL_CALL ppapi_glRenderbufferStorage(GLenum target, GLenum internalformat, GLsizei width, GLsizei height)
{
  Internal("ppapi_glRenderbufferStorage","()");
  RegalContext * rCtx = REGAL_GET_CONTEXT();
  RegalAssert(rCtx)
  RegalAssert(rCtx->ppapiES2)
  RegalAssert(rCtx->ppapiES2->RenderbufferStorage)
  RegalAssert(rCtx->ppapiResource)
  rCtx->ppapiES2->RenderbufferStorage(rCtx->ppapiResource, target, internalformat, width, height);
}

void InitDispatchTablePpapi(DispatchTableGL &tbl)
{
  // OpenGL ES 2.0 only
  tbl.glBlendFunc = ppapi_glBlendFunc;
  tbl.glClear = ppapi_glClear;
  tbl.glClearColor = ppapi_glClearColor;
  tbl.glClearStencil = ppapi_glClearStencil;
  tbl.glColorMask = ppapi_glColorMask;
  tbl.glCullFace = ppapi_glCullFace;
  tbl.glDepthFunc = ppapi_glDepthFunc;
  tbl.glDepthMask = ppapi_glDepthMask;
  tbl.glDisable = ppapi_glDisable;
  tbl.glEnable = ppapi_glEnable;
  tbl.glFinish = ppapi_glFinish;
  tbl.glFlush = ppapi_glFlush;
  tbl.glFrontFace = ppapi_glFrontFace;
  tbl.glGetBooleanv = ppapi_glGetBooleanv;
  tbl.glGetError = ppapi_glGetError;
  tbl.glGetFloatv = ppapi_glGetFloatv;
  tbl.glGetIntegerv = ppapi_glGetIntegerv;
  tbl.glGetString = ppapi_glGetString;
  tbl.glGetTexParameterfv = ppapi_glGetTexParameterfv;
  tbl.glGetTexParameteriv = ppapi_glGetTexParameteriv;
  tbl.glHint = ppapi_glHint;
  tbl.glIsEnabled = ppapi_glIsEnabled;
  tbl.glLineWidth = ppapi_glLineWidth;
  tbl.glPixelStorei = ppapi_glPixelStorei;
  tbl.glReadPixels = ppapi_glReadPixels;
  tbl.glScissor = ppapi_glScissor;
  tbl.glStencilFunc = ppapi_glStencilFunc;
  tbl.glStencilMask = ppapi_glStencilMask;
  tbl.glStencilOp = ppapi_glStencilOp;
  tbl.glTexImage2D = ppapi_glTexImage2D;
  tbl.glTexParameterf = ppapi_glTexParameterf;
  tbl.glTexParameterfv = ppapi_glTexParameterfv;
  tbl.glTexParameteri = ppapi_glTexParameteri;
  tbl.glTexParameteriv = ppapi_glTexParameteriv;
  tbl.glViewport = ppapi_glViewport;
  tbl.glBindTexture = ppapi_glBindTexture;
  tbl.glCopyTexImage2D = ppapi_glCopyTexImage2D;
  tbl.glCopyTexSubImage2D = ppapi_glCopyTexSubImage2D;
  tbl.glDeleteTextures = ppapi_glDeleteTextures;
  tbl.glDrawArrays = ppapi_glDrawArrays;
  tbl.glDrawElements = ppapi_glDrawElements;
  tbl.glGenTextures = ppapi_glGenTextures;
  tbl.glIsTexture = ppapi_glIsTexture;
  tbl.glPolygonOffset = ppapi_glPolygonOffset;
  tbl.glTexSubImage2D = ppapi_glTexSubImage2D;
  tbl.glBlendColor = ppapi_glBlendColor;
  tbl.glBlendEquation = ppapi_glBlendEquation;
  tbl.glActiveTexture = ppapi_glActiveTexture;
  tbl.glCompressedTexImage2D = ppapi_glCompressedTexImage2D;
  tbl.glCompressedTexSubImage2D = ppapi_glCompressedTexSubImage2D;
  tbl.glSampleCoverage = ppapi_glSampleCoverage;
  tbl.glBlendFuncSeparate = ppapi_glBlendFuncSeparate;
  tbl.glBindBuffer = ppapi_glBindBuffer;
  tbl.glBufferData = ppapi_glBufferData;
  tbl.glBufferSubData = ppapi_glBufferSubData;
  tbl.glDeleteBuffers = ppapi_glDeleteBuffers;
  tbl.glGenBuffers = ppapi_glGenBuffers;
  tbl.glGetBufferParameteriv = ppapi_glGetBufferParameteriv;
  tbl.glIsBuffer = ppapi_glIsBuffer;
  tbl.glAttachShader = ppapi_glAttachShader;
  tbl.glBindAttribLocation = ppapi_glBindAttribLocation;
  tbl.glBlendEquationSeparate = ppapi_glBlendEquationSeparate;
  tbl.glCompileShader = ppapi_glCompileShader;
  tbl.glCreateProgram = ppapi_glCreateProgram;
  tbl.glCreateShader = ppapi_glCreateShader;
  tbl.glDeleteProgram = ppapi_glDeleteProgram;
  tbl.glDeleteShader = ppapi_glDeleteShader;
  tbl.glDetachShader = ppapi_glDetachShader;
  tbl.glDisableVertexAttribArray = ppapi_glDisableVertexAttribArray;
  tbl.glEnableVertexAttribArray = ppapi_glEnableVertexAttribArray;
  tbl.glGetActiveAttrib = ppapi_glGetActiveAttrib;
  tbl.glGetActiveUniform = ppapi_glGetActiveUniform;
  tbl.glGetAttachedShaders = ppapi_glGetAttachedShaders;
  tbl.glGetAttribLocation = ppapi_glGetAttribLocation;
  tbl.glGetProgramInfoLog = ppapi_glGetProgramInfoLog;
  tbl.glGetProgramiv = ppapi_glGetProgramiv;
  tbl.glGetShaderInfoLog = ppapi_glGetShaderInfoLog;
  tbl.glGetShaderSource = ppapi_glGetShaderSource;
  tbl.glGetShaderiv = ppapi_glGetShaderiv;
  tbl.glGetUniformLocation = ppapi_glGetUniformLocation;
  tbl.glGetUniformfv = ppapi_glGetUniformfv;
  tbl.glGetUniformiv = ppapi_glGetUniformiv;
  tbl.glGetVertexAttribPointerv = ppapi_glGetVertexAttribPointerv;
  tbl.glGetVertexAttribfv = ppapi_glGetVertexAttribfv;
  tbl.glGetVertexAttribiv = ppapi_glGetVertexAttribiv;
  tbl.glIsProgram = ppapi_glIsProgram;
  tbl.glIsShader = ppapi_glIsShader;
  tbl.glLinkProgram = ppapi_glLinkProgram;
  tbl.glShaderSource = ppapi_glShaderSource;
  tbl.glStencilFuncSeparate = ppapi_glStencilFuncSeparate;
  tbl.glStencilMaskSeparate = ppapi_glStencilMaskSeparate;
  tbl.glStencilOpSeparate = ppapi_glStencilOpSeparate;
  tbl.glUniform1f = ppapi_glUniform1f;
  tbl.glUniform1fv = ppapi_glUniform1fv;
  tbl.glUniform1i = ppapi_glUniform1i;
  tbl.glUniform1iv = ppapi_glUniform1iv;
  tbl.glUniform2f = ppapi_glUniform2f;
  tbl.glUniform2fv = ppapi_glUniform2fv;
  tbl.glUniform2i = ppapi_glUniform2i;
  tbl.glUniform2iv = ppapi_glUniform2iv;
  tbl.glUniform3f = ppapi_glUniform3f;
  tbl.glUniform3fv = ppapi_glUniform3fv;
  tbl.glUniform3i = ppapi_glUniform3i;
  tbl.glUniform3iv = ppapi_glUniform3iv;
  tbl.glUniform4f = ppapi_glUniform4f;
  tbl.glUniform4fv = ppapi_glUniform4fv;
  tbl.glUniform4i = ppapi_glUniform4i;
  tbl.glUniform4iv = ppapi_glUniform4iv;
  tbl.glUniformMatrix2fv = ppapi_glUniformMatrix2fv;
  tbl.glUniformMatrix3fv = ppapi_glUniformMatrix3fv;
  tbl.glUniformMatrix4fv = ppapi_glUniformMatrix4fv;
  tbl.glUseProgram = ppapi_glUseProgram;
  tbl.glValidateProgram = ppapi_glValidateProgram;
  tbl.glVertexAttrib1f = ppapi_glVertexAttrib1f;
  tbl.glVertexAttrib1fv = ppapi_glVertexAttrib1fv;
  tbl.glVertexAttrib2f = ppapi_glVertexAttrib2f;
  tbl.glVertexAttrib2fv = ppapi_glVertexAttrib2fv;
  tbl.glVertexAttrib3f = ppapi_glVertexAttrib3f;
  tbl.glVertexAttrib3fv = ppapi_glVertexAttrib3fv;
  tbl.glVertexAttrib4f = ppapi_glVertexAttrib4f;
  tbl.glVertexAttrib4fv = ppapi_glVertexAttrib4fv;
  tbl.glVertexAttribPointer = ppapi_glVertexAttribPointer;
  tbl.glClearDepthf = ppapi_glClearDepthf;
  tbl.glDepthRangef = ppapi_glDepthRangef;
  tbl.glGetShaderPrecisionFormat = ppapi_glGetShaderPrecisionFormat;
  tbl.glReleaseShaderCompiler = ppapi_glReleaseShaderCompiler;
  tbl.glShaderBinary = ppapi_glShaderBinary;
  tbl.glBindFramebuffer = ppapi_glBindFramebuffer;
  tbl.glBindRenderbuffer = ppapi_glBindRenderbuffer;
  tbl.glCheckFramebufferStatus = ppapi_glCheckFramebufferStatus;
  tbl.glDeleteFramebuffers = ppapi_glDeleteFramebuffers;
  tbl.glDeleteRenderbuffers = ppapi_glDeleteRenderbuffers;
  tbl.glFramebufferRenderbuffer = ppapi_glFramebufferRenderbuffer;
  tbl.glFramebufferTexture2D = ppapi_glFramebufferTexture2D;
  tbl.glGenFramebuffers = ppapi_glGenFramebuffers;
  tbl.glGenRenderbuffers = ppapi_glGenRenderbuffers;
  tbl.glGenerateMipmap = ppapi_glGenerateMipmap;
  tbl.glGetFramebufferAttachmentParameteriv = ppapi_glGetFramebufferAttachmentParameteriv;
  tbl.glGetRenderbufferParameteriv = ppapi_glGetRenderbufferParameteriv;
  tbl.glIsFramebuffer = ppapi_glIsFramebuffer;
  tbl.glIsRenderbuffer = ppapi_glIsRenderbuffer;
  tbl.glRenderbufferStorage = ppapi_glRenderbufferStorage;

}

REGAL_NAMESPACE_END

#endif
