/* NOTE: Do not edit this file, it is generated by a script:
   Export.py --api gl 4.4 --api wgl 4.4 --api glx 4.4 --api cgl 1.4 --api egl 1.0 --outdir .
*/

/*
  Copyright (c) 2011-2013 NVIDIA Corporation
  Copyright (c) 2011-2013 Cass Everitt
  Copyright (c) 2012-2013 Scott Nations
  Copyright (c) 2012 Mathias Schott
  Copyright (c) 2012-2013 Nigel Stewart
  Copyright (c) 2012-2013 Google Inc.
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification,
  are permitted provided that the following conditions are met:

    Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.

    Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
  OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
  OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
  Intended formatting conventions:
  $ astyle --style=allman --indent=spaces=2 --indent-switches
*/

#ifndef __REGAL_STATISTICS_H__
#define __REGAL_STATISTICS_H__

#include "RegalUtil.h"

#if REGAL_STATISTICS

REGAL_GLOBAL_BEGIN

#include <GL/Regal.h>

REGAL_GLOBAL_END

REGAL_NAMESPACE_BEGIN

struct Statistics
{
  Statistics();
  ~Statistics();

  void reset();
  void log() const;

  static inline void log(const char *name, const GLuint count);

  GLuint gl_version_1_0;
  GLuint gl_version_1_1;
  GLuint gl_version_1_2;
  GLuint gl_version_1_3;
  GLuint gl_version_1_4;
  GLuint gl_version_1_5;
  GLuint gl_version_2_0;
  GLuint gl_version_2_1;
  GLuint gl_version_3_0;
  GLuint gl_version_3_1;
  GLuint gl_version_3_2;
  GLuint gl_version_3_3;
  GLuint gl_version_4_0;
  GLuint gl_version_4_1;
  GLuint gl_version_4_2;
  GLuint gl_version_4_3;
  GLuint gl_version_4_4;

  GLuint glx_version_1_0;
  GLuint glx_version_1_1;
  GLuint glx_version_1_2;
  GLuint glx_version_1_3;
  GLuint glx_version_1_4;

  GLuint egl_version_1_0;
  GLuint egl_version_1_1;
  GLuint egl_version_1_2;

  GLuint gl_3dfx_multisample;
  GLuint gl_3dfx_tbuffer;
  GLuint gl_3dfx_texture_compression_fxt1;
  GLuint gl_amd_blend_minmax_factor;
  GLuint gl_amd_compressed_3dc_texture;
  GLuint gl_amd_compressed_atc_texture;
  GLuint gl_amd_debug_output;
  GLuint gl_amd_depth_clamp_separate;
  GLuint gl_amd_draw_buffers_blend;
  GLuint gl_amd_interleaved_elements;
  GLuint gl_amd_multi_draw_indirect;
  GLuint gl_amd_name_gen_delete;
  GLuint gl_amd_performance_monitor;
  GLuint gl_amd_pinned_memory;
  GLuint gl_amd_program_binary_z400;
  GLuint gl_amd_query_buffer_object;
  GLuint gl_amd_sample_positions;
  GLuint gl_amd_seamless_cubemap_per_texture;
  GLuint gl_amd_sparse_texture;
  GLuint gl_amd_stencil_operation_extended;
  GLuint gl_amd_vertex_shader_tessellator;
  GLuint gl_angle_framebuffer_blit;
  GLuint gl_angle_framebuffer_multisample;
  GLuint gl_angle_instanced_arrays;
  GLuint gl_angle_pack_reverse_row_order;
  GLuint gl_angle_program_binary;
  GLuint gl_angle_texture_compression_dxt1;
  GLuint gl_angle_texture_compression_dxt3;
  GLuint gl_angle_texture_compression_dxt5;
  GLuint gl_angle_texture_usage;
  GLuint gl_angle_timer_query;
  GLuint gl_angle_translated_shader_source;
  GLuint gl_apple_aux_depth_stencil;
  GLuint gl_apple_client_storage;
  GLuint gl_apple_copy_texture_levels;
  GLuint gl_apple_element_array;
  GLuint gl_apple_fence;
  GLuint gl_apple_float_pixels;
  GLuint gl_apple_flush_buffer_range;
  GLuint gl_apple_flush_render;
  GLuint gl_apple_framebuffer_multisample;
  GLuint gl_apple_object_purgeable;
  GLuint gl_apple_pixel_buffer;
  GLuint gl_apple_rgb_422;
  GLuint gl_apple_row_bytes;
  GLuint gl_apple_specular_vector;
  GLuint gl_apple_sync;
  GLuint gl_apple_texture_max_level;
  GLuint gl_apple_texture_range;
  GLuint gl_apple_transform_hint;
  GLuint gl_apple_vertex_array_object;
  GLuint gl_apple_vertex_array_range;
  GLuint gl_apple_vertex_program_evaluators;
  GLuint gl_apple_ycbcr_422;
  GLuint gl_arb_es2_compatibility;
  GLuint gl_arb_es3_compatibility;
  GLuint gl_arb_base_instance;
  GLuint gl_arb_bindless_texture;
  GLuint gl_arb_blend_func_extended;
  GLuint gl_arb_buffer_storage;
  GLuint gl_arb_cl_event;
  GLuint gl_arb_clear_buffer_object;
  GLuint gl_arb_clear_texture;
  GLuint gl_arb_color_buffer_float;
  GLuint gl_arb_compressed_texture_pixel_storage;
  GLuint gl_arb_compute_shader;
  GLuint gl_arb_compute_variable_group_size;
  GLuint gl_arb_copy_buffer;
  GLuint gl_arb_copy_image;
  GLuint gl_arb_debug_output;
  GLuint gl_arb_depth_buffer_float;
  GLuint gl_arb_depth_clamp;
  GLuint gl_arb_depth_texture;
  GLuint gl_arb_draw_buffers;
  GLuint gl_arb_draw_buffers_blend;
  GLuint gl_arb_draw_elements_base_vertex;
  GLuint gl_arb_draw_indirect;
  GLuint gl_arb_draw_instanced;
  GLuint gl_arb_enhanced_layouts;
  GLuint gl_arb_explicit_uniform_location;
  GLuint gl_arb_fragment_program;
  GLuint gl_arb_fragment_shader;
  GLuint gl_arb_framebuffer_no_attachments;
  GLuint gl_arb_framebuffer_object;
  GLuint gl_arb_framebuffer_srgb;
  GLuint gl_arb_geometry_shader4;
  GLuint gl_arb_get_program_binary;
  GLuint gl_arb_gpu_shader5;
  GLuint gl_arb_gpu_shader_fp64;
  GLuint gl_arb_half_float_pixel;
  GLuint gl_arb_half_float_vertex;
  GLuint gl_arb_imaging;
  GLuint gl_arb_indirect_parameters;
  GLuint gl_arb_instanced_arrays;
  GLuint gl_arb_internalformat_query;
  GLuint gl_arb_internalformat_query2;
  GLuint gl_arb_invalidate_subdata;
  GLuint gl_arb_map_buffer_alignment;
  GLuint gl_arb_map_buffer_range;
  GLuint gl_arb_matrix_palette;
  GLuint gl_arb_multi_bind;
  GLuint gl_arb_multi_draw_indirect;
  GLuint gl_arb_multisample;
  GLuint gl_arb_multitexture;
  GLuint gl_arb_occlusion_query;
  GLuint gl_arb_occlusion_query2;
  GLuint gl_arb_pixel_buffer_object;
  GLuint gl_arb_point_parameters;
  GLuint gl_arb_point_sprite;
  GLuint gl_arb_program_interface_query;
  GLuint gl_arb_provoking_vertex;
  GLuint gl_arb_query_buffer_object;
  GLuint gl_arb_robustness;
  GLuint gl_arb_sample_shading;
  GLuint gl_arb_sampler_objects;
  GLuint gl_arb_seamless_cube_map;
  GLuint gl_arb_separate_shader_objects;
  GLuint gl_arb_shader_atomic_counters;
  GLuint gl_arb_shader_image_load_store;
  GLuint gl_arb_shader_objects;
  GLuint gl_arb_shader_storage_buffer_object;
  GLuint gl_arb_shader_subroutine;
  GLuint gl_arb_shading_language_100;
  GLuint gl_arb_shading_language_include;
  GLuint gl_arb_shadow;
  GLuint gl_arb_shadow_ambient;
  GLuint gl_arb_sparse_texture;
  GLuint gl_arb_stencil_texturing;
  GLuint gl_arb_sync;
  GLuint gl_arb_tessellation_shader;
  GLuint gl_arb_texture_border_clamp;
  GLuint gl_arb_texture_buffer_object;
  GLuint gl_arb_texture_buffer_range;
  GLuint gl_arb_texture_compression;
  GLuint gl_arb_texture_compression_bptc;
  GLuint gl_arb_texture_compression_rgtc;
  GLuint gl_arb_texture_cube_map;
  GLuint gl_arb_texture_cube_map_array;
  GLuint gl_arb_texture_env_combine;
  GLuint gl_arb_texture_env_dot3;
  GLuint gl_arb_texture_float;
  GLuint gl_arb_texture_gather;
  GLuint gl_arb_texture_mirror_clamp_to_edge;
  GLuint gl_arb_texture_mirrored_repeat;
  GLuint gl_arb_texture_multisample;
  GLuint gl_arb_texture_rectangle;
  GLuint gl_arb_texture_rg;
  GLuint gl_arb_texture_rgb10_a2ui;
  GLuint gl_arb_texture_storage;
  GLuint gl_arb_texture_storage_multisample;
  GLuint gl_arb_texture_swizzle;
  GLuint gl_arb_texture_view;
  GLuint gl_arb_timer_query;
  GLuint gl_arb_transform_feedback2;
  GLuint gl_arb_transform_feedback3;
  GLuint gl_arb_transform_feedback_instanced;
  GLuint gl_arb_transpose_matrix;
  GLuint gl_arb_uniform_buffer_object;
  GLuint gl_arb_vertex_array_object;
  GLuint gl_arb_vertex_attrib_64bit;
  GLuint gl_arb_vertex_attrib_binding;
  GLuint gl_arb_vertex_blend;
  GLuint gl_arb_vertex_buffer_object;
  GLuint gl_arb_vertex_program;
  GLuint gl_arb_vertex_shader;
  GLuint gl_arb_vertex_type_2_10_10_10_rev;
  GLuint gl_arb_viewport_array;
  GLuint gl_arb_window_pos;
  GLuint gl_arm_mali_program_binary;
  GLuint gl_arm_mali_shader_binary;
  GLuint gl_ati_draw_buffers;
  GLuint gl_ati_element_array;
  GLuint gl_ati_envmap_bumpmap;
  GLuint gl_ati_fragment_shader;
  GLuint gl_ati_map_object_buffer;
  GLuint gl_ati_meminfo;
  GLuint gl_ati_pn_triangles;
  GLuint gl_ati_separate_stencil;
  GLuint gl_ati_text_fragment_shader;
  GLuint gl_ati_texture_compression_3dc;
  GLuint gl_ati_texture_env_combine3;
  GLuint gl_ati_texture_float;
  GLuint gl_ati_texture_mirror_once;
  GLuint gl_ati_vertex_array_object;
  GLuint gl_ati_vertex_attrib_array_object;
  GLuint gl_ati_vertex_streams;
  GLuint gl_dmp_shader_binary;
  GLuint gl_ext_422_pixels;
  GLuint gl_ext_cg_shader;
  GLuint gl_ext_abgr;
  GLuint gl_ext_bgra;
  GLuint gl_ext_bindable_uniform;
  GLuint gl_ext_blend_color;
  GLuint gl_ext_blend_equation_separate;
  GLuint gl_ext_blend_func_separate;
  GLuint gl_ext_blend_minmax;
  GLuint gl_ext_blend_subtract;
  GLuint gl_ext_clip_volume_hint;
  GLuint gl_ext_cmyka;
  GLuint gl_ext_color_buffer_half_float;
  GLuint gl_ext_color_subtable;
  GLuint gl_ext_compiled_vertex_array;
  GLuint gl_ext_convolution;
  GLuint gl_ext_coordinate_frame;
  GLuint gl_ext_copy_texture;
  GLuint gl_ext_cull_vertex;
  GLuint gl_ext_debug_label;
  GLuint gl_ext_debug_marker;
  GLuint gl_ext_depth_bounds_test;
  GLuint gl_ext_direct_state_access;
  GLuint gl_ext_discard_framebuffer;
  GLuint gl_ext_disjoint_timer_query;
  GLuint gl_ext_draw_buffers2;
  GLuint gl_ext_draw_instanced;
  GLuint gl_ext_draw_range_elements;
  GLuint gl_ext_fog_coord;
  GLuint gl_ext_fragment_lighting;
  GLuint gl_ext_framebuffer_blit;
  GLuint gl_ext_framebuffer_multisample;
  GLuint gl_ext_framebuffer_multisample_blit_scaled;
  GLuint gl_ext_framebuffer_object;
  GLuint gl_ext_framebuffer_srgb;
  GLuint gl_ext_geometry_shader4;
  GLuint gl_ext_gpu_program_parameters;
  GLuint gl_ext_gpu_shader4;
  GLuint gl_ext_histogram;
  GLuint gl_ext_index_func;
  GLuint gl_ext_index_material;
  GLuint gl_ext_light_texture;
  GLuint gl_ext_map_buffer_range;
  GLuint gl_ext_multi_draw_arrays;
  GLuint gl_ext_multisample;
  GLuint gl_ext_multisampled_render_to_texture;
  GLuint gl_ext_multiview_draw_buffers;
  GLuint gl_ext_occlusion_query_boolean;
  GLuint gl_ext_packed_depth_stencil;
  GLuint gl_ext_packed_float;
  GLuint gl_ext_packed_pixels;
  GLuint gl_ext_paletted_texture;
  GLuint gl_ext_pixel_buffer_object;
  GLuint gl_ext_pixel_transform;
  GLuint gl_ext_point_parameters;
  GLuint gl_ext_polygon_offset;
  GLuint gl_ext_provoking_vertex;
  GLuint gl_ext_read_format_bgra;
  GLuint gl_ext_rescale_normal;
  GLuint gl_ext_robustness;
  GLuint gl_ext_srgb;
  GLuint gl_ext_scene_marker;
  GLuint gl_ext_secondary_color;
  GLuint gl_ext_separate_shader_objects;
  GLuint gl_ext_separate_specular_color;
  GLuint gl_ext_shader_framebuffer_fetch;
  GLuint gl_ext_shader_image_load_store;
  GLuint gl_ext_shadow_samplers;
  GLuint gl_ext_shared_texture_palette;
  GLuint gl_ext_stencil_clear_tag;
  GLuint gl_ext_stencil_two_side;
  GLuint gl_ext_stencil_wrap;
  GLuint gl_ext_subtexture;
  GLuint gl_ext_texture;
  GLuint gl_ext_texture3d;
  GLuint gl_ext_texture_array;
  GLuint gl_ext_texture_buffer_object;
  GLuint gl_ext_texture_compression_latc;
  GLuint gl_ext_texture_compression_rgtc;
  GLuint gl_ext_texture_compression_s3tc;
  GLuint gl_ext_texture_cube_map;
  GLuint gl_ext_texture_edge_clamp;
  GLuint gl_ext_texture_env_combine;
  GLuint gl_ext_texture_env_dot3;
  GLuint gl_ext_texture_filter_anisotropic;
  GLuint gl_ext_texture_format_bgra8888;
  GLuint gl_ext_texture_integer;
  GLuint gl_ext_texture_lod_bias;
  GLuint gl_ext_texture_mirror_clamp;
  GLuint gl_ext_texture_object;
  GLuint gl_ext_texture_perturb_normal;
  GLuint gl_ext_texture_rectangle;
  GLuint gl_ext_texture_rg;
  GLuint gl_ext_texture_srgb;
  GLuint gl_ext_texture_srgb_decode;
  GLuint gl_ext_texture_shared_exponent;
  GLuint gl_ext_texture_snorm;
  GLuint gl_ext_texture_storage;
  GLuint gl_ext_texture_swizzle;
  GLuint gl_ext_texture_type_2_10_10_10_rev;
  GLuint gl_ext_timer_query;
  GLuint gl_ext_transform_feedback;
  GLuint gl_ext_unpack_subimage;
  GLuint gl_ext_vertex_array;
  GLuint gl_ext_vertex_attrib_64bit;
  GLuint gl_ext_vertex_shader;
  GLuint gl_ext_vertex_weighting;
  GLuint gl_ext_x11_sync_object;
  GLuint gl_fj_shader_binary_gccso;
  GLuint gl_gremedy_frame_terminator;
  GLuint gl_gremedy_string_marker;
  GLuint gl_hp_image_transform;
  GLuint gl_hp_occlusion_test;
  GLuint gl_ibm_cull_vertex;
  GLuint gl_ibm_multimode_draw_arrays;
  GLuint gl_ibm_rasterpos_clip;
  GLuint gl_ibm_static_data;
  GLuint gl_ibm_texture_mirrored_repeat;
  GLuint gl_ibm_vertex_array_lists;
  GLuint gl_img_multisampled_render_to_texture;
  GLuint gl_img_program_binary;
  GLuint gl_img_read_format;
  GLuint gl_img_shader_binary;
  GLuint gl_img_texture_compression_pvrtc;
  GLuint gl_img_texture_compression_pvrtc2;
  GLuint gl_img_texture_env_enhanced_fixed_function;
  GLuint gl_img_user_clip_plane;
  GLuint gl_ingr_blend_func_separate;
  GLuint gl_ingr_color_clamp;
  GLuint gl_ingr_interlace_read;
  GLuint gl_intel_map_texture;
  GLuint gl_intel_parallel_arrays;
  GLuint gl_intel_texture_scissor;
  GLuint gl_khr_debug;
  GLuint gl_khr_texture_compression_astc_ldr;
  GLuint gl_ktx_buffer_region;
  GLuint gl_mesax_texture_stack;
  GLuint gl_mesa_pack_invert;
  GLuint gl_mesa_resize_buffers;
  GLuint gl_mesa_window_pos;
  GLuint gl_mesa_ycbcr_texture;
  GLuint gl_nvx_conditional_render;
  GLuint gl_nvx_gpu_memory_info;
  GLuint gl_nv_3dvision_settings;
  GLuint gl_nv_bgr;
  GLuint gl_nv_bindless_texture;
  GLuint gl_nv_blend_equation_advanced;
  GLuint gl_nv_blend_square;
  GLuint gl_nv_compute_program5;
  GLuint gl_nv_conditional_render;
  GLuint gl_nv_copy_buffer;
  GLuint gl_nv_copy_depth_to_color;
  GLuint gl_nv_copy_image;
  GLuint gl_nv_coverage_sample;
  GLuint gl_nv_deep_texture3d;
  GLuint gl_nv_depth_buffer_float;
  GLuint gl_nv_depth_clamp;
  GLuint gl_nv_depth_nonlinear;
  GLuint gl_nv_depth_range_unclamped;
  GLuint gl_nv_draw_buffers;
  GLuint gl_nv_draw_texture;
  GLuint gl_nv_evaluators;
  GLuint gl_nv_explicit_multisample;
  GLuint gl_nv_fbo_color_attachments;
  GLuint gl_nv_fence;
  GLuint gl_nv_float_buffer;
  GLuint gl_nv_fog_distance;
  GLuint gl_nv_fragment_program;
  GLuint gl_nv_fragment_program2;
  GLuint gl_nv_framebuffer_blit;
  GLuint gl_nv_framebuffer_multisample;
  GLuint gl_nv_framebuffer_multisample_coverage;
  GLuint gl_nv_geometry_program4;
  GLuint gl_nv_gpu_program4;
  GLuint gl_nv_gpu_program5;
  GLuint gl_nv_gpu_shader5;
  GLuint gl_nv_half_float;
  GLuint gl_nv_instanced_arrays;
  GLuint gl_nv_light_max_exponent;
  GLuint gl_nv_multisample_coverage;
  GLuint gl_nv_multisample_filter_hint;
  GLuint gl_nv_non_square_matrices;
  GLuint gl_nv_occlusion_query;
  GLuint gl_nv_pack_subimage;
  GLuint gl_nv_packed_depth_stencil;
  GLuint gl_nv_packed_float_linear;
  GLuint gl_nv_parameter_buffer_object;
  GLuint gl_nv_path_rendering;
  GLuint gl_nv_pixel_buffer_object;
  GLuint gl_nv_pixel_data_range;
  GLuint gl_nv_platform_binary;
  GLuint gl_nv_point_sprite;
  GLuint gl_nv_present_video;
  GLuint gl_nv_primitive_restart;
  GLuint gl_nv_read_buffer;
  GLuint gl_nv_read_buffer_front;
  GLuint gl_nv_register_combiners;
  GLuint gl_nv_register_combiners2;
  GLuint gl_nv_srgb_formats;
  GLuint gl_nv_shader_buffer_load;
  GLuint gl_nv_shadow_samplers_array;
  GLuint gl_nv_shadow_samplers_cube;
  GLuint gl_nv_tessellation_program5;
  GLuint gl_nv_texgen_emboss;
  GLuint gl_nv_texgen_reflection;
  GLuint gl_nv_texture_array;
  GLuint gl_nv_texture_barrier;
  GLuint gl_nv_texture_border_clamp;
  GLuint gl_nv_texture_compression_latc;
  GLuint gl_nv_texture_compression_s3tc;
  GLuint gl_nv_texture_env_combine4;
  GLuint gl_nv_texture_expand_normal;
  GLuint gl_nv_texture_multisample;
  GLuint gl_nv_texture_rectangle;
  GLuint gl_nv_texture_shader;
  GLuint gl_nv_texture_shader2;
  GLuint gl_nv_texture_shader3;
  GLuint gl_nv_transform_feedback;
  GLuint gl_nv_transform_feedback2;
  GLuint gl_nv_vdpau_interop;
  GLuint gl_nv_vertex_array_range;
  GLuint gl_nv_vertex_array_range2;
  GLuint gl_nv_vertex_attrib_integer_64bit;
  GLuint gl_nv_vertex_buffer_unified_memory;
  GLuint gl_nv_vertex_program;
  GLuint gl_nv_vertex_program2_option;
  GLuint gl_nv_vertex_program3;
  GLuint gl_nv_vertex_program4;
  GLuint gl_nv_video_capture;
  GLuint gl_oes_egl_image_external;
  GLuint gl_oes_blend_equation_separate;
  GLuint gl_oes_blend_func_separate;
  GLuint gl_oes_blend_subtract;
  GLuint gl_oes_compressed_etc1_rgb8_texture;
  GLuint gl_oes_compressed_paletted_texture;
  GLuint gl_oes_depth_texture;
  GLuint gl_oes_draw_texture;
  GLuint gl_oes_element_index_uint;
  GLuint gl_oes_fbo_render_mipmap;
  GLuint gl_oes_framebuffer_object;
  GLuint gl_oes_get_program_binary;
  GLuint gl_oes_mapbuffer;
  GLuint gl_oes_matrix_get;
  GLuint gl_oes_matrix_palette;
  GLuint gl_oes_packed_depth_stencil;
  GLuint gl_oes_point_size_array;
  GLuint gl_oes_point_sprite;
  GLuint gl_oes_read_format;
  GLuint gl_oes_required_internalformat;
  GLuint gl_oes_rgb8_rgba8;
  GLuint gl_oes_single_precision;
  GLuint gl_oes_standard_derivatives;
  GLuint gl_oes_stencil1;
  GLuint gl_oes_stencil4;
  GLuint gl_oes_stencil8;
  GLuint gl_oes_surfaceless_context;
  GLuint gl_oes_texture_3d;
  GLuint gl_oes_texture_cube_map;
  GLuint gl_oes_texture_mirrored_repeat;
  GLuint gl_oes_vertex_array_object;
  GLuint gl_oes_vertex_half_float;
  GLuint gl_oes_vertex_type_10_10_10_2;
  GLuint gl_oml_interlace;
  GLuint gl_oml_resample;
  GLuint gl_oml_subsample;
  GLuint gl_pgi_misc_hints;
  GLuint gl_pgi_vertex_hints;
  GLuint gl_qcom_alpha_test;
  GLuint gl_qcom_binning_control;
  GLuint gl_qcom_driver_control;
  GLuint gl_qcom_extended_get;
  GLuint gl_qcom_extended_get2;
  GLuint gl_qcom_perfmon_global_mode;
  GLuint gl_qcom_tiled_rendering;
  GLuint gl_qcom_writeonly_rendering;
  GLuint gl_regal_es1_0_compatibility;
  GLuint gl_regal_es1_1_compatibility;
  GLuint gl_regal_enable;
  GLuint gl_regal_error_string;
  GLuint gl_regal_extension_query;
  GLuint gl_regal_log;
  GLuint gl_regal_proc_address;
  GLuint gl_rend_screen_coordinates;
  GLuint gl_s3_s3tc;
  GLuint gl_sgis_color_range;
  GLuint gl_sgis_detail_texture;
  GLuint gl_sgis_fog_function;
  GLuint gl_sgis_generate_mipmap;
  GLuint gl_sgis_multisample;
  GLuint gl_sgis_pixel_texture;
  GLuint gl_sgis_point_line_texgen;
  GLuint gl_sgis_point_parameters;
  GLuint gl_sgis_sharpen_texture;
  GLuint gl_sgis_texture4d;
  GLuint gl_sgis_texture_border_clamp;
  GLuint gl_sgis_texture_color_mask;
  GLuint gl_sgis_texture_edge_clamp;
  GLuint gl_sgis_texture_filter4;
  GLuint gl_sgis_texture_lod;
  GLuint gl_sgix_async;
  GLuint gl_sgix_async_histogram;
  GLuint gl_sgix_async_pixel;
  GLuint gl_sgix_blend_alpha_minmax;
  GLuint gl_sgix_convolution_accuracy;
  GLuint gl_sgix_depth_texture;
  GLuint gl_sgix_flush_raster;
  GLuint gl_sgix_fog_offset;
  GLuint gl_sgix_fog_texture;
  GLuint gl_sgix_fragment_lighting;
  GLuint gl_sgix_fragment_specular_lighting;
  GLuint gl_sgix_framezoom;
  GLuint gl_sgix_igloo_interface;
  GLuint gl_sgix_instruments;
  GLuint gl_sgix_interlace;
  GLuint gl_sgix_list_priority;
  GLuint gl_sgix_pixel_texture;
  GLuint gl_sgix_polynomial_ffd;
  GLuint gl_sgix_reference_plane;
  GLuint gl_sgix_resample;
  GLuint gl_sgix_shadow;
  GLuint gl_sgix_shadow_ambient;
  GLuint gl_sgix_sprite;
  GLuint gl_sgix_tag_sample_buffer;
  GLuint gl_sgix_texture_coordinate_clamp;
  GLuint gl_sgix_texture_multi_buffer;
  GLuint gl_sgix_texture_range;
  GLuint gl_sgix_texture_scale_bias;
  GLuint gl_sgix_vertex_preclip_hint;
  GLuint gl_sgix_ycrcb;
  GLuint gl_sgi_color_matrix;
  GLuint gl_sgi_color_table;
  GLuint gl_sgi_texture_color_table;
  GLuint gl_sunx_constant_data;
  GLuint gl_sun_convolution_border_modes;
  GLuint gl_sun_global_alpha;
  GLuint gl_sun_mesh_array;
  GLuint gl_sun_read_video_pixels;
  GLuint gl_sun_slice_accum;
  GLuint gl_sun_triangle_list;
  GLuint gl_sun_vertex;
  GLuint gl_viv_shader_binary;
  GLuint gl_win_phong_shading;
  GLuint gl_win_specular_fog;
  GLuint gl_win_swap_hint;

#if REGAL_SYS_WGL
  GLuint wgl_3dl_stereo_control;
  GLuint wgl_amd_gpu_association;
  GLuint wgl_arb_buffer_region;
  GLuint wgl_arb_create_context;
  GLuint wgl_arb_create_context_profile;
  GLuint wgl_arb_create_context_robustness;
  GLuint wgl_arb_extensions_string;
  GLuint wgl_arb_framebuffer_srgb;
  GLuint wgl_arb_make_current_read;
  GLuint wgl_arb_multisample;
  GLuint wgl_arb_pbuffer;
  GLuint wgl_arb_pixel_format;
  GLuint wgl_arb_pixel_format_float;
  GLuint wgl_arb_render_texture;
  GLuint wgl_arb_robustness_share_group_isolation;
  GLuint wgl_ati_pixel_format_float;
  GLuint wgl_ati_render_texture_rectangle;
  GLuint wgl_ext_create_context_es2_profile;
  GLuint wgl_ext_create_context_es_profile;
  GLuint wgl_ext_depth_float;
  GLuint wgl_ext_display_color_table;
  GLuint wgl_ext_extensions_string;
  GLuint wgl_ext_framebuffer_srgb;
  GLuint wgl_ext_make_current_read;
  GLuint wgl_ext_multisample;
  GLuint wgl_ext_pbuffer;
  GLuint wgl_ext_pixel_format;
  GLuint wgl_ext_pixel_format_packed_float;
  GLuint wgl_ext_swap_control;
  GLuint wgl_gdi;
  GLuint wgl_i3d_digital_video_control;
  GLuint wgl_i3d_gamma;
  GLuint wgl_i3d_genlock;
  GLuint wgl_i3d_image_buffer;
  GLuint wgl_i3d_swap_frame_lock;
  GLuint wgl_i3d_swap_frame_usage;
  GLuint wgl_nv_dx_interop;
  GLuint wgl_nv_copy_image;
  GLuint wgl_nv_float_buffer;
  GLuint wgl_nv_gpu_affinity;
  GLuint wgl_nv_multisample_coverage;
  GLuint wgl_nv_present_video;
  GLuint wgl_nv_render_depth_texture;
  GLuint wgl_nv_render_texture_rectangle;
  GLuint wgl_nv_swap_group;
  GLuint wgl_nv_vertex_array_range;
  GLuint wgl_nv_video_capture;
  GLuint wgl_nv_video_output;
  GLuint wgl_oml_sync_control;
#endif

#if REGAL_SYS_GLX
  GLuint glx_3dfx_multisample;
  GLuint glx_amd_gpu_association;
  GLuint glx_arb_create_context;
  GLuint glx_arb_create_context_profile;
  GLuint glx_arb_create_context_robustness;
  GLuint glx_arb_fbconfig_float;
  GLuint glx_arb_framebuffer_srgb;
  GLuint glx_arb_get_proc_address;
  GLuint glx_arb_multisample;
  GLuint glx_arb_robustness_share_group_isolation;
  GLuint glx_arb_vertex_buffer_object;
  GLuint glx_ati_pixel_format_float;
  GLuint glx_ati_render_texture;
  GLuint glx_ext_create_context_es2_profile;
  GLuint glx_ext_create_context_es_profile;
  GLuint glx_ext_fbconfig_packed_float;
  GLuint glx_ext_framebuffer_srgb;
  GLuint glx_ext_import_context;
  GLuint glx_ext_swap_control;
  GLuint glx_ext_swap_control_tear;
  GLuint glx_ext_texture_from_pixmap;
  GLuint glx_ext_visual_info;
  GLuint glx_ext_visual_rating;
  GLuint glx_intel_swap_event;
  GLuint glx_mesa_agp_offset;
  GLuint glx_mesa_copy_sub_buffer;
  GLuint glx_mesa_pixmap_colormap;
  GLuint glx_mesa_release_buffers;
  GLuint glx_mesa_set_3dfx_mode;
  GLuint glx_mesa_swap_control;
  GLuint glx_nv_copy_image;
  GLuint glx_nv_float_buffer;
  GLuint glx_nv_multisample_coverage;
  GLuint glx_nv_present_video;
  GLuint glx_nv_swap_group;
  GLuint glx_nv_vertex_array_range;
  GLuint glx_nv_video_capture;
  GLuint glx_nv_video_output;
  GLuint glx_oml_swap_method;
  GLuint glx_oml_sync_control;
  GLuint glx_sgis_blended_overlay;
  GLuint glx_sgis_color_range;
  GLuint glx_sgis_multisample;
  GLuint glx_sgis_shared_multisample;
  GLuint glx_sgix_fbconfig;
  GLuint glx_sgix_hyperpipe;
  GLuint glx_sgix_pbuffer;
  GLuint glx_sgix_swap_barrier;
  GLuint glx_sgix_swap_group;
  GLuint glx_sgix_video_resize;
  GLuint glx_sgix_visual_select_group;
  GLuint glx_sgi_cushion;
  GLuint glx_sgi_make_current_read;
  GLuint glx_sgi_swap_control;
  GLuint glx_sgi_video_sync;
  GLuint glx_sun_get_transparent_index;
  GLuint glx_sun_video_resize;
#endif

#if REGAL_SYS_EGL
  GLuint egl_angle_query_surface_pointer;
  GLuint egl_angle_surface_d3d_texture_2d_share_handle;
  GLuint egl_ext_create_context_robustness;
  GLuint egl_ext_multiview_window;
  GLuint egl_hi_colorformats;
  GLuint egl_img_context_priority;
  GLuint egl_khr_config_attribs;
  GLuint egl_khr_create_context;
  GLuint egl_khr_fence_sync;
  GLuint egl_khr_gl_texture_cubemap_image;
  GLuint egl_khr_image_base;
  GLuint egl_khr_image_pixmap;
  GLuint egl_khr_lock_surface;
  GLuint egl_khr_lock_surface2;
  GLuint egl_khr_reusable_sync;
  GLuint egl_khr_stream;
  GLuint egl_khr_stream_consumer_gltexture;
  GLuint egl_khr_stream_cross_process_fd;
  GLuint egl_khr_stream_fifo;
  GLuint egl_khr_stream_producer_eglsurface;
  GLuint egl_khr_vg_parent_image;
  GLuint egl_khr_wait_sync;
  GLuint egl_mesa_drm_image;
  GLuint egl_nv_coverage_sample;
  GLuint egl_nv_coverage_sample_resolve;
  GLuint egl_nv_post_sub_buffer;
  GLuint egl_nv_sync;
  GLuint egl_nv_system_time;
#endif

  /* GL_VERSION_1_0 */

  GLuint glAccum;
  GLuint glAlphaFunc;
  GLuint glBegin;
  GLuint glBitmap;
  GLuint glBlendFunc;
  GLuint glCallList;
  GLuint glCallLists;
  GLuint glClear;
  GLuint glClearAccum;
  GLuint glClearColor;
  GLuint glClearDepth;
  GLuint glClearIndex;
  GLuint glClearStencil;
  GLuint glClipPlane;
  GLuint glColor3b;
  GLuint glColor3bv;
  GLuint glColor3d;
  GLuint glColor3dv;
  GLuint glColor3f;
  GLuint glColor3fv;
  GLuint glColor3i;
  GLuint glColor3iv;
  GLuint glColor3s;
  GLuint glColor3sv;
  GLuint glColor3ub;
  GLuint glColor3ubv;
  GLuint glColor3ui;
  GLuint glColor3uiv;
  GLuint glColor3us;
  GLuint glColor3usv;
  GLuint glColor4b;
  GLuint glColor4bv;
  GLuint glColor4d;
  GLuint glColor4dv;
  GLuint glColor4f;
  GLuint glColor4fv;
  GLuint glColor4i;
  GLuint glColor4iv;
  GLuint glColor4s;
  GLuint glColor4sv;
  GLuint glColor4ub;
  GLuint glColor4ubv;
  GLuint glColor4ui;
  GLuint glColor4uiv;
  GLuint glColor4us;
  GLuint glColor4usv;
  GLuint glColorMask;
  GLuint glColorMaterial;
  GLuint glCopyPixels;
  GLuint glCullFace;
  GLuint glDeleteLists;
  GLuint glDepthFunc;
  GLuint glDepthMask;
  GLuint glDepthRange;
  GLuint glDisable;
  GLuint glDrawBuffer;
  GLuint glDrawPixels;
  GLuint glEdgeFlag;
  GLuint glEdgeFlagv;
  GLuint glEnable;
  GLuint glEnd;
  GLuint glEndList;
  GLuint glEvalCoord1d;
  GLuint glEvalCoord1dv;
  GLuint glEvalCoord1f;
  GLuint glEvalCoord1fv;
  GLuint glEvalCoord2d;
  GLuint glEvalCoord2dv;
  GLuint glEvalCoord2f;
  GLuint glEvalCoord2fv;
  GLuint glEvalMesh1;
  GLuint glEvalMesh2;
  GLuint glEvalPoint1;
  GLuint glEvalPoint2;
  GLuint glFeedbackBuffer;
  GLuint glFinish;
  GLuint glFlush;
  GLuint glFogf;
  GLuint glFogfv;
  GLuint glFogi;
  GLuint glFogiv;
  GLuint glFrontFace;
  GLuint glFrustum;
  GLuint glGenLists;
  GLuint glGetBooleanv;
  GLuint glGetClipPlane;
  GLuint glGetDoublev;
  GLuint glGetError;
  GLuint glGetFloatv;
  GLuint glGetIntegerv;
  GLuint glGetLightfv;
  GLuint glGetLightiv;
  GLuint glGetMapdv;
  GLuint glGetMapfv;
  GLuint glGetMapiv;
  GLuint glGetMaterialfv;
  GLuint glGetMaterialiv;
  GLuint glGetPixelMapfv;
  GLuint glGetPixelMapuiv;
  GLuint glGetPixelMapusv;
  GLuint glGetPolygonStipple;
  GLuint glGetString;
  GLuint glGetTexEnvfv;
  GLuint glGetTexEnviv;
  GLuint glGetTexGendv;
  GLuint glGetTexGenfv;
  GLuint glGetTexGeniv;
  GLuint glGetTexImage;
  GLuint glGetTexLevelParameterfv;
  GLuint glGetTexLevelParameteriv;
  GLuint glGetTexParameterfv;
  GLuint glGetTexParameteriv;
  GLuint glHint;
  GLuint glIndexMask;
  GLuint glIndexd;
  GLuint glIndexdv;
  GLuint glIndexf;
  GLuint glIndexfv;
  GLuint glIndexi;
  GLuint glIndexiv;
  GLuint glIndexs;
  GLuint glIndexsv;
  GLuint glInitNames;
  GLuint glIsEnabled;
  GLuint glIsList;
  GLuint glLightModelf;
  GLuint glLightModelfv;
  GLuint glLightModeli;
  GLuint glLightModeliv;
  GLuint glLightf;
  GLuint glLightfv;
  GLuint glLighti;
  GLuint glLightiv;
  GLuint glLineStipple;
  GLuint glLineWidth;
  GLuint glListBase;
  GLuint glLoadIdentity;
  GLuint glLoadMatrixd;
  GLuint glLoadMatrixf;
  GLuint glLoadName;
  GLuint glLogicOp;
  GLuint glMap1d;
  GLuint glMap1f;
  GLuint glMap2d;
  GLuint glMap2f;
  GLuint glMapGrid1d;
  GLuint glMapGrid1f;
  GLuint glMapGrid2d;
  GLuint glMapGrid2f;
  GLuint glMaterialf;
  GLuint glMaterialfv;
  GLuint glMateriali;
  GLuint glMaterialiv;
  GLuint glMatrixMode;
  GLuint glMultMatrixd;
  GLuint glMultMatrixf;
  GLuint glNewList;
  GLuint glNormal3b;
  GLuint glNormal3bv;
  GLuint glNormal3d;
  GLuint glNormal3dv;
  GLuint glNormal3f;
  GLuint glNormal3fv;
  GLuint glNormal3i;
  GLuint glNormal3iv;
  GLuint glNormal3s;
  GLuint glNormal3sv;
  GLuint glOrtho;
  GLuint glPassThrough;
  GLuint glPixelMapfv;
  GLuint glPixelMapuiv;
  GLuint glPixelMapusv;
  GLuint glPixelStoref;
  GLuint glPixelStorei;
  GLuint glPixelTransferf;
  GLuint glPixelTransferi;
  GLuint glPixelZoom;
  GLuint glPointSize;
  GLuint glPolygonMode;
  GLuint glPolygonStipple;
  GLuint glPopAttrib;
  GLuint glPopMatrix;
  GLuint glPopName;
  GLuint glPushAttrib;
  GLuint glPushMatrix;
  GLuint glPushName;
  GLuint glRasterPos2d;
  GLuint glRasterPos2dv;
  GLuint glRasterPos2f;
  GLuint glRasterPos2fv;
  GLuint glRasterPos2i;
  GLuint glRasterPos2iv;
  GLuint glRasterPos2s;
  GLuint glRasterPos2sv;
  GLuint glRasterPos3d;
  GLuint glRasterPos3dv;
  GLuint glRasterPos3f;
  GLuint glRasterPos3fv;
  GLuint glRasterPos3i;
  GLuint glRasterPos3iv;
  GLuint glRasterPos3s;
  GLuint glRasterPos3sv;
  GLuint glRasterPos4d;
  GLuint glRasterPos4dv;
  GLuint glRasterPos4f;
  GLuint glRasterPos4fv;
  GLuint glRasterPos4i;
  GLuint glRasterPos4iv;
  GLuint glRasterPos4s;
  GLuint glRasterPos4sv;
  GLuint glReadBuffer;
  GLuint glReadPixels;
  GLuint glRectd;
  GLuint glRectdv;
  GLuint glRectf;
  GLuint glRectfv;
  GLuint glRecti;
  GLuint glRectiv;
  GLuint glRects;
  GLuint glRectsv;
  GLuint glRenderMode;
  GLuint glRotated;
  GLuint glRotatef;
  GLuint glScaled;
  GLuint glScalef;
  GLuint glScissor;
  GLuint glSelectBuffer;
  GLuint glShadeModel;
  GLuint glStencilFunc;
  GLuint glStencilMask;
  GLuint glStencilOp;
  GLuint glTexCoord1d;
  GLuint glTexCoord1dv;
  GLuint glTexCoord1f;
  GLuint glTexCoord1fv;
  GLuint glTexCoord1i;
  GLuint glTexCoord1iv;
  GLuint glTexCoord1s;
  GLuint glTexCoord1sv;
  GLuint glTexCoord2d;
  GLuint glTexCoord2dv;
  GLuint glTexCoord2f;
  GLuint glTexCoord2fv;
  GLuint glTexCoord2i;
  GLuint glTexCoord2iv;
  GLuint glTexCoord2s;
  GLuint glTexCoord2sv;
  GLuint glTexCoord3d;
  GLuint glTexCoord3dv;
  GLuint glTexCoord3f;
  GLuint glTexCoord3fv;
  GLuint glTexCoord3i;
  GLuint glTexCoord3iv;
  GLuint glTexCoord3s;
  GLuint glTexCoord3sv;
  GLuint glTexCoord4d;
  GLuint glTexCoord4dv;
  GLuint glTexCoord4f;
  GLuint glTexCoord4fv;
  GLuint glTexCoord4i;
  GLuint glTexCoord4iv;
  GLuint glTexCoord4s;
  GLuint glTexCoord4sv;
  GLuint glTexEnvf;
  GLuint glTexEnvfv;
  GLuint glTexEnvi;
  GLuint glTexEnviv;
  GLuint glTexGend;
  GLuint glTexGendv;
  GLuint glTexGenf;
  GLuint glTexGenfv;
  GLuint glTexGeni;
  GLuint glTexGeniv;
  GLuint glTexImage1D;
  GLuint glTexImage2D;
  GLuint glTexParameterf;
  GLuint glTexParameterfv;
  GLuint glTexParameteri;
  GLuint glTexParameteriv;
  GLuint glTranslated;
  GLuint glTranslatef;
  GLuint glVertex2d;
  GLuint glVertex2dv;
  GLuint glVertex2f;
  GLuint glVertex2fv;
  GLuint glVertex2i;
  GLuint glVertex2iv;
  GLuint glVertex2s;
  GLuint glVertex2sv;
  GLuint glVertex3d;
  GLuint glVertex3dv;
  GLuint glVertex3f;
  GLuint glVertex3fv;
  GLuint glVertex3i;
  GLuint glVertex3iv;
  GLuint glVertex3s;
  GLuint glVertex3sv;
  GLuint glVertex4d;
  GLuint glVertex4dv;
  GLuint glVertex4f;
  GLuint glVertex4fv;
  GLuint glVertex4i;
  GLuint glVertex4iv;
  GLuint glVertex4s;
  GLuint glVertex4sv;
  GLuint glViewport;

  /* GL_VERSION_1_1 */

  GLuint glAreTexturesResident;
  GLuint glArrayElement;
  GLuint glBindTexture;
  GLuint glColorPointer;
  GLuint glCopyTexImage1D;
  GLuint glCopyTexImage2D;
  GLuint glCopyTexSubImage1D;
  GLuint glCopyTexSubImage2D;
  GLuint glDeleteTextures;
  GLuint glDisableClientState;
  GLuint glDrawArrays;
  GLuint glDrawElements;
  GLuint glEdgeFlagPointer;
  GLuint glEnableClientState;
  GLuint glGenTextures;
  GLuint glGetPointerv;
  GLuint glIndexPointer;
  GLuint glIndexub;
  GLuint glIndexubv;
  GLuint glInterleavedArrays;
  GLuint glIsTexture;
  GLuint glNormalPointer;
  GLuint glPolygonOffset;
  GLuint glPopClientAttrib;
  GLuint glPrioritizeTextures;
  GLuint glPushClientAttrib;
  GLuint glTexCoordPointer;
  GLuint glTexSubImage1D;
  GLuint glTexSubImage2D;
  GLuint glVertexPointer;

  /* GL_VERSION_1_2 */

  GLuint glBlendColor;
  GLuint glBlendEquation;
  GLuint glCopyTexSubImage3D;
  GLuint glDrawRangeElements;
  GLuint glTexImage3D;
  GLuint glTexSubImage3D;

  /* GL_VERSION_1_3 */

  GLuint glActiveTexture;
  GLuint glClientActiveTexture;
  GLuint glCompressedTexImage1D;
  GLuint glCompressedTexImage2D;
  GLuint glCompressedTexImage3D;
  GLuint glCompressedTexSubImage1D;
  GLuint glCompressedTexSubImage2D;
  GLuint glCompressedTexSubImage3D;
  GLuint glGetCompressedTexImage;
  GLuint glLoadTransposeMatrixd;
  GLuint glLoadTransposeMatrixf;
  GLuint glMultTransposeMatrixd;
  GLuint glMultTransposeMatrixf;
  GLuint glMultiTexCoord1d;
  GLuint glMultiTexCoord1dv;
  GLuint glMultiTexCoord1f;
  GLuint glMultiTexCoord1fv;
  GLuint glMultiTexCoord1i;
  GLuint glMultiTexCoord1iv;
  GLuint glMultiTexCoord1s;
  GLuint glMultiTexCoord1sv;
  GLuint glMultiTexCoord2d;
  GLuint glMultiTexCoord2dv;
  GLuint glMultiTexCoord2f;
  GLuint glMultiTexCoord2fv;
  GLuint glMultiTexCoord2i;
  GLuint glMultiTexCoord2iv;
  GLuint glMultiTexCoord2s;
  GLuint glMultiTexCoord2sv;
  GLuint glMultiTexCoord3d;
  GLuint glMultiTexCoord3dv;
  GLuint glMultiTexCoord3f;
  GLuint glMultiTexCoord3fv;
  GLuint glMultiTexCoord3i;
  GLuint glMultiTexCoord3iv;
  GLuint glMultiTexCoord3s;
  GLuint glMultiTexCoord3sv;
  GLuint glMultiTexCoord4d;
  GLuint glMultiTexCoord4dv;
  GLuint glMultiTexCoord4f;
  GLuint glMultiTexCoord4fv;
  GLuint glMultiTexCoord4i;
  GLuint glMultiTexCoord4iv;
  GLuint glMultiTexCoord4s;
  GLuint glMultiTexCoord4sv;
  GLuint glSampleCoverage;

  /* GL_VERSION_1_4 */

  GLuint glBlendFuncSeparate;
  GLuint glFogCoordPointer;
  GLuint glFogCoordd;
  GLuint glFogCoorddv;
  GLuint glFogCoordf;
  GLuint glFogCoordfv;
  GLuint glMultiDrawArrays;
  GLuint glMultiDrawElements;
  GLuint glPointParameterf;
  GLuint glPointParameterfv;
  GLuint glPointParameteri;
  GLuint glPointParameteriv;
  GLuint glSecondaryColor3b;
  GLuint glSecondaryColor3bv;
  GLuint glSecondaryColor3d;
  GLuint glSecondaryColor3dv;
  GLuint glSecondaryColor3f;
  GLuint glSecondaryColor3fv;
  GLuint glSecondaryColor3i;
  GLuint glSecondaryColor3iv;
  GLuint glSecondaryColor3s;
  GLuint glSecondaryColor3sv;
  GLuint glSecondaryColor3ub;
  GLuint glSecondaryColor3ubv;
  GLuint glSecondaryColor3ui;
  GLuint glSecondaryColor3uiv;
  GLuint glSecondaryColor3us;
  GLuint glSecondaryColor3usv;
  GLuint glSecondaryColorPointer;
  GLuint glWindowPos2d;
  GLuint glWindowPos2dv;
  GLuint glWindowPos2f;
  GLuint glWindowPos2fv;
  GLuint glWindowPos2i;
  GLuint glWindowPos2iv;
  GLuint glWindowPos2s;
  GLuint glWindowPos2sv;
  GLuint glWindowPos3d;
  GLuint glWindowPos3dv;
  GLuint glWindowPos3f;
  GLuint glWindowPos3fv;
  GLuint glWindowPos3i;
  GLuint glWindowPos3iv;
  GLuint glWindowPos3s;
  GLuint glWindowPos3sv;

  /* GL_VERSION_1_5 */

  GLuint glBeginQuery;
  GLuint glBindBuffer;
  GLuint glBufferData;
  GLuint glBufferSubData;
  GLuint glDeleteBuffers;
  GLuint glDeleteQueries;
  GLuint glEndQuery;
  GLuint glGenBuffers;
  GLuint glGenQueries;
  GLuint glGetBufferParameteriv;
  GLuint glGetBufferPointerv;
  GLuint glGetBufferSubData;
  GLuint glGetQueryObjectiv;
  GLuint glGetQueryObjectuiv;
  GLuint glGetQueryiv;
  GLuint glIsBuffer;
  GLuint glIsQuery;
  GLuint glMapBuffer;
  GLuint glUnmapBuffer;

  /* GL_VERSION_2_0 */

  GLuint glAttachShader;
  GLuint glBindAttribLocation;
  GLuint glBlendEquationSeparate;
  GLuint glCompileShader;
  GLuint glCreateProgram;
  GLuint glCreateShader;
  GLuint glDeleteProgram;
  GLuint glDeleteShader;
  GLuint glDetachShader;
  GLuint glDisableVertexAttribArray;
  GLuint glDrawBuffers;
  GLuint glEnableVertexAttribArray;
  GLuint glGetActiveAttrib;
  GLuint glGetActiveUniform;
  GLuint glGetAttachedShaders;
  GLuint glGetAttribLocation;
  GLuint glGetProgramInfoLog;
  GLuint glGetProgramiv;
  GLuint glGetShaderInfoLog;
  GLuint glGetShaderSource;
  GLuint glGetShaderiv;
  GLuint glGetUniformLocation;
  GLuint glGetUniformfv;
  GLuint glGetUniformiv;
  GLuint glGetVertexAttribPointerv;
  GLuint glGetVertexAttribdv;
  GLuint glGetVertexAttribfv;
  GLuint glGetVertexAttribiv;
  GLuint glIsProgram;
  GLuint glIsShader;
  GLuint glLinkProgram;
  GLuint glShaderSource;
  GLuint glStencilFuncSeparate;
  GLuint glStencilMaskSeparate;
  GLuint glStencilOpSeparate;
  GLuint glUniform1f;
  GLuint glUniform1fv;
  GLuint glUniform1i;
  GLuint glUniform1iv;
  GLuint glUniform2f;
  GLuint glUniform2fv;
  GLuint glUniform2i;
  GLuint glUniform2iv;
  GLuint glUniform3f;
  GLuint glUniform3fv;
  GLuint glUniform3i;
  GLuint glUniform3iv;
  GLuint glUniform4f;
  GLuint glUniform4fv;
  GLuint glUniform4i;
  GLuint glUniform4iv;
  GLuint glUniformMatrix2fv;
  GLuint glUniformMatrix3fv;
  GLuint glUniformMatrix4fv;
  GLuint glUseProgram;
  GLuint glValidateProgram;
  GLuint glVertexAttrib1d;
  GLuint glVertexAttrib1dv;
  GLuint glVertexAttrib1f;
  GLuint glVertexAttrib1fv;
  GLuint glVertexAttrib1s;
  GLuint glVertexAttrib1sv;
  GLuint glVertexAttrib2d;
  GLuint glVertexAttrib2dv;
  GLuint glVertexAttrib2f;
  GLuint glVertexAttrib2fv;
  GLuint glVertexAttrib2s;
  GLuint glVertexAttrib2sv;
  GLuint glVertexAttrib3d;
  GLuint glVertexAttrib3dv;
  GLuint glVertexAttrib3f;
  GLuint glVertexAttrib3fv;
  GLuint glVertexAttrib3s;
  GLuint glVertexAttrib3sv;
  GLuint glVertexAttrib4Nbv;
  GLuint glVertexAttrib4Niv;
  GLuint glVertexAttrib4Nsv;
  GLuint glVertexAttrib4Nub;
  GLuint glVertexAttrib4Nubv;
  GLuint glVertexAttrib4Nuiv;
  GLuint glVertexAttrib4Nusv;
  GLuint glVertexAttrib4bv;
  GLuint glVertexAttrib4d;
  GLuint glVertexAttrib4dv;
  GLuint glVertexAttrib4f;
  GLuint glVertexAttrib4fv;
  GLuint glVertexAttrib4iv;
  GLuint glVertexAttrib4s;
  GLuint glVertexAttrib4sv;
  GLuint glVertexAttrib4ubv;
  GLuint glVertexAttrib4uiv;
  GLuint glVertexAttrib4usv;
  GLuint glVertexAttribPointer;

  /* GL_VERSION_2_1 */

  GLuint glUniformMatrix2x3fv;
  GLuint glUniformMatrix2x4fv;
  GLuint glUniformMatrix3x2fv;
  GLuint glUniformMatrix3x4fv;
  GLuint glUniformMatrix4x2fv;
  GLuint glUniformMatrix4x3fv;

  /* GL_VERSION_3_0 */

  GLuint glBeginConditionalRender;
  GLuint glBeginTransformFeedback;
  GLuint glBindFragDataLocation;
  GLuint glClampColor;
  GLuint glClearBufferfi;
  GLuint glClearBufferfv;
  GLuint glClearBufferiv;
  GLuint glClearBufferuiv;
  GLuint glColorMaski;
  GLuint glDisablei;
  GLuint glEnablei;
  GLuint glEndConditionalRender;
  GLuint glEndTransformFeedback;
  GLuint glGetBooleani_v;
  GLuint glGetFragDataLocation;
  GLuint glGetStringi;
  GLuint glGetTexParameterIiv;
  GLuint glGetTexParameterIuiv;
  GLuint glGetTransformFeedbackVarying;
  GLuint glGetUniformuiv;
  GLuint glGetVertexAttribIiv;
  GLuint glGetVertexAttribIuiv;
  GLuint glIsEnabledi;
  GLuint glTexParameterIiv;
  GLuint glTexParameterIuiv;
  GLuint glTransformFeedbackVaryings;
  GLuint glUniform1ui;
  GLuint glUniform1uiv;
  GLuint glUniform2ui;
  GLuint glUniform2uiv;
  GLuint glUniform3ui;
  GLuint glUniform3uiv;
  GLuint glUniform4ui;
  GLuint glUniform4uiv;
  GLuint glVertexAttribI1i;
  GLuint glVertexAttribI1iv;
  GLuint glVertexAttribI1ui;
  GLuint glVertexAttribI1uiv;
  GLuint glVertexAttribI2i;
  GLuint glVertexAttribI2iv;
  GLuint glVertexAttribI2ui;
  GLuint glVertexAttribI2uiv;
  GLuint glVertexAttribI3i;
  GLuint glVertexAttribI3iv;
  GLuint glVertexAttribI3ui;
  GLuint glVertexAttribI3uiv;
  GLuint glVertexAttribI4bv;
  GLuint glVertexAttribI4i;
  GLuint glVertexAttribI4iv;
  GLuint glVertexAttribI4sv;
  GLuint glVertexAttribI4ubv;
  GLuint glVertexAttribI4ui;
  GLuint glVertexAttribI4uiv;
  GLuint glVertexAttribI4usv;
  GLuint glVertexAttribIPointer;

  /* GL_VERSION_3_1 */

  GLuint glDrawArraysInstanced;
  GLuint glDrawElementsInstanced;
  GLuint glPrimitiveRestartIndex;
  GLuint glTexBuffer;

  /* GL_VERSION_3_2 */

  GLuint glFramebufferTexture;
  GLuint glGetBufferParameteri64v;
  GLuint glGetInteger64i_v;

  /* GL_VERSION_3_3 */

  GLuint glVertexAttribDivisor;

  /* GL_VERSION_4_0 */

  GLuint glBlendEquationSeparatei;
  GLuint glBlendEquationi;
  GLuint glBlendFuncSeparatei;
  GLuint glBlendFunci;

  /* GL_3DFX_tbuffer */

  GLuint glTbufferMask3DFX;

  /* GL_AMD_debug_output */

  GLuint glDebugMessageCallbackAMD;
  GLuint glDebugMessageEnableAMD;
  GLuint glDebugMessageInsertAMD;
  GLuint glGetDebugMessageLogAMD;

  /* GL_AMD_draw_buffers_blend */

  GLuint glBlendEquationIndexedAMD;
  GLuint glBlendEquationSeparateIndexedAMD;
  GLuint glBlendFuncIndexedAMD;
  GLuint glBlendFuncSeparateIndexedAMD;

  /* GL_AMD_interleaved_elements */

  GLuint glVertexAttribParameteriAMD;

  /* GL_AMD_multi_draw_indirect */

  GLuint glMultiDrawArraysIndirectAMD;
  GLuint glMultiDrawElementsIndirectAMD;

  /* GL_AMD_name_gen_delete */

  GLuint glDeleteNamesAMD;
  GLuint glGenNamesAMD;
  GLuint glIsNameAMD;

  /* GL_AMD_performance_monitor */

  GLuint glBeginPerfMonitorAMD;
  GLuint glDeletePerfMonitorsAMD;
  GLuint glEndPerfMonitorAMD;
  GLuint glGenPerfMonitorsAMD;
  GLuint glGetPerfMonitorCounterDataAMD;
  GLuint glGetPerfMonitorCounterInfoAMD;
  GLuint glGetPerfMonitorCounterStringAMD;
  GLuint glGetPerfMonitorCountersAMD;
  GLuint glGetPerfMonitorGroupStringAMD;
  GLuint glGetPerfMonitorGroupsAMD;
  GLuint glSelectPerfMonitorCountersAMD;

  /* GL_AMD_sample_positions */

  GLuint glSetMultisamplefvAMD;

  /* GL_AMD_sparse_texture */

  GLuint glTexStorageSparseAMD;
  GLuint glTextureStorageSparseAMD;

  /* GL_AMD_stencil_operation_extended */

  GLuint glStencilOpValueAMD;

  /* GL_AMD_vertex_shader_tessellator */

  GLuint glTessellationFactorAMD;
  GLuint glTessellationModeAMD;

  /* GL_ANGLE_framebuffer_blit */

  GLuint glBlitFramebufferANGLE;

  /* GL_ANGLE_framebuffer_multisample */

  GLuint glRenderbufferStorageMultisampleANGLE;

  /* GL_ANGLE_instanced_arrays */

  GLuint glDrawArraysInstancedANGLE;
  GLuint glDrawElementsInstancedANGLE;
  GLuint glVertexAttribDivisorANGLE;

  /* GL_ANGLE_timer_query */

  GLuint glBeginQueryANGLE;
  GLuint glDeleteQueriesANGLE;
  GLuint glEndQueryANGLE;
  GLuint glGenQueriesANGLE;
  GLuint glGetQueryObjecti64vANGLE;
  GLuint glGetQueryObjectivANGLE;
  GLuint glGetQueryObjectui64vANGLE;
  GLuint glGetQueryObjectuivANGLE;
  GLuint glGetQueryivANGLE;
  GLuint glIsQueryANGLE;
  GLuint glQueryCounterANGLE;

  /* GL_ANGLE_translated_shader_source */

  GLuint glGetTranslatedShaderSourceANGLE;

  /* GL_APPLE_copy_texture_levels */

  GLuint glCopyTextureLevelsAPPLE;

  /* GL_APPLE_element_array */

  GLuint glDrawElementArrayAPPLE;
  GLuint glDrawRangeElementArrayAPPLE;
  GLuint glElementPointerAPPLE;
  GLuint glMultiDrawElementArrayAPPLE;
  GLuint glMultiDrawRangeElementArrayAPPLE;

  /* GL_APPLE_fence */

  GLuint glDeleteFencesAPPLE;
  GLuint glFinishFenceAPPLE;
  GLuint glFinishObjectAPPLE;
  GLuint glGenFencesAPPLE;
  GLuint glIsFenceAPPLE;
  GLuint glSetFenceAPPLE;
  GLuint glTestFenceAPPLE;
  GLuint glTestObjectAPPLE;

  /* GL_APPLE_flush_buffer_range */

  GLuint glBufferParameteriAPPLE;
  GLuint glFlushMappedBufferRangeAPPLE;

  /* GL_APPLE_flush_render */

  GLuint glFinishRenderAPPLE;
  GLuint glFlushRenderAPPLE;
  GLuint glSwapAPPLE;

  /* GL_APPLE_framebuffer_multisample */

  GLuint glRenderbufferStorageMultisampleAPPLE;
  GLuint glResolveMultisampleFramebufferAPPLE;

  /* GL_APPLE_object_purgeable */

  GLuint glGetObjectParameterivAPPLE;
  GLuint glObjectPurgeableAPPLE;
  GLuint glObjectUnpurgeableAPPLE;

  /* GL_APPLE_sync */

  GLuint glClientWaitSyncAPPLE;
  GLuint glDeleteSyncAPPLE;
  GLuint glFenceSyncAPPLE;
  GLuint glGetInteger64vAPPLE;
  GLuint glGetSyncivAPPLE;
  GLuint glIsSyncAPPLE;
  GLuint glWaitSyncAPPLE;

  /* GL_APPLE_texture_range */

  GLuint glGetTexParameterPointervAPPLE;
  GLuint glTextureRangeAPPLE;

  /* GL_APPLE_vertex_array_object */

  GLuint glBindVertexArrayAPPLE;
  GLuint glDeleteVertexArraysAPPLE;
  GLuint glGenVertexArraysAPPLE;
  GLuint glIsVertexArrayAPPLE;

  /* GL_APPLE_vertex_array_range */

  GLuint glFlushVertexArrayRangeAPPLE;
  GLuint glVertexArrayParameteriAPPLE;
  GLuint glVertexArrayRangeAPPLE;

  /* GL_APPLE_vertex_program_evaluators */

  GLuint glDisableVertexAttribAPPLE;
  GLuint glEnableVertexAttribAPPLE;
  GLuint glIsVertexAttribEnabledAPPLE;
  GLuint glMapVertexAttrib1dAPPLE;
  GLuint glMapVertexAttrib1fAPPLE;
  GLuint glMapVertexAttrib2dAPPLE;
  GLuint glMapVertexAttrib2fAPPLE;

  /* GL_ARB_ES2_compatibility */

  GLuint glClearDepthf;
  GLuint glDepthRangef;
  GLuint glGetShaderPrecisionFormat;
  GLuint glReleaseShaderCompiler;
  GLuint glShaderBinary;

  /* GL_ARB_base_instance */

  GLuint glDrawArraysInstancedBaseInstance;
  GLuint glDrawElementsInstancedBaseInstance;
  GLuint glDrawElementsInstancedBaseVertexBaseInstance;

  /* GL_ARB_bindless_texture */

  GLuint glGetImageHandleARB;
  GLuint glGetTextureHandleARB;
  GLuint glGetTextureSamplerHandleARB;
  GLuint glGetVertexAttribLui64vARB;
  GLuint glIsImageHandleResidentARB;
  GLuint glIsTextureHandleResidentARB;
  GLuint glMakeImageHandleNonResidentARB;
  GLuint glMakeImageHandleResidentARB;
  GLuint glMakeTextureHandleNonResidentARB;
  GLuint glMakeTextureHandleResidentARB;
  GLuint glProgramUniformHandleui64ARB;
  GLuint glProgramUniformHandleui64vARB;
  GLuint glUniformHandleui64ARB;
  GLuint glUniformHandleui64vARB;
  GLuint glVertexAttribL1ui64ARB;
  GLuint glVertexAttribL1ui64vARB;

  /* GL_ARB_blend_func_extended */

  GLuint glBindFragDataLocationIndexed;
  GLuint glGetFragDataIndex;

  /* GL_ARB_buffer_storage */

  GLuint glBufferStorage;
  GLuint glNamedBufferStorageEXT;

  /* GL_ARB_cl_event */

  GLuint glCreateSyncFromCLeventARB;

  /* GL_ARB_clear_buffer_object */

  GLuint glClearBufferData;
  GLuint glClearBufferSubData;
  GLuint glClearNamedBufferDataEXT;
  GLuint glClearNamedBufferSubDataEXT;

  /* GL_ARB_clear_texture */

  GLuint glClearTexImage;
  GLuint glClearTexSubImage;

  /* GL_ARB_color_buffer_float */

  GLuint glClampColorARB;

  /* GL_ARB_compute_shader */

  GLuint glDispatchCompute;
  GLuint glDispatchComputeIndirect;

  /* GL_ARB_compute_variable_group_size */

  GLuint glDispatchComputeGroupSizeARB;

  /* GL_ARB_copy_buffer */

  GLuint glCopyBufferSubData;

  /* GL_ARB_copy_image */

  GLuint glCopyImageSubData;

  /* GL_ARB_debug_output */

  GLuint glDebugMessageCallbackARB;
  GLuint glDebugMessageControlARB;
  GLuint glDebugMessageInsertARB;
  GLuint glGetDebugMessageLogARB;

  /* GL_ARB_draw_buffers */

  GLuint glDrawBuffersARB;

  /* GL_ARB_draw_buffers_blend */

  GLuint glBlendEquationSeparateiARB;
  GLuint glBlendEquationiARB;
  GLuint glBlendFuncSeparateiARB;
  GLuint glBlendFunciARB;

  /* GL_ARB_draw_elements_base_vertex */

  GLuint glDrawElementsBaseVertex;
  GLuint glDrawElementsInstancedBaseVertex;
  GLuint glDrawRangeElementsBaseVertex;
  GLuint glMultiDrawElementsBaseVertex;

  /* GL_ARB_draw_indirect */

  GLuint glDrawArraysIndirect;
  GLuint glDrawElementsIndirect;

  /* GL_ARB_draw_instanced */

  GLuint glDrawArraysInstancedARB;
  GLuint glDrawElementsInstancedARB;

  /* GL_ARB_framebuffer_no_attachments */

  GLuint glFramebufferParameteri;
  GLuint glGetFramebufferParameteriv;
  GLuint glGetNamedFramebufferParameterivEXT;
  GLuint glNamedFramebufferParameteriEXT;

  /* GL_ARB_framebuffer_object */

  GLuint glBindFramebuffer;
  GLuint glBindRenderbuffer;
  GLuint glBlitFramebuffer;
  GLuint glCheckFramebufferStatus;
  GLuint glDeleteFramebuffers;
  GLuint glDeleteRenderbuffers;
  GLuint glFramebufferRenderbuffer;
  GLuint glFramebufferTexture1D;
  GLuint glFramebufferTexture2D;
  GLuint glFramebufferTexture3D;
  GLuint glFramebufferTextureLayer;
  GLuint glGenFramebuffers;
  GLuint glGenRenderbuffers;
  GLuint glGenerateMipmap;
  GLuint glGetFramebufferAttachmentParameteriv;
  GLuint glGetRenderbufferParameteriv;
  GLuint glIsFramebuffer;
  GLuint glIsRenderbuffer;
  GLuint glRenderbufferStorage;
  GLuint glRenderbufferStorageMultisample;

  /* GL_ARB_geometry_shader4 */

  GLuint glFramebufferTextureARB;
  GLuint glFramebufferTextureFaceARB;
  GLuint glFramebufferTextureLayerARB;
  GLuint glProgramParameteriARB;

  /* GL_ARB_get_program_binary */

  GLuint glGetProgramBinary;
  GLuint glProgramBinary;
  GLuint glProgramParameteri;

  /* GL_ARB_gpu_shader_fp64 */

  GLuint glGetUniformdv;
  GLuint glUniform1d;
  GLuint glUniform1dv;
  GLuint glUniform2d;
  GLuint glUniform2dv;
  GLuint glUniform3d;
  GLuint glUniform3dv;
  GLuint glUniform4d;
  GLuint glUniform4dv;
  GLuint glUniformMatrix2dv;
  GLuint glUniformMatrix2x3dv;
  GLuint glUniformMatrix2x4dv;
  GLuint glUniformMatrix3dv;
  GLuint glUniformMatrix3x2dv;
  GLuint glUniformMatrix3x4dv;
  GLuint glUniformMatrix4dv;
  GLuint glUniformMatrix4x2dv;
  GLuint glUniformMatrix4x3dv;

  /* GL_ARB_imaging */

  GLuint glColorSubTable;
  GLuint glColorTable;
  GLuint glColorTableParameterfv;
  GLuint glColorTableParameteriv;
  GLuint glConvolutionFilter1D;
  GLuint glConvolutionFilter2D;
  GLuint glConvolutionParameterf;
  GLuint glConvolutionParameterfv;
  GLuint glConvolutionParameteri;
  GLuint glConvolutionParameteriv;
  GLuint glCopyColorSubTable;
  GLuint glCopyColorTable;
  GLuint glCopyConvolutionFilter1D;
  GLuint glCopyConvolutionFilter2D;
  GLuint glGetColorTable;
  GLuint glGetColorTableParameterfv;
  GLuint glGetColorTableParameteriv;
  GLuint glGetConvolutionFilter;
  GLuint glGetConvolutionParameterfv;
  GLuint glGetConvolutionParameteriv;
  GLuint glGetHistogram;
  GLuint glGetHistogramParameterfv;
  GLuint glGetHistogramParameteriv;
  GLuint glGetMinmax;
  GLuint glGetMinmaxParameterfv;
  GLuint glGetMinmaxParameteriv;
  GLuint glGetSeparableFilter;
  GLuint glHistogram;
  GLuint glMinmax;
  GLuint glResetHistogram;
  GLuint glResetMinmax;
  GLuint glSeparableFilter2D;

  /* GL_ARB_indirect_parameters */

  GLuint glMultiDrawArraysIndirectCountARB;
  GLuint glMultiDrawElementsIndirectCountARB;

  /* GL_ARB_instanced_arrays */

  GLuint glVertexAttribDivisorARB;

  /* GL_ARB_internalformat_query */

  GLuint glGetInternalformativ;

  /* GL_ARB_internalformat_query2 */

  GLuint glGetInternalformati64v;

  /* GL_ARB_invalidate_subdata */

  GLuint glInvalidateBufferData;
  GLuint glInvalidateBufferSubData;
  GLuint glInvalidateFramebuffer;
  GLuint glInvalidateSubFramebuffer;
  GLuint glInvalidateTexImage;
  GLuint glInvalidateTexSubImage;

  /* GL_ARB_map_buffer_range */

  GLuint glFlushMappedBufferRange;
  GLuint glMapBufferRange;

  /* GL_ARB_matrix_palette */

  GLuint glCurrentPaletteMatrixARB;
  GLuint glMatrixIndexPointerARB;
  GLuint glMatrixIndexubvARB;
  GLuint glMatrixIndexuivARB;
  GLuint glMatrixIndexusvARB;

  /* GL_ARB_multi_bind */

  GLuint glBindBuffersBase;
  GLuint glBindBuffersRange;
  GLuint glBindImageTextures;
  GLuint glBindSamplers;
  GLuint glBindTextures;
  GLuint glBindVertexBuffers;

  /* GL_ARB_multi_draw_indirect */

  GLuint glMultiDrawArraysIndirect;
  GLuint glMultiDrawElementsIndirect;

  /* GL_ARB_multisample */

  GLuint glSampleCoverageARB;

  /* GL_ARB_multitexture */

  GLuint glActiveTextureARB;
  GLuint glClientActiveTextureARB;
  GLuint glMultiTexCoord1dARB;
  GLuint glMultiTexCoord1dvARB;
  GLuint glMultiTexCoord1fARB;
  GLuint glMultiTexCoord1fvARB;
  GLuint glMultiTexCoord1iARB;
  GLuint glMultiTexCoord1ivARB;
  GLuint glMultiTexCoord1sARB;
  GLuint glMultiTexCoord1svARB;
  GLuint glMultiTexCoord2dARB;
  GLuint glMultiTexCoord2dvARB;
  GLuint glMultiTexCoord2fARB;
  GLuint glMultiTexCoord2fvARB;
  GLuint glMultiTexCoord2iARB;
  GLuint glMultiTexCoord2ivARB;
  GLuint glMultiTexCoord2sARB;
  GLuint glMultiTexCoord2svARB;
  GLuint glMultiTexCoord3dARB;
  GLuint glMultiTexCoord3dvARB;
  GLuint glMultiTexCoord3fARB;
  GLuint glMultiTexCoord3fvARB;
  GLuint glMultiTexCoord3iARB;
  GLuint glMultiTexCoord3ivARB;
  GLuint glMultiTexCoord3sARB;
  GLuint glMultiTexCoord3svARB;
  GLuint glMultiTexCoord4dARB;
  GLuint glMultiTexCoord4dvARB;
  GLuint glMultiTexCoord4fARB;
  GLuint glMultiTexCoord4fvARB;
  GLuint glMultiTexCoord4iARB;
  GLuint glMultiTexCoord4ivARB;
  GLuint glMultiTexCoord4sARB;
  GLuint glMultiTexCoord4svARB;

  /* GL_ARB_occlusion_query */

  GLuint glBeginQueryARB;
  GLuint glDeleteQueriesARB;
  GLuint glEndQueryARB;
  GLuint glGenQueriesARB;
  GLuint glGetQueryObjectivARB;
  GLuint glGetQueryObjectuivARB;
  GLuint glGetQueryivARB;
  GLuint glIsQueryARB;

  /* GL_ARB_point_parameters */

  GLuint glPointParameterfARB;
  GLuint glPointParameterfvARB;

  /* GL_ARB_program_interface_query */

  GLuint glGetProgramInterfaceiv;
  GLuint glGetProgramResourceIndex;
  GLuint glGetProgramResourceLocation;
  GLuint glGetProgramResourceLocationIndex;
  GLuint glGetProgramResourceName;
  GLuint glGetProgramResourceiv;

  /* GL_ARB_provoking_vertex */

  GLuint glProvokingVertex;

  /* GL_ARB_robustness */

  GLuint glGetGraphicsResetStatusARB;
  GLuint glGetnColorTableARB;
  GLuint glGetnCompressedTexImageARB;
  GLuint glGetnConvolutionFilterARB;
  GLuint glGetnHistogramARB;
  GLuint glGetnMapdvARB;
  GLuint glGetnMapfvARB;
  GLuint glGetnMapivARB;
  GLuint glGetnMinmaxARB;
  GLuint glGetnPixelMapfvARB;
  GLuint glGetnPixelMapuivARB;
  GLuint glGetnPixelMapusvARB;
  GLuint glGetnPolygonStippleARB;
  GLuint glGetnSeparableFilterARB;
  GLuint glGetnTexImageARB;
  GLuint glGetnUniformdvARB;
  GLuint glGetnUniformfvARB;
  GLuint glGetnUniformivARB;
  GLuint glGetnUniformuivARB;
  GLuint glReadnPixelsARB;

  /* GL_ARB_sample_shading */

  GLuint glMinSampleShading;
  GLuint glMinSampleShadingARB;

  /* GL_ARB_sampler_objects */

  GLuint glBindSampler;
  GLuint glDeleteSamplers;
  GLuint glGenSamplers;
  GLuint glGetSamplerParameterIiv;
  GLuint glGetSamplerParameterIuiv;
  GLuint glGetSamplerParameterfv;
  GLuint glGetSamplerParameteriv;
  GLuint glIsSampler;
  GLuint glSamplerParameterIiv;
  GLuint glSamplerParameterIuiv;
  GLuint glSamplerParameterf;
  GLuint glSamplerParameterfv;
  GLuint glSamplerParameteri;
  GLuint glSamplerParameteriv;

  /* GL_ARB_separate_shader_objects */

  GLuint glActiveShaderProgram;
  GLuint glBindProgramPipeline;
  GLuint glCreateShaderProgramv;
  GLuint glDeleteProgramPipelines;
  GLuint glGenProgramPipelines;
  GLuint glGetProgramPipelineInfoLog;
  GLuint glGetProgramPipelineiv;
  GLuint glIsProgramPipeline;
  GLuint glProgramUniform1d;
  GLuint glProgramUniform1dv;
  GLuint glProgramUniform1f;
  GLuint glProgramUniform1fv;
  GLuint glProgramUniform1i;
  GLuint glProgramUniform1iv;
  GLuint glProgramUniform1ui;
  GLuint glProgramUniform1uiv;
  GLuint glProgramUniform2d;
  GLuint glProgramUniform2dv;
  GLuint glProgramUniform2f;
  GLuint glProgramUniform2fv;
  GLuint glProgramUniform2i;
  GLuint glProgramUniform2iv;
  GLuint glProgramUniform2ui;
  GLuint glProgramUniform2uiv;
  GLuint glProgramUniform3d;
  GLuint glProgramUniform3dv;
  GLuint glProgramUniform3f;
  GLuint glProgramUniform3fv;
  GLuint glProgramUniform3i;
  GLuint glProgramUniform3iv;
  GLuint glProgramUniform3ui;
  GLuint glProgramUniform3uiv;
  GLuint glProgramUniform4d;
  GLuint glProgramUniform4dv;
  GLuint glProgramUniform4f;
  GLuint glProgramUniform4fv;
  GLuint glProgramUniform4i;
  GLuint glProgramUniform4iv;
  GLuint glProgramUniform4ui;
  GLuint glProgramUniform4uiv;
  GLuint glProgramUniformMatrix2dv;
  GLuint glProgramUniformMatrix2fv;
  GLuint glProgramUniformMatrix2x3dv;
  GLuint glProgramUniformMatrix2x3fv;
  GLuint glProgramUniformMatrix2x4dv;
  GLuint glProgramUniformMatrix2x4fv;
  GLuint glProgramUniformMatrix3dv;
  GLuint glProgramUniformMatrix3fv;
  GLuint glProgramUniformMatrix3x2dv;
  GLuint glProgramUniformMatrix3x2fv;
  GLuint glProgramUniformMatrix3x4dv;
  GLuint glProgramUniformMatrix3x4fv;
  GLuint glProgramUniformMatrix4dv;
  GLuint glProgramUniformMatrix4fv;
  GLuint glProgramUniformMatrix4x2dv;
  GLuint glProgramUniformMatrix4x2fv;
  GLuint glProgramUniformMatrix4x3dv;
  GLuint glProgramUniformMatrix4x3fv;
  GLuint glUseProgramStages;
  GLuint glValidateProgramPipeline;

  /* GL_ARB_shader_atomic_counters */

  GLuint glGetActiveAtomicCounterBufferiv;

  /* GL_ARB_shader_image_load_store */

  GLuint glBindImageTexture;
  GLuint glMemoryBarrier;

  /* GL_ARB_shader_objects */

  GLuint glAttachObjectARB;
  GLuint glCompileShaderARB;
  GLuint glCreateProgramObjectARB;
  GLuint glCreateShaderObjectARB;
  GLuint glDeleteObjectARB;
  GLuint glDetachObjectARB;
  GLuint glGetActiveUniformARB;
  GLuint glGetAttachedObjectsARB;
  GLuint glGetHandleARB;
  GLuint glGetInfoLogARB;
  GLuint glGetObjectParameterfvARB;
  GLuint glGetObjectParameterivARB;
  GLuint glGetShaderSourceARB;
  GLuint glGetUniformLocationARB;
  GLuint glGetUniformfvARB;
  GLuint glGetUniformivARB;
  GLuint glLinkProgramARB;
  GLuint glShaderSourceARB;
  GLuint glUniform1fARB;
  GLuint glUniform1fvARB;
  GLuint glUniform1iARB;
  GLuint glUniform1ivARB;
  GLuint glUniform2fARB;
  GLuint glUniform2fvARB;
  GLuint glUniform2iARB;
  GLuint glUniform2ivARB;
  GLuint glUniform3fARB;
  GLuint glUniform3fvARB;
  GLuint glUniform3iARB;
  GLuint glUniform3ivARB;
  GLuint glUniform4fARB;
  GLuint glUniform4fvARB;
  GLuint glUniform4iARB;
  GLuint glUniform4ivARB;
  GLuint glUniformMatrix2fvARB;
  GLuint glUniformMatrix3fvARB;
  GLuint glUniformMatrix4fvARB;
  GLuint glUseProgramObjectARB;
  GLuint glValidateProgramARB;

  /* GL_ARB_shader_storage_buffer_object */

  GLuint glShaderStorageBlockBinding;

  /* GL_ARB_shader_subroutine */

  GLuint glGetActiveSubroutineName;
  GLuint glGetActiveSubroutineUniformName;
  GLuint glGetActiveSubroutineUniformiv;
  GLuint glGetProgramStageiv;
  GLuint glGetProgramSubroutineParameteruivNV;
  GLuint glGetSubroutineIndex;
  GLuint glGetSubroutineUniformLocation;
  GLuint glGetUniformSubroutineuiv;
  GLuint glProgramSubroutineParametersuivNV;
  GLuint glUniformSubroutinesuiv;

  /* GL_ARB_shading_language_include */

  GLuint glCompileShaderIncludeARB;
  GLuint glDeleteNamedStringARB;
  GLuint glGetNamedStringARB;
  GLuint glGetNamedStringivARB;
  GLuint glIsNamedStringARB;
  GLuint glNamedStringARB;

  /* GL_ARB_sparse_texture */

  GLuint glTexPageCommitmentARB;
  GLuint glTexturePageCommitmentEXT;

  /* GL_ARB_sync */

  GLuint glClientWaitSync;
  GLuint glDeleteSync;
  GLuint glFenceSync;
  GLuint glGetInteger64v;
  GLuint glGetSynciv;
  GLuint glIsSync;
  GLuint glWaitSync;

  /* GL_ARB_tessellation_shader */

  GLuint glPatchParameterfv;
  GLuint glPatchParameteri;

  /* GL_ARB_texture_buffer_object */

  GLuint glTexBufferARB;

  /* GL_ARB_texture_buffer_range */

  GLuint glTexBufferRange;
  GLuint glTextureBufferRangeEXT;

  /* GL_ARB_texture_compression */

  GLuint glCompressedTexImage1DARB;
  GLuint glCompressedTexImage2DARB;
  GLuint glCompressedTexImage3DARB;
  GLuint glCompressedTexSubImage1DARB;
  GLuint glCompressedTexSubImage2DARB;
  GLuint glCompressedTexSubImage3DARB;
  GLuint glGetCompressedTexImageARB;

  /* GL_ARB_texture_multisample */

  GLuint glGetMultisamplefv;
  GLuint glSampleMaski;
  GLuint glTexImage2DMultisample;
  GLuint glTexImage3DMultisample;

  /* GL_ARB_texture_storage */

  GLuint glTexStorage1D;
  GLuint glTexStorage2D;
  GLuint glTexStorage3D;
  GLuint glTextureStorage1DEXT;
  GLuint glTextureStorage2DEXT;
  GLuint glTextureStorage3DEXT;

  /* GL_ARB_texture_storage_multisample */

  GLuint glTexStorage2DMultisample;
  GLuint glTexStorage3DMultisample;
  GLuint glTextureStorage2DMultisampleEXT;
  GLuint glTextureStorage3DMultisampleEXT;

  /* GL_ARB_texture_view */

  GLuint glTextureView;

  /* GL_ARB_timer_query */

  GLuint glGetQueryObjecti64v;
  GLuint glGetQueryObjectui64v;
  GLuint glQueryCounter;

  /* GL_ARB_transform_feedback2 */

  GLuint glBindTransformFeedback;
  GLuint glDeleteTransformFeedbacks;
  GLuint glDrawTransformFeedback;
  GLuint glGenTransformFeedbacks;
  GLuint glIsTransformFeedback;
  GLuint glPauseTransformFeedback;
  GLuint glResumeTransformFeedback;

  /* GL_ARB_transform_feedback3 */

  GLuint glBeginQueryIndexed;
  GLuint glDrawTransformFeedbackStream;
  GLuint glEndQueryIndexed;
  GLuint glGetQueryIndexediv;

  /* GL_ARB_transform_feedback_instanced */

  GLuint glDrawTransformFeedbackInstanced;
  GLuint glDrawTransformFeedbackStreamInstanced;

  /* GL_ARB_transpose_matrix */

  GLuint glLoadTransposeMatrixdARB;
  GLuint glLoadTransposeMatrixfARB;
  GLuint glMultTransposeMatrixdARB;
  GLuint glMultTransposeMatrixfARB;

  /* GL_ARB_uniform_buffer_object */

  GLuint glBindBufferBase;
  GLuint glBindBufferRange;
  GLuint glGetActiveUniformBlockName;
  GLuint glGetActiveUniformBlockiv;
  GLuint glGetActiveUniformName;
  GLuint glGetActiveUniformsiv;
  GLuint glGetIntegeri_v;
  GLuint glGetUniformBlockIndex;
  GLuint glGetUniformIndices;
  GLuint glUniformBlockBinding;

  /* GL_ARB_vertex_array_object */

  GLuint glBindVertexArray;
  GLuint glDeleteVertexArrays;
  GLuint glGenVertexArrays;
  GLuint glIsVertexArray;

  /* GL_ARB_vertex_attrib_64bit */

  GLuint glGetVertexAttribLdv;
  GLuint glVertexAttribL1d;
  GLuint glVertexAttribL1dv;
  GLuint glVertexAttribL2d;
  GLuint glVertexAttribL2dv;
  GLuint glVertexAttribL3d;
  GLuint glVertexAttribL3dv;
  GLuint glVertexAttribL4d;
  GLuint glVertexAttribL4dv;
  GLuint glVertexAttribLPointer;

  /* GL_ARB_vertex_attrib_binding */

  GLuint glBindVertexBuffer;
  GLuint glVertexArrayBindVertexBufferEXT;
  GLuint glVertexArrayVertexAttribBindingEXT;
  GLuint glVertexArrayVertexAttribFormatEXT;
  GLuint glVertexArrayVertexAttribIFormatEXT;
  GLuint glVertexArrayVertexAttribLFormatEXT;
  GLuint glVertexArrayVertexBindingDivisorEXT;
  GLuint glVertexAttribBinding;
  GLuint glVertexAttribFormat;
  GLuint glVertexAttribIFormat;
  GLuint glVertexAttribLFormat;
  GLuint glVertexBindingDivisor;

  /* GL_ARB_vertex_blend */

  GLuint glVertexBlendARB;
  GLuint glWeightPointerARB;
  GLuint glWeightbvARB;
  GLuint glWeightdvARB;
  GLuint glWeightfvARB;
  GLuint glWeightivARB;
  GLuint glWeightsvARB;
  GLuint glWeightubvARB;
  GLuint glWeightuivARB;
  GLuint glWeightusvARB;

  /* GL_ARB_vertex_buffer_object */

  GLuint glBindBufferARB;
  GLuint glBufferDataARB;
  GLuint glBufferSubDataARB;
  GLuint glDeleteBuffersARB;
  GLuint glGenBuffersARB;
  GLuint glGetBufferParameterivARB;
  GLuint glGetBufferPointervARB;
  GLuint glGetBufferSubDataARB;
  GLuint glIsBufferARB;
  GLuint glMapBufferARB;
  GLuint glUnmapBufferARB;

  /* GL_ARB_vertex_program */

  GLuint glBindProgramARB;
  GLuint glDeleteProgramsARB;
  GLuint glDisableVertexAttribArrayARB;
  GLuint glEnableVertexAttribArrayARB;
  GLuint glGenProgramsARB;
  GLuint glGetProgramEnvParameterdvARB;
  GLuint glGetProgramEnvParameterfvARB;
  GLuint glGetProgramLocalParameterdvARB;
  GLuint glGetProgramLocalParameterfvARB;
  GLuint glGetProgramStringARB;
  GLuint glGetProgramivARB;
  GLuint glGetVertexAttribPointervARB;
  GLuint glGetVertexAttribdvARB;
  GLuint glGetVertexAttribfvARB;
  GLuint glGetVertexAttribivARB;
  GLuint glIsProgramARB;
  GLuint glProgramEnvParameter4dARB;
  GLuint glProgramEnvParameter4dvARB;
  GLuint glProgramEnvParameter4fARB;
  GLuint glProgramEnvParameter4fvARB;
  GLuint glProgramLocalParameter4dARB;
  GLuint glProgramLocalParameter4dvARB;
  GLuint glProgramLocalParameter4fARB;
  GLuint glProgramLocalParameter4fvARB;
  GLuint glProgramStringARB;
  GLuint glVertexAttrib1dARB;
  GLuint glVertexAttrib1dvARB;
  GLuint glVertexAttrib1fARB;
  GLuint glVertexAttrib1fvARB;
  GLuint glVertexAttrib1sARB;
  GLuint glVertexAttrib1svARB;
  GLuint glVertexAttrib2dARB;
  GLuint glVertexAttrib2dvARB;
  GLuint glVertexAttrib2fARB;
  GLuint glVertexAttrib2fvARB;
  GLuint glVertexAttrib2sARB;
  GLuint glVertexAttrib2svARB;
  GLuint glVertexAttrib3dARB;
  GLuint glVertexAttrib3dvARB;
  GLuint glVertexAttrib3fARB;
  GLuint glVertexAttrib3fvARB;
  GLuint glVertexAttrib3sARB;
  GLuint glVertexAttrib3svARB;
  GLuint glVertexAttrib4NbvARB;
  GLuint glVertexAttrib4NivARB;
  GLuint glVertexAttrib4NsvARB;
  GLuint glVertexAttrib4NubARB;
  GLuint glVertexAttrib4NubvARB;
  GLuint glVertexAttrib4NuivARB;
  GLuint glVertexAttrib4NusvARB;
  GLuint glVertexAttrib4bvARB;
  GLuint glVertexAttrib4dARB;
  GLuint glVertexAttrib4dvARB;
  GLuint glVertexAttrib4fARB;
  GLuint glVertexAttrib4fvARB;
  GLuint glVertexAttrib4ivARB;
  GLuint glVertexAttrib4sARB;
  GLuint glVertexAttrib4svARB;
  GLuint glVertexAttrib4ubvARB;
  GLuint glVertexAttrib4uivARB;
  GLuint glVertexAttrib4usvARB;
  GLuint glVertexAttribPointerARB;

  /* GL_ARB_vertex_shader */

  GLuint glBindAttribLocationARB;
  GLuint glGetActiveAttribARB;
  GLuint glGetAttribLocationARB;

  /* GL_ARB_vertex_type_2_10_10_10_rev */

  GLuint glColorP3ui;
  GLuint glColorP3uiv;
  GLuint glColorP4ui;
  GLuint glColorP4uiv;
  GLuint glMultiTexCoordP1ui;
  GLuint glMultiTexCoordP1uiv;
  GLuint glMultiTexCoordP2ui;
  GLuint glMultiTexCoordP2uiv;
  GLuint glMultiTexCoordP3ui;
  GLuint glMultiTexCoordP3uiv;
  GLuint glMultiTexCoordP4ui;
  GLuint glMultiTexCoordP4uiv;
  GLuint glNormalP3ui;
  GLuint glNormalP3uiv;
  GLuint glSecondaryColorP3ui;
  GLuint glSecondaryColorP3uiv;
  GLuint glTexCoordP1ui;
  GLuint glTexCoordP1uiv;
  GLuint glTexCoordP2ui;
  GLuint glTexCoordP2uiv;
  GLuint glTexCoordP3ui;
  GLuint glTexCoordP3uiv;
  GLuint glTexCoordP4ui;
  GLuint glTexCoordP4uiv;
  GLuint glVertexAttribP1ui;
  GLuint glVertexAttribP1uiv;
  GLuint glVertexAttribP2ui;
  GLuint glVertexAttribP2uiv;
  GLuint glVertexAttribP3ui;
  GLuint glVertexAttribP3uiv;
  GLuint glVertexAttribP4ui;
  GLuint glVertexAttribP4uiv;
  GLuint glVertexP2ui;
  GLuint glVertexP2uiv;
  GLuint glVertexP3ui;
  GLuint glVertexP3uiv;
  GLuint glVertexP4ui;
  GLuint glVertexP4uiv;

  /* GL_ARB_viewport_array */

  GLuint glDepthRangeArrayv;
  GLuint glDepthRangeIndexed;
  GLuint glGetDoublei_v;
  GLuint glGetFloati_v;
  GLuint glScissorArrayv;
  GLuint glScissorIndexed;
  GLuint glScissorIndexedv;
  GLuint glViewportArrayv;
  GLuint glViewportIndexedf;
  GLuint glViewportIndexedfv;

  /* GL_ARB_window_pos */

  GLuint glWindowPos2dARB;
  GLuint glWindowPos2dvARB;
  GLuint glWindowPos2fARB;
  GLuint glWindowPos2fvARB;
  GLuint glWindowPos2iARB;
  GLuint glWindowPos2ivARB;
  GLuint glWindowPos2sARB;
  GLuint glWindowPos2svARB;
  GLuint glWindowPos3dARB;
  GLuint glWindowPos3dvARB;
  GLuint glWindowPos3fARB;
  GLuint glWindowPos3fvARB;
  GLuint glWindowPos3iARB;
  GLuint glWindowPos3ivARB;
  GLuint glWindowPos3sARB;
  GLuint glWindowPos3svARB;

  /* GL_ATI_draw_buffers */

  GLuint glDrawBuffersATI;

  /* GL_ATI_element_array */

  GLuint glDrawElementArrayATI;
  GLuint glDrawRangeElementArrayATI;
  GLuint glElementPointerATI;

  /* GL_ATI_envmap_bumpmap */

  GLuint glGetTexBumpParameterfvATI;
  GLuint glGetTexBumpParameterivATI;
  GLuint glTexBumpParameterfvATI;
  GLuint glTexBumpParameterivATI;

  /* GL_ATI_fragment_shader */

  GLuint glAlphaFragmentOp1ATI;
  GLuint glAlphaFragmentOp2ATI;
  GLuint glAlphaFragmentOp3ATI;
  GLuint glBeginFragmentShaderATI;
  GLuint glBindFragmentShaderATI;
  GLuint glColorFragmentOp1ATI;
  GLuint glColorFragmentOp2ATI;
  GLuint glColorFragmentOp3ATI;
  GLuint glDeleteFragmentShaderATI;
  GLuint glEndFragmentShaderATI;
  GLuint glGenFragmentShadersATI;
  GLuint glPassTexCoordATI;
  GLuint glSampleMapATI;
  GLuint glSetFragmentShaderConstantATI;

  /* GL_ATI_map_object_buffer */

  GLuint glMapObjectBufferATI;
  GLuint glUnmapObjectBufferATI;

  /* GL_ATI_pn_triangles */

  GLuint glPNTrianglesfATI;
  GLuint glPNTrianglesiATI;

  /* GL_ATI_separate_stencil */

  GLuint glStencilFuncSeparateATI;
  GLuint glStencilOpSeparateATI;

  /* GL_ATI_vertex_array_object */

  GLuint glArrayObjectATI;
  GLuint glFreeObjectBufferATI;
  GLuint glGetArrayObjectfvATI;
  GLuint glGetArrayObjectivATI;
  GLuint glGetObjectBufferfvATI;
  GLuint glGetObjectBufferivATI;
  GLuint glGetVariantArrayObjectfvATI;
  GLuint glGetVariantArrayObjectivATI;
  GLuint glIsObjectBufferATI;
  GLuint glNewObjectBufferATI;
  GLuint glUpdateObjectBufferATI;
  GLuint glVariantArrayObjectATI;

  /* GL_ATI_vertex_attrib_array_object */

  GLuint glGetVertexAttribArrayObjectfvATI;
  GLuint glGetVertexAttribArrayObjectivATI;
  GLuint glVertexAttribArrayObjectATI;

  /* GL_ATI_vertex_streams */

  GLuint glClientActiveVertexStreamATI;
  GLuint glNormalStream3bATI;
  GLuint glNormalStream3bvATI;
  GLuint glNormalStream3dATI;
  GLuint glNormalStream3dvATI;
  GLuint glNormalStream3fATI;
  GLuint glNormalStream3fvATI;
  GLuint glNormalStream3iATI;
  GLuint glNormalStream3ivATI;
  GLuint glNormalStream3sATI;
  GLuint glNormalStream3svATI;
  GLuint glVertexBlendEnvfATI;
  GLuint glVertexBlendEnviATI;
  GLuint glVertexStream1dATI;
  GLuint glVertexStream1dvATI;
  GLuint glVertexStream1fATI;
  GLuint glVertexStream1fvATI;
  GLuint glVertexStream1iATI;
  GLuint glVertexStream1ivATI;
  GLuint glVertexStream1sATI;
  GLuint glVertexStream1svATI;
  GLuint glVertexStream2dATI;
  GLuint glVertexStream2dvATI;
  GLuint glVertexStream2fATI;
  GLuint glVertexStream2fvATI;
  GLuint glVertexStream2iATI;
  GLuint glVertexStream2ivATI;
  GLuint glVertexStream2sATI;
  GLuint glVertexStream2svATI;
  GLuint glVertexStream3dATI;
  GLuint glVertexStream3dvATI;
  GLuint glVertexStream3fATI;
  GLuint glVertexStream3fvATI;
  GLuint glVertexStream3iATI;
  GLuint glVertexStream3ivATI;
  GLuint glVertexStream3sATI;
  GLuint glVertexStream3svATI;
  GLuint glVertexStream4dATI;
  GLuint glVertexStream4dvATI;
  GLuint glVertexStream4fATI;
  GLuint glVertexStream4fvATI;
  GLuint glVertexStream4iATI;
  GLuint glVertexStream4ivATI;
  GLuint glVertexStream4sATI;
  GLuint glVertexStream4svATI;

  /* GL_EXT_bindable_uniform */

  GLuint glGetUniformBufferSizeEXT;
  GLuint glGetUniformOffsetEXT;
  GLuint glUniformBufferEXT;

  /* GL_EXT_blend_color */

  GLuint glBlendColorEXT;

  /* GL_EXT_blend_equation_separate */

  GLuint glBlendEquationSeparateEXT;

  /* GL_EXT_blend_func_separate */

  GLuint glBlendFuncSeparateEXT;

  /* GL_EXT_blend_minmax */

  GLuint glBlendEquationEXT;

  /* GL_EXT_color_subtable */

  GLuint glColorSubTableEXT;
  GLuint glCopyColorSubTableEXT;

  /* GL_EXT_compiled_vertex_array */

  GLuint glLockArraysEXT;
  GLuint glUnlockArraysEXT;

  /* GL_EXT_convolution */

  GLuint glConvolutionFilter1DEXT;
  GLuint glConvolutionFilter2DEXT;
  GLuint glConvolutionParameterfEXT;
  GLuint glConvolutionParameterfvEXT;
  GLuint glConvolutionParameteriEXT;
  GLuint glConvolutionParameterivEXT;
  GLuint glCopyConvolutionFilter1DEXT;
  GLuint glCopyConvolutionFilter2DEXT;
  GLuint glGetConvolutionFilterEXT;
  GLuint glGetConvolutionParameterfvEXT;
  GLuint glGetConvolutionParameterivEXT;
  GLuint glGetSeparableFilterEXT;
  GLuint glSeparableFilter2DEXT;

  /* GL_EXT_coordinate_frame */

  GLuint glBinormal3bEXT;
  GLuint glBinormal3bvEXT;
  GLuint glBinormal3dEXT;
  GLuint glBinormal3dvEXT;
  GLuint glBinormal3fEXT;
  GLuint glBinormal3fvEXT;
  GLuint glBinormal3iEXT;
  GLuint glBinormal3ivEXT;
  GLuint glBinormal3sEXT;
  GLuint glBinormal3svEXT;
  GLuint glBinormalPointerEXT;
  GLuint glTangent3bEXT;
  GLuint glTangent3bvEXT;
  GLuint glTangent3dEXT;
  GLuint glTangent3dvEXT;
  GLuint glTangent3fEXT;
  GLuint glTangent3fvEXT;
  GLuint glTangent3iEXT;
  GLuint glTangent3ivEXT;
  GLuint glTangent3sEXT;
  GLuint glTangent3svEXT;
  GLuint glTangentPointerEXT;

  /* GL_EXT_copy_texture */

  GLuint glCopyTexImage1DEXT;
  GLuint glCopyTexImage2DEXT;
  GLuint glCopyTexSubImage1DEXT;
  GLuint glCopyTexSubImage2DEXT;
  GLuint glCopyTexSubImage3DEXT;

  /* GL_EXT_cull_vertex */

  GLuint glCullParameterdvEXT;
  GLuint glCullParameterfvEXT;

  /* GL_EXT_debug_label */

  GLuint glGetObjectLabelEXT;
  GLuint glLabelObjectEXT;

  /* GL_EXT_debug_marker */

  GLuint glInsertEventMarkerEXT;
  GLuint glPopGroupMarkerEXT;
  GLuint glPushGroupMarkerEXT;

  /* GL_EXT_depth_bounds_test */

  GLuint glDepthBoundsEXT;

  /* GL_EXT_direct_state_access */

  GLuint glBindMultiTextureEXT;
  GLuint glCheckNamedFramebufferStatusEXT;
  GLuint glClientAttribDefaultEXT;
  GLuint glCompressedMultiTexImage1DEXT;
  GLuint glCompressedMultiTexImage2DEXT;
  GLuint glCompressedMultiTexImage3DEXT;
  GLuint glCompressedMultiTexSubImage1DEXT;
  GLuint glCompressedMultiTexSubImage2DEXT;
  GLuint glCompressedMultiTexSubImage3DEXT;
  GLuint glCompressedTextureImage1DEXT;
  GLuint glCompressedTextureImage2DEXT;
  GLuint glCompressedTextureImage3DEXT;
  GLuint glCompressedTextureSubImage1DEXT;
  GLuint glCompressedTextureSubImage2DEXT;
  GLuint glCompressedTextureSubImage3DEXT;
  GLuint glCopyMultiTexImage1DEXT;
  GLuint glCopyMultiTexImage2DEXT;
  GLuint glCopyMultiTexSubImage1DEXT;
  GLuint glCopyMultiTexSubImage2DEXT;
  GLuint glCopyMultiTexSubImage3DEXT;
  GLuint glCopyTextureImage1DEXT;
  GLuint glCopyTextureImage2DEXT;
  GLuint glCopyTextureSubImage1DEXT;
  GLuint glCopyTextureSubImage2DEXT;
  GLuint glCopyTextureSubImage3DEXT;
  GLuint glDisableClientStateIndexedEXT;
  GLuint glDisableClientStateiEXT;
  GLuint glDisableVertexArrayAttribEXT;
  GLuint glDisableVertexArrayEXT;
  GLuint glEnableClientStateIndexedEXT;
  GLuint glEnableClientStateiEXT;
  GLuint glEnableVertexArrayAttribEXT;
  GLuint glEnableVertexArrayEXT;
  GLuint glFlushMappedNamedBufferRangeEXT;
  GLuint glFramebufferDrawBufferEXT;
  GLuint glFramebufferDrawBuffersEXT;
  GLuint glFramebufferReadBufferEXT;
  GLuint glGenerateMultiTexMipmapEXT;
  GLuint glGenerateTextureMipmapEXT;
  GLuint glGetCompressedMultiTexImageEXT;
  GLuint glGetCompressedTextureImageEXT;
  GLuint glGetDoubleIndexedvEXT;
  GLuint glGetDoublei_vEXT;
  GLuint glGetFloatIndexedvEXT;
  GLuint glGetFloati_vEXT;
  GLuint glGetFramebufferParameterivEXT;
  GLuint glGetMultiTexEnvfvEXT;
  GLuint glGetMultiTexEnvivEXT;
  GLuint glGetMultiTexGendvEXT;
  GLuint glGetMultiTexGenfvEXT;
  GLuint glGetMultiTexGenivEXT;
  GLuint glGetMultiTexImageEXT;
  GLuint glGetMultiTexLevelParameterfvEXT;
  GLuint glGetMultiTexLevelParameterivEXT;
  GLuint glGetMultiTexParameterIivEXT;
  GLuint glGetMultiTexParameterIuivEXT;
  GLuint glGetMultiTexParameterfvEXT;
  GLuint glGetMultiTexParameterivEXT;
  GLuint glGetNamedBufferParameterivEXT;
  GLuint glGetNamedBufferPointervEXT;
  GLuint glGetNamedBufferSubDataEXT;
  GLuint glGetNamedFramebufferAttachmentParameterivEXT;
  GLuint glGetNamedProgramLocalParameterIivEXT;
  GLuint glGetNamedProgramLocalParameterIuivEXT;
  GLuint glGetNamedProgramLocalParameterdvEXT;
  GLuint glGetNamedProgramLocalParameterfvEXT;
  GLuint glGetNamedProgramStringEXT;
  GLuint glGetNamedProgramivEXT;
  GLuint glGetNamedRenderbufferParameterivEXT;
  GLuint glGetPointerIndexedvEXT;
  GLuint glGetPointeri_vEXT;
  GLuint glGetTextureImageEXT;
  GLuint glGetTextureLevelParameterfvEXT;
  GLuint glGetTextureLevelParameterivEXT;
  GLuint glGetTextureParameterIivEXT;
  GLuint glGetTextureParameterIuivEXT;
  GLuint glGetTextureParameterfvEXT;
  GLuint glGetTextureParameterivEXT;
  GLuint glGetVertexArrayIntegeri_vEXT;
  GLuint glGetVertexArrayIntegervEXT;
  GLuint glGetVertexArrayPointeri_vEXT;
  GLuint glGetVertexArrayPointervEXT;
  GLuint glMapNamedBufferEXT;
  GLuint glMapNamedBufferRangeEXT;
  GLuint glMatrixFrustumEXT;
  GLuint glMatrixLoadIdentityEXT;
  GLuint glMatrixLoadTransposedEXT;
  GLuint glMatrixLoadTransposefEXT;
  GLuint glMatrixLoaddEXT;
  GLuint glMatrixLoadfEXT;
  GLuint glMatrixMultTransposedEXT;
  GLuint glMatrixMultTransposefEXT;
  GLuint glMatrixMultdEXT;
  GLuint glMatrixMultfEXT;
  GLuint glMatrixOrthoEXT;
  GLuint glMatrixPopEXT;
  GLuint glMatrixPushEXT;
  GLuint glMatrixRotatedEXT;
  GLuint glMatrixRotatefEXT;
  GLuint glMatrixScaledEXT;
  GLuint glMatrixScalefEXT;
  GLuint glMatrixTranslatedEXT;
  GLuint glMatrixTranslatefEXT;
  GLuint glMultiTexBufferEXT;
  GLuint glMultiTexCoordPointerEXT;
  GLuint glMultiTexEnvfEXT;
  GLuint glMultiTexEnvfvEXT;
  GLuint glMultiTexEnviEXT;
  GLuint glMultiTexEnvivEXT;
  GLuint glMultiTexGendEXT;
  GLuint glMultiTexGendvEXT;
  GLuint glMultiTexGenfEXT;
  GLuint glMultiTexGenfvEXT;
  GLuint glMultiTexGeniEXT;
  GLuint glMultiTexGenivEXT;
  GLuint glMultiTexImage1DEXT;
  GLuint glMultiTexImage2DEXT;
  GLuint glMultiTexImage3DEXT;
  GLuint glMultiTexParameterIivEXT;
  GLuint glMultiTexParameterIuivEXT;
  GLuint glMultiTexParameterfEXT;
  GLuint glMultiTexParameterfvEXT;
  GLuint glMultiTexParameteriEXT;
  GLuint glMultiTexParameterivEXT;
  GLuint glMultiTexRenderbufferEXT;
  GLuint glMultiTexSubImage1DEXT;
  GLuint glMultiTexSubImage2DEXT;
  GLuint glMultiTexSubImage3DEXT;
  GLuint glNamedBufferDataEXT;
  GLuint glNamedBufferSubDataEXT;
  GLuint glNamedCopyBufferSubDataEXT;
  GLuint glNamedFramebufferRenderbufferEXT;
  GLuint glNamedFramebufferTexture1DEXT;
  GLuint glNamedFramebufferTexture2DEXT;
  GLuint glNamedFramebufferTexture3DEXT;
  GLuint glNamedFramebufferTextureEXT;
  GLuint glNamedFramebufferTextureFaceEXT;
  GLuint glNamedFramebufferTextureLayerEXT;
  GLuint glNamedProgramLocalParameter4dEXT;
  GLuint glNamedProgramLocalParameter4dvEXT;
  GLuint glNamedProgramLocalParameter4fEXT;
  GLuint glNamedProgramLocalParameter4fvEXT;
  GLuint glNamedProgramLocalParameterI4iEXT;
  GLuint glNamedProgramLocalParameterI4ivEXT;
  GLuint glNamedProgramLocalParameterI4uiEXT;
  GLuint glNamedProgramLocalParameterI4uivEXT;
  GLuint glNamedProgramLocalParameters4fvEXT;
  GLuint glNamedProgramLocalParametersI4ivEXT;
  GLuint glNamedProgramLocalParametersI4uivEXT;
  GLuint glNamedProgramStringEXT;
  GLuint glNamedRenderbufferStorageEXT;
  GLuint glNamedRenderbufferStorageMultisampleCoverageEXT;
  GLuint glNamedRenderbufferStorageMultisampleEXT;
  GLuint glProgramUniform1dEXT;
  GLuint glProgramUniform1dvEXT;
  GLuint glProgramUniform1fEXT;
  GLuint glProgramUniform1fvEXT;
  GLuint glProgramUniform1iEXT;
  GLuint glProgramUniform1ivEXT;
  GLuint glProgramUniform1uiEXT;
  GLuint glProgramUniform1uivEXT;
  GLuint glProgramUniform2dEXT;
  GLuint glProgramUniform2dvEXT;
  GLuint glProgramUniform2fEXT;
  GLuint glProgramUniform2fvEXT;
  GLuint glProgramUniform2iEXT;
  GLuint glProgramUniform2ivEXT;
  GLuint glProgramUniform2uiEXT;
  GLuint glProgramUniform2uivEXT;
  GLuint glProgramUniform3dEXT;
  GLuint glProgramUniform3dvEXT;
  GLuint glProgramUniform3fEXT;
  GLuint glProgramUniform3fvEXT;
  GLuint glProgramUniform3iEXT;
  GLuint glProgramUniform3ivEXT;
  GLuint glProgramUniform3uiEXT;
  GLuint glProgramUniform3uivEXT;
  GLuint glProgramUniform4dEXT;
  GLuint glProgramUniform4dvEXT;
  GLuint glProgramUniform4fEXT;
  GLuint glProgramUniform4fvEXT;
  GLuint glProgramUniform4iEXT;
  GLuint glProgramUniform4ivEXT;
  GLuint glProgramUniform4uiEXT;
  GLuint glProgramUniform4uivEXT;
  GLuint glProgramUniformMatrix2dvEXT;
  GLuint glProgramUniformMatrix2fvEXT;
  GLuint glProgramUniformMatrix2x3dvEXT;
  GLuint glProgramUniformMatrix2x3fvEXT;
  GLuint glProgramUniformMatrix2x4dvEXT;
  GLuint glProgramUniformMatrix2x4fvEXT;
  GLuint glProgramUniformMatrix3dvEXT;
  GLuint glProgramUniformMatrix3fvEXT;
  GLuint glProgramUniformMatrix3x2dvEXT;
  GLuint glProgramUniformMatrix3x2fvEXT;
  GLuint glProgramUniformMatrix3x4dvEXT;
  GLuint glProgramUniformMatrix3x4fvEXT;
  GLuint glProgramUniformMatrix4dvEXT;
  GLuint glProgramUniformMatrix4fvEXT;
  GLuint glProgramUniformMatrix4x2dvEXT;
  GLuint glProgramUniformMatrix4x2fvEXT;
  GLuint glProgramUniformMatrix4x3dvEXT;
  GLuint glProgramUniformMatrix4x3fvEXT;
  GLuint glPushClientAttribDefaultEXT;
  GLuint glTextureBufferEXT;
  GLuint glTextureImage1DEXT;
  GLuint glTextureImage2DEXT;
  GLuint glTextureImage3DEXT;
  GLuint glTextureParameterIivEXT;
  GLuint glTextureParameterIuivEXT;
  GLuint glTextureParameterfEXT;
  GLuint glTextureParameterfvEXT;
  GLuint glTextureParameteriEXT;
  GLuint glTextureParameterivEXT;
  GLuint glTextureRenderbufferEXT;
  GLuint glTextureSubImage1DEXT;
  GLuint glTextureSubImage2DEXT;
  GLuint glTextureSubImage3DEXT;
  GLuint glUnmapNamedBufferEXT;
  GLuint glVertexArrayColorOffsetEXT;
  GLuint glVertexArrayEdgeFlagOffsetEXT;
  GLuint glVertexArrayFogCoordOffsetEXT;
  GLuint glVertexArrayIndexOffsetEXT;
  GLuint glVertexArrayMultiTexCoordOffsetEXT;
  GLuint glVertexArrayNormalOffsetEXT;
  GLuint glVertexArraySecondaryColorOffsetEXT;
  GLuint glVertexArrayTexCoordOffsetEXT;
  GLuint glVertexArrayVertexAttribIOffsetEXT;
  GLuint glVertexArrayVertexAttribOffsetEXT;
  GLuint glVertexArrayVertexOffsetEXT;

  /* GL_EXT_discard_framebuffer */

  GLuint glDiscardFramebufferEXT;

  /* GL_EXT_disjoint_timer_query */

  GLuint glGetQueryObjectivEXT;
  GLuint glQueryCounterEXT;

  /* GL_EXT_draw_buffers2 */

  GLuint glColorMaskIndexedEXT;
  GLuint glDisableIndexedEXT;
  GLuint glEnableIndexedEXT;
  GLuint glGetBooleanIndexedvEXT;
  GLuint glGetIntegerIndexedvEXT;
  GLuint glIsEnabledIndexedEXT;

  /* GL_EXT_draw_instanced */

  GLuint glDrawArraysInstancedEXT;
  GLuint glDrawElementsInstancedEXT;

  /* GL_EXT_draw_range_elements */

  GLuint glDrawRangeElementsEXT;

  /* GL_EXT_fog_coord */

  GLuint glFogCoordPointerEXT;
  GLuint glFogCoorddEXT;
  GLuint glFogCoorddvEXT;
  GLuint glFogCoordfEXT;
  GLuint glFogCoordfvEXT;

  /* GL_EXT_fragment_lighting */

  GLuint glFragmentColorMaterialEXT;
  GLuint glFragmentLightModelfEXT;
  GLuint glFragmentLightModelfvEXT;
  GLuint glFragmentLightModeliEXT;
  GLuint glFragmentLightModelivEXT;
  GLuint glFragmentLightfEXT;
  GLuint glFragmentLightfvEXT;
  GLuint glFragmentLightiEXT;
  GLuint glFragmentLightivEXT;
  GLuint glFragmentMaterialfEXT;
  GLuint glFragmentMaterialfvEXT;
  GLuint glFragmentMaterialiEXT;
  GLuint glFragmentMaterialivEXT;
  GLuint glGetFragmentLightfvEXT;
  GLuint glGetFragmentLightivEXT;
  GLuint glGetFragmentMaterialfvEXT;
  GLuint glGetFragmentMaterialivEXT;
  GLuint glLightEnviEXT;

  /* GL_EXT_framebuffer_blit */

  GLuint glBlitFramebufferEXT;

  /* GL_EXT_framebuffer_multisample */

  GLuint glRenderbufferStorageMultisampleEXT;

  /* GL_EXT_framebuffer_object */

  GLuint glBindFramebufferEXT;
  GLuint glBindRenderbufferEXT;
  GLuint glCheckFramebufferStatusEXT;
  GLuint glDeleteFramebuffersEXT;
  GLuint glDeleteRenderbuffersEXT;
  GLuint glFramebufferRenderbufferEXT;
  GLuint glFramebufferTexture1DEXT;
  GLuint glFramebufferTexture2DEXT;
  GLuint glFramebufferTexture3DEXT;
  GLuint glGenFramebuffersEXT;
  GLuint glGenRenderbuffersEXT;
  GLuint glGenerateMipmapEXT;
  GLuint glGetFramebufferAttachmentParameterivEXT;
  GLuint glGetRenderbufferParameterivEXT;
  GLuint glIsFramebufferEXT;
  GLuint glIsRenderbufferEXT;
  GLuint glRenderbufferStorageEXT;

  /* GL_EXT_geometry_shader4 */

  GLuint glFramebufferTextureEXT;
  GLuint glFramebufferTextureFaceEXT;
  GLuint glProgramParameteriEXT;

  /* GL_EXT_gpu_program_parameters */

  GLuint glProgramEnvParameters4fvEXT;
  GLuint glProgramLocalParameters4fvEXT;

  /* GL_EXT_gpu_shader4 */

  GLuint glBindFragDataLocationEXT;
  GLuint glGetFragDataLocationEXT;
  GLuint glGetUniformuivEXT;
  GLuint glGetVertexAttribIivEXT;
  GLuint glGetVertexAttribIuivEXT;
  GLuint glUniform1uiEXT;
  GLuint glUniform1uivEXT;
  GLuint glUniform2uiEXT;
  GLuint glUniform2uivEXT;
  GLuint glUniform3uiEXT;
  GLuint glUniform3uivEXT;
  GLuint glUniform4uiEXT;
  GLuint glUniform4uivEXT;
  GLuint glVertexAttribI1iEXT;
  GLuint glVertexAttribI1ivEXT;
  GLuint glVertexAttribI1uiEXT;
  GLuint glVertexAttribI1uivEXT;
  GLuint glVertexAttribI2iEXT;
  GLuint glVertexAttribI2ivEXT;
  GLuint glVertexAttribI2uiEXT;
  GLuint glVertexAttribI2uivEXT;
  GLuint glVertexAttribI3iEXT;
  GLuint glVertexAttribI3ivEXT;
  GLuint glVertexAttribI3uiEXT;
  GLuint glVertexAttribI3uivEXT;
  GLuint glVertexAttribI4bvEXT;
  GLuint glVertexAttribI4iEXT;
  GLuint glVertexAttribI4ivEXT;
  GLuint glVertexAttribI4svEXT;
  GLuint glVertexAttribI4ubvEXT;
  GLuint glVertexAttribI4uiEXT;
  GLuint glVertexAttribI4uivEXT;
  GLuint glVertexAttribI4usvEXT;
  GLuint glVertexAttribIPointerEXT;

  /* GL_EXT_histogram */

  GLuint glGetHistogramEXT;
  GLuint glGetHistogramParameterfvEXT;
  GLuint glGetHistogramParameterivEXT;
  GLuint glGetMinmaxEXT;
  GLuint glGetMinmaxParameterfvEXT;
  GLuint glGetMinmaxParameterivEXT;
  GLuint glHistogramEXT;
  GLuint glMinmaxEXT;
  GLuint glResetHistogramEXT;
  GLuint glResetMinmaxEXT;

  /* GL_EXT_index_func */

  GLuint glIndexFuncEXT;

  /* GL_EXT_index_material */

  GLuint glIndexMaterialEXT;

  /* GL_EXT_light_texture */

  GLuint glApplyTextureEXT;
  GLuint glTextureLightEXT;
  GLuint glTextureMaterialEXT;

  /* GL_EXT_map_buffer_range */

  GLuint glFlushMappedBufferRangeEXT;
  GLuint glMapBufferRangeEXT;

  /* GL_EXT_multi_draw_arrays */

  GLuint glMultiDrawArraysEXT;
  GLuint glMultiDrawElementsEXT;

  /* GL_EXT_multisample */

  GLuint glSampleMaskEXT;
  GLuint glSamplePatternEXT;

  /* GL_EXT_multisampled_render_to_texture */

  GLuint glFramebufferTexture2DMultisampleEXT;

  /* GL_EXT_multiview_draw_buffers */

  GLuint glDrawBuffersIndexedEXT;
  GLuint glGetIntegeri_vEXT;
  GLuint glReadBufferIndexedEXT;

  /* GL_EXT_occlusion_query_boolean */

  GLuint glBeginQueryEXT;
  GLuint glDeleteQueriesEXT;
  GLuint glEndQueryEXT;
  GLuint glGenQueriesEXT;
  GLuint glGetQueryObjectuivEXT;
  GLuint glGetQueryivEXT;
  GLuint glIsQueryEXT;

  /* GL_EXT_paletted_texture */

  GLuint glColorTableEXT;
  GLuint glGetColorTableEXT;
  GLuint glGetColorTableParameterfvEXT;
  GLuint glGetColorTableParameterivEXT;

  /* GL_EXT_pixel_transform */

  GLuint glGetPixelTransformParameterfvEXT;
  GLuint glGetPixelTransformParameterivEXT;
  GLuint glPixelTransformParameterfEXT;
  GLuint glPixelTransformParameterfvEXT;
  GLuint glPixelTransformParameteriEXT;
  GLuint glPixelTransformParameterivEXT;

  /* GL_EXT_point_parameters */

  GLuint glPointParameterfEXT;
  GLuint glPointParameterfvEXT;

  /* GL_EXT_polygon_offset */

  GLuint glPolygonOffsetEXT;

  /* GL_EXT_provoking_vertex */

  GLuint glProvokingVertexEXT;

  /* GL_EXT_robustness */

  GLuint glGetnUniformfvEXT;
  GLuint glGetnUniformivEXT;
  GLuint glReadnPixelsEXT;

  /* GL_EXT_scene_marker */

  GLuint glBeginSceneEXT;
  GLuint glEndSceneEXT;

  /* GL_EXT_secondary_color */

  GLuint glSecondaryColor3bEXT;
  GLuint glSecondaryColor3bvEXT;
  GLuint glSecondaryColor3dEXT;
  GLuint glSecondaryColor3dvEXT;
  GLuint glSecondaryColor3fEXT;
  GLuint glSecondaryColor3fvEXT;
  GLuint glSecondaryColor3iEXT;
  GLuint glSecondaryColor3ivEXT;
  GLuint glSecondaryColor3sEXT;
  GLuint glSecondaryColor3svEXT;
  GLuint glSecondaryColor3ubEXT;
  GLuint glSecondaryColor3ubvEXT;
  GLuint glSecondaryColor3uiEXT;
  GLuint glSecondaryColor3uivEXT;
  GLuint glSecondaryColor3usEXT;
  GLuint glSecondaryColor3usvEXT;
  GLuint glSecondaryColorPointerEXT;

  /* GL_EXT_separate_shader_objects */

  GLuint glActiveProgramEXT;
  GLuint glCreateShaderProgramEXT;
  GLuint glUseShaderProgramEXT;

  /* GL_EXT_shader_image_load_store */

  GLuint glBindImageTextureEXT;
  GLuint glMemoryBarrierEXT;

  /* GL_EXT_stencil_clear_tag */

  GLuint glStencilClearTagEXT;

  /* GL_EXT_stencil_two_side */

  GLuint glActiveStencilFaceEXT;

  /* GL_EXT_subtexture */

  GLuint glTexSubImage1DEXT;
  GLuint glTexSubImage2DEXT;
  GLuint glTexSubImage3DEXT;

  /* GL_EXT_texture3D */

  GLuint glTexImage3DEXT;

  /* GL_EXT_texture_array */

  GLuint glFramebufferTextureLayerEXT;

  /* GL_EXT_texture_buffer_object */

  GLuint glTexBufferEXT;

  /* GL_EXT_texture_integer */

  GLuint glClearColorIiEXT;
  GLuint glClearColorIuiEXT;
  GLuint glGetTexParameterIivEXT;
  GLuint glGetTexParameterIuivEXT;
  GLuint glTexParameterIivEXT;
  GLuint glTexParameterIuivEXT;

  /* GL_EXT_texture_object */

  GLuint glAreTexturesResidentEXT;
  GLuint glBindTextureEXT;
  GLuint glDeleteTexturesEXT;
  GLuint glGenTexturesEXT;
  GLuint glIsTextureEXT;
  GLuint glPrioritizeTexturesEXT;

  /* GL_EXT_texture_perturb_normal */

  GLuint glTextureNormalEXT;

  /* GL_EXT_texture_storage */

  GLuint glTexStorage1DEXT;
  GLuint glTexStorage2DEXT;
  GLuint glTexStorage3DEXT;

  /* GL_EXT_timer_query */

  GLuint glGetQueryObjecti64vEXT;
  GLuint glGetQueryObjectui64vEXT;

  /* GL_EXT_transform_feedback */

  GLuint glBeginTransformFeedbackEXT;
  GLuint glBindBufferBaseEXT;
  GLuint glBindBufferOffsetEXT;
  GLuint glBindBufferRangeEXT;
  GLuint glEndTransformFeedbackEXT;
  GLuint glGetTransformFeedbackVaryingEXT;
  GLuint glTransformFeedbackVaryingsEXT;

  /* GL_EXT_vertex_array */

  GLuint glArrayElementEXT;
  GLuint glColorPointerEXT;
  GLuint glDrawArraysEXT;
  GLuint glEdgeFlagPointerEXT;
  GLuint glGetPointervEXT;
  GLuint glIndexPointerEXT;
  GLuint glNormalPointerEXT;
  GLuint glTexCoordPointerEXT;
  GLuint glVertexPointerEXT;

  /* GL_EXT_vertex_attrib_64bit */

  GLuint glGetVertexAttribLdvEXT;
  GLuint glVertexArrayVertexAttribLOffsetEXT;
  GLuint glVertexAttribL1dEXT;
  GLuint glVertexAttribL1dvEXT;
  GLuint glVertexAttribL2dEXT;
  GLuint glVertexAttribL2dvEXT;
  GLuint glVertexAttribL3dEXT;
  GLuint glVertexAttribL3dvEXT;
  GLuint glVertexAttribL4dEXT;
  GLuint glVertexAttribL4dvEXT;
  GLuint glVertexAttribLPointerEXT;

  /* GL_EXT_vertex_shader */

  GLuint glBeginVertexShaderEXT;
  GLuint glBindLightParameterEXT;
  GLuint glBindMaterialParameterEXT;
  GLuint glBindParameterEXT;
  GLuint glBindTexGenParameterEXT;
  GLuint glBindTextureUnitParameterEXT;
  GLuint glBindVertexShaderEXT;
  GLuint glDeleteVertexShaderEXT;
  GLuint glDisableVariantClientStateEXT;
  GLuint glEnableVariantClientStateEXT;
  GLuint glEndVertexShaderEXT;
  GLuint glExtractComponentEXT;
  GLuint glGenSymbolsEXT;
  GLuint glGenVertexShadersEXT;
  GLuint glGetInvariantBooleanvEXT;
  GLuint glGetInvariantFloatvEXT;
  GLuint glGetInvariantIntegervEXT;
  GLuint glGetLocalConstantBooleanvEXT;
  GLuint glGetLocalConstantFloatvEXT;
  GLuint glGetLocalConstantIntegervEXT;
  GLuint glGetVariantBooleanvEXT;
  GLuint glGetVariantFloatvEXT;
  GLuint glGetVariantIntegervEXT;
  GLuint glGetVariantPointervEXT;
  GLuint glInsertComponentEXT;
  GLuint glIsVariantEnabledEXT;
  GLuint glSetInvariantEXT;
  GLuint glSetLocalConstantEXT;
  GLuint glShaderOp1EXT;
  GLuint glShaderOp2EXT;
  GLuint glShaderOp3EXT;
  GLuint glSwizzleEXT;
  GLuint glVariantPointerEXT;
  GLuint glVariantbvEXT;
  GLuint glVariantdvEXT;
  GLuint glVariantfvEXT;
  GLuint glVariantivEXT;
  GLuint glVariantsvEXT;
  GLuint glVariantubvEXT;
  GLuint glVariantuivEXT;
  GLuint glVariantusvEXT;
  GLuint glWriteMaskEXT;

  /* GL_EXT_vertex_weighting */

  GLuint glVertexWeightPointerEXT;
  GLuint glVertexWeightfEXT;
  GLuint glVertexWeightfvEXT;

  /* GL_EXT_x11_sync_object */

  GLuint glImportSyncEXT;

  /* GL_GREMEDY_frame_terminator */

  GLuint glFrameTerminatorGREMEDY;

  /* GL_GREMEDY_string_marker */

  GLuint glStringMarkerGREMEDY;

  /* GL_HP_image_transform */

  GLuint glGetImageTransformParameterfvHP;
  GLuint glGetImageTransformParameterivHP;
  GLuint glImageTransformParameterfHP;
  GLuint glImageTransformParameterfvHP;
  GLuint glImageTransformParameteriHP;
  GLuint glImageTransformParameterivHP;

  /* GL_IBM_multimode_draw_arrays */

  GLuint glMultiModeDrawArraysIBM;
  GLuint glMultiModeDrawElementsIBM;

  /* GL_IBM_vertex_array_lists */

  GLuint glColorPointerListIBM;
  GLuint glEdgeFlagPointerListIBM;
  GLuint glFogCoordPointerListIBM;
  GLuint glIndexPointerListIBM;
  GLuint glNormalPointerListIBM;
  GLuint glSecondaryColorPointerListIBM;
  GLuint glTexCoordPointerListIBM;
  GLuint glVertexPointerListIBM;

  /* GL_IMG_multisampled_render_to_texture */

  GLuint glFramebufferTexture2DMultisampleIMG;
  GLuint glRenderbufferStorageMultisampleIMG;

  /* GL_INGR_blend_func_separate */

  GLuint glBlendFuncSeparateINGR;

  /* GL_INTEL_map_texture */

  GLuint glMapTexture2DINTEL;
  GLuint glSyncTextureINTEL;
  GLuint glUnmapTexture2DINTEL;

  /* GL_INTEL_parallel_arrays */

  GLuint glColorPointervINTEL;
  GLuint glNormalPointervINTEL;
  GLuint glTexCoordPointervINTEL;
  GLuint glVertexPointervINTEL;

  /* GL_INTEL_texture_scissor */

  GLuint glTexScissorFuncINTEL;
  GLuint glTexScissorINTEL;

  /* GL_KHR_debug */

  GLuint glDebugMessageCallback;
  GLuint glDebugMessageControl;
  GLuint glDebugMessageInsert;
  GLuint glGetDebugMessageLog;
  GLuint glGetObjectLabel;
  GLuint glGetObjectPtrLabel;
  GLuint glObjectLabel;
  GLuint glObjectPtrLabel;
  GLuint glPopDebugGroup;
  GLuint glPushDebugGroup;

  /* GL_KTX_buffer_region */

  GLuint glBufferRegionEnabled;
  GLuint glDeleteBufferRegion;
  GLuint glDrawBufferRegion;
  GLuint glNewBufferRegion;
  GLuint glReadBufferRegion;

  /* GL_MESA_resize_buffers */

  GLuint glResizeBuffersMESA;

  /* GL_MESA_window_pos */

  GLuint glWindowPos2dMESA;
  GLuint glWindowPos2dvMESA;
  GLuint glWindowPos2fMESA;
  GLuint glWindowPos2fvMESA;
  GLuint glWindowPos2iMESA;
  GLuint glWindowPos2ivMESA;
  GLuint glWindowPos2sMESA;
  GLuint glWindowPos2svMESA;
  GLuint glWindowPos3dMESA;
  GLuint glWindowPos3dvMESA;
  GLuint glWindowPos3fMESA;
  GLuint glWindowPos3fvMESA;
  GLuint glWindowPos3iMESA;
  GLuint glWindowPos3ivMESA;
  GLuint glWindowPos3sMESA;
  GLuint glWindowPos3svMESA;
  GLuint glWindowPos4dMESA;
  GLuint glWindowPos4dvMESA;
  GLuint glWindowPos4fMESA;
  GLuint glWindowPos4fvMESA;
  GLuint glWindowPos4iMESA;
  GLuint glWindowPos4ivMESA;
  GLuint glWindowPos4sMESA;
  GLuint glWindowPos4svMESA;

  /* GL_NVX_conditional_render */

  GLuint glBeginConditionalRenderNVX;
  GLuint glEndConditionalRenderNVX;

  /* GL_NV_bindless_texture */

  GLuint glGetImageHandleNV;
  GLuint glGetTextureHandleNV;
  GLuint glGetTextureSamplerHandleNV;
  GLuint glIsImageHandleResidentNV;
  GLuint glIsTextureHandleResidentNV;
  GLuint glMakeImageHandleNonResidentNV;
  GLuint glMakeImageHandleResidentNV;
  GLuint glMakeTextureHandleNonResidentNV;
  GLuint glMakeTextureHandleResidentNV;
  GLuint glProgramUniformHandleui64NV;
  GLuint glProgramUniformHandleui64vNV;
  GLuint glUniformHandleui64NV;
  GLuint glUniformHandleui64vNV;

  /* GL_NV_blend_equation_advanced */

  GLuint glBlendBarrierNV;
  GLuint glBlendParameteriNV;

  /* GL_NV_conditional_render */

  GLuint glBeginConditionalRenderNV;
  GLuint glEndConditionalRenderNV;

  /* GL_NV_copy_buffer */

  GLuint glCopyBufferSubDataNV;

  /* GL_NV_copy_image */

  GLuint glCopyImageSubDataNV;

  /* GL_NV_coverage_sample */

  GLuint glCoverageMaskNV;
  GLuint glCoverageOperationNV;

  /* GL_NV_depth_buffer_float */

  GLuint glClearDepthdNV;
  GLuint glDepthBoundsdNV;
  GLuint glDepthRangedNV;

  /* GL_NV_draw_buffers */

  GLuint glDrawBuffersNV;

  /* GL_NV_draw_texture */

  GLuint glDrawTextureNV;

  /* GL_NV_evaluators */

  GLuint glEvalMapsNV;
  GLuint glGetMapAttribParameterfvNV;
  GLuint glGetMapAttribParameterivNV;
  GLuint glGetMapControlPointsNV;
  GLuint glGetMapParameterfvNV;
  GLuint glGetMapParameterivNV;
  GLuint glMapControlPointsNV;
  GLuint glMapParameterfvNV;
  GLuint glMapParameterivNV;

  /* GL_NV_explicit_multisample */

  GLuint glGetMultisamplefvNV;
  GLuint glSampleMaskIndexedNV;
  GLuint glTexRenderbufferNV;

  /* GL_NV_fence */

  GLuint glDeleteFencesNV;
  GLuint glFinishFenceNV;
  GLuint glGenFencesNV;
  GLuint glGetFenceivNV;
  GLuint glIsFenceNV;
  GLuint glSetFenceNV;
  GLuint glTestFenceNV;

  /* GL_NV_fragment_program */

  GLuint glGetProgramNamedParameterdvNV;
  GLuint glGetProgramNamedParameterfvNV;
  GLuint glProgramNamedParameter4dNV;
  GLuint glProgramNamedParameter4dvNV;
  GLuint glProgramNamedParameter4fNV;
  GLuint glProgramNamedParameter4fvNV;

  /* GL_NV_framebuffer_blit */

  GLuint glBlitFramebufferNV;

  /* GL_NV_framebuffer_multisample_coverage */

  GLuint glRenderbufferStorageMultisampleCoverageNV;

  /* GL_NV_geometry_program4 */

  GLuint glProgramVertexLimitNV;

  /* GL_NV_gpu_program4 */

  GLuint glGetProgramEnvParameterIivNV;
  GLuint glGetProgramEnvParameterIuivNV;
  GLuint glGetProgramLocalParameterIivNV;
  GLuint glGetProgramLocalParameterIuivNV;
  GLuint glProgramEnvParameterI4iNV;
  GLuint glProgramEnvParameterI4ivNV;
  GLuint glProgramEnvParameterI4uiNV;
  GLuint glProgramEnvParameterI4uivNV;
  GLuint glProgramEnvParametersI4ivNV;
  GLuint glProgramEnvParametersI4uivNV;
  GLuint glProgramLocalParameterI4iNV;
  GLuint glProgramLocalParameterI4ivNV;
  GLuint glProgramLocalParameterI4uiNV;
  GLuint glProgramLocalParameterI4uivNV;
  GLuint glProgramLocalParametersI4ivNV;
  GLuint glProgramLocalParametersI4uivNV;

  /* GL_NV_gpu_shader5 */

  GLuint glGetUniformi64vNV;
  GLuint glProgramUniform1i64NV;
  GLuint glProgramUniform1i64vNV;
  GLuint glProgramUniform1ui64NV;
  GLuint glProgramUniform1ui64vNV;
  GLuint glProgramUniform2i64NV;
  GLuint glProgramUniform2i64vNV;
  GLuint glProgramUniform2ui64NV;
  GLuint glProgramUniform2ui64vNV;
  GLuint glProgramUniform3i64NV;
  GLuint glProgramUniform3i64vNV;
  GLuint glProgramUniform3ui64NV;
  GLuint glProgramUniform3ui64vNV;
  GLuint glProgramUniform4i64NV;
  GLuint glProgramUniform4i64vNV;
  GLuint glProgramUniform4ui64NV;
  GLuint glProgramUniform4ui64vNV;
  GLuint glUniform1i64NV;
  GLuint glUniform1i64vNV;
  GLuint glUniform1ui64NV;
  GLuint glUniform1ui64vNV;
  GLuint glUniform2i64NV;
  GLuint glUniform2i64vNV;
  GLuint glUniform2ui64NV;
  GLuint glUniform2ui64vNV;
  GLuint glUniform3i64NV;
  GLuint glUniform3i64vNV;
  GLuint glUniform3ui64NV;
  GLuint glUniform3ui64vNV;
  GLuint glUniform4i64NV;
  GLuint glUniform4i64vNV;
  GLuint glUniform4ui64NV;
  GLuint glUniform4ui64vNV;

  /* GL_NV_half_float */

  GLuint glColor3hNV;
  GLuint glColor3hvNV;
  GLuint glColor4hNV;
  GLuint glColor4hvNV;
  GLuint glFogCoordhNV;
  GLuint glFogCoordhvNV;
  GLuint glMultiTexCoord1hNV;
  GLuint glMultiTexCoord1hvNV;
  GLuint glMultiTexCoord2hNV;
  GLuint glMultiTexCoord2hvNV;
  GLuint glMultiTexCoord3hNV;
  GLuint glMultiTexCoord3hvNV;
  GLuint glMultiTexCoord4hNV;
  GLuint glMultiTexCoord4hvNV;
  GLuint glNormal3hNV;
  GLuint glNormal3hvNV;
  GLuint glSecondaryColor3hNV;
  GLuint glSecondaryColor3hvNV;
  GLuint glTexCoord1hNV;
  GLuint glTexCoord1hvNV;
  GLuint glTexCoord2hNV;
  GLuint glTexCoord2hvNV;
  GLuint glTexCoord3hNV;
  GLuint glTexCoord3hvNV;
  GLuint glTexCoord4hNV;
  GLuint glTexCoord4hvNV;
  GLuint glVertex2hNV;
  GLuint glVertex2hvNV;
  GLuint glVertex3hNV;
  GLuint glVertex3hvNV;
  GLuint glVertex4hNV;
  GLuint glVertex4hvNV;
  GLuint glVertexAttrib1hNV;
  GLuint glVertexAttrib1hvNV;
  GLuint glVertexAttrib2hNV;
  GLuint glVertexAttrib2hvNV;
  GLuint glVertexAttrib3hNV;
  GLuint glVertexAttrib3hvNV;
  GLuint glVertexAttrib4hNV;
  GLuint glVertexAttrib4hvNV;
  GLuint glVertexAttribs1hvNV;
  GLuint glVertexAttribs2hvNV;
  GLuint glVertexAttribs3hvNV;
  GLuint glVertexAttribs4hvNV;
  GLuint glVertexWeighthNV;
  GLuint glVertexWeighthvNV;

  /* GL_NV_non_square_matrices */

  GLuint glUniformMatrix2x3fvNV;
  GLuint glUniformMatrix2x4fvNV;
  GLuint glUniformMatrix3x2fvNV;
  GLuint glUniformMatrix3x4fvNV;
  GLuint glUniformMatrix4x2fvNV;
  GLuint glUniformMatrix4x3fvNV;

  /* GL_NV_occlusion_query */

  GLuint glBeginOcclusionQueryNV;
  GLuint glDeleteOcclusionQueriesNV;
  GLuint glEndOcclusionQueryNV;
  GLuint glGenOcclusionQueriesNV;
  GLuint glGetOcclusionQueryivNV;
  GLuint glGetOcclusionQueryuivNV;
  GLuint glIsOcclusionQueryNV;

  /* GL_NV_parameter_buffer_object */

  GLuint glProgramBufferParametersIivNV;
  GLuint glProgramBufferParametersIuivNV;
  GLuint glProgramBufferParametersfvNV;

  /* GL_NV_path_rendering */

  GLuint glCopyPathNV;
  GLuint glCoverFillPathInstancedNV;
  GLuint glCoverFillPathNV;
  GLuint glCoverStrokePathInstancedNV;
  GLuint glCoverStrokePathNV;
  GLuint glDeletePathsNV;
  GLuint glGenPathsNV;
  GLuint glGetPathColorGenfvNV;
  GLuint glGetPathColorGenivNV;
  GLuint glGetPathCommandsNV;
  GLuint glGetPathCoordsNV;
  GLuint glGetPathDashArrayNV;
  GLuint glGetPathLengthNV;
  GLuint glGetPathMetricRangeNV;
  GLuint glGetPathMetricsNV;
  GLuint glGetPathParameterfvNV;
  GLuint glGetPathParameterivNV;
  GLuint glGetPathSpacingNV;
  GLuint glGetPathTexGenfvNV;
  GLuint glGetPathTexGenivNV;
  GLuint glInterpolatePathsNV;
  GLuint glIsPathNV;
  GLuint glIsPointInFillPathNV;
  GLuint glIsPointInStrokePathNV;
  GLuint glPathColorGenNV;
  GLuint glPathCommandsNV;
  GLuint glPathCoordsNV;
  GLuint glPathCoverDepthFuncNV;
  GLuint glPathDashArrayNV;
  GLuint glPathFogGenNV;
  GLuint glPathGlyphRangeNV;
  GLuint glPathGlyphsNV;
  GLuint glPathParameterfNV;
  GLuint glPathParameterfvNV;
  GLuint glPathParameteriNV;
  GLuint glPathParameterivNV;
  GLuint glPathStencilDepthOffsetNV;
  GLuint glPathStencilFuncNV;
  GLuint glPathStringNV;
  GLuint glPathSubCommandsNV;
  GLuint glPathSubCoordsNV;
  GLuint glPathTexGenNV;
  GLuint glPointAlongPathNV;
  GLuint glStencilFillPathInstancedNV;
  GLuint glStencilFillPathNV;
  GLuint glStencilStrokePathInstancedNV;
  GLuint glStencilStrokePathNV;
  GLuint glTransformPathNV;
  GLuint glWeightPathsNV;

  /* GL_NV_pixel_data_range */

  GLuint glFlushPixelDataRangeNV;
  GLuint glPixelDataRangeNV;

  /* GL_NV_point_sprite */

  GLuint glPointParameteriNV;
  GLuint glPointParameterivNV;

  /* GL_NV_present_video */

  GLuint glGetVideoi64vNV;
  GLuint glGetVideoivNV;
  GLuint glGetVideoui64vNV;
  GLuint glGetVideouivNV;
  GLuint glPresentFrameDualFillNV;
  GLuint glPresentFrameKeyedNV;

  /* GL_NV_primitive_restart */

  GLuint glPrimitiveRestartIndexNV;
  GLuint glPrimitiveRestartNV;

  /* GL_NV_read_buffer */

  GLuint glReadBufferNV;

  /* GL_NV_register_combiners */

  GLuint glCombinerInputNV;
  GLuint glCombinerOutputNV;
  GLuint glCombinerParameterfNV;
  GLuint glCombinerParameterfvNV;
  GLuint glCombinerParameteriNV;
  GLuint glCombinerParameterivNV;
  GLuint glFinalCombinerInputNV;
  GLuint glGetCombinerInputParameterfvNV;
  GLuint glGetCombinerInputParameterivNV;
  GLuint glGetCombinerOutputParameterfvNV;
  GLuint glGetCombinerOutputParameterivNV;
  GLuint glGetFinalCombinerInputParameterfvNV;
  GLuint glGetFinalCombinerInputParameterivNV;

  /* GL_NV_register_combiners2 */

  GLuint glCombinerStageParameterfvNV;
  GLuint glGetCombinerStageParameterfvNV;

  /* GL_NV_shader_buffer_load */

  GLuint glGetBufferParameterui64vNV;
  GLuint glGetIntegerui64vNV;
  GLuint glGetNamedBufferParameterui64vNV;
  GLuint glGetUniformui64vNV;
  GLuint glIsBufferResidentNV;
  GLuint glIsNamedBufferResidentNV;
  GLuint glMakeBufferNonResidentNV;
  GLuint glMakeBufferResidentNV;
  GLuint glMakeNamedBufferNonResidentNV;
  GLuint glMakeNamedBufferResidentNV;
  GLuint glProgramUniformui64NV;
  GLuint glProgramUniformui64vNV;
  GLuint glUniformui64NV;
  GLuint glUniformui64vNV;

  /* GL_NV_texture_barrier */

  GLuint glTextureBarrierNV;

  /* GL_NV_texture_multisample */

  GLuint glTexImage2DMultisampleCoverageNV;
  GLuint glTexImage3DMultisampleCoverageNV;
  GLuint glTextureImage2DMultisampleCoverageNV;
  GLuint glTextureImage2DMultisampleNV;
  GLuint glTextureImage3DMultisampleCoverageNV;
  GLuint glTextureImage3DMultisampleNV;

  /* GL_NV_transform_feedback */

  GLuint glActiveVaryingNV;
  GLuint glBeginTransformFeedbackNV;
  GLuint glBindBufferBaseNV;
  GLuint glBindBufferOffsetNV;
  GLuint glBindBufferRangeNV;
  GLuint glEndTransformFeedbackNV;
  GLuint glGetActiveVaryingNV;
  GLuint glGetTransformFeedbackVaryingNV;
  GLuint glGetVaryingLocationNV;
  GLuint glTransformFeedbackAttribsNV;
  GLuint glTransformFeedbackVaryingsNV;

  /* GL_NV_transform_feedback2 */

  GLuint glBindTransformFeedbackNV;
  GLuint glDeleteTransformFeedbacksNV;
  GLuint glDrawTransformFeedbackNV;
  GLuint glGenTransformFeedbacksNV;
  GLuint glIsTransformFeedbackNV;
  GLuint glPauseTransformFeedbackNV;
  GLuint glResumeTransformFeedbackNV;

  /* GL_NV_vdpau_interop */

  GLuint glVDPAUFiniNV;
  GLuint glVDPAUGetSurfaceivNV;
  GLuint glVDPAUInitNV;
  GLuint glVDPAUIsSurfaceNV;
  GLuint glVDPAUMapSurfacesNV;
  GLuint glVDPAURegisterOutputSurfaceNV;
  GLuint glVDPAURegisterVideoSurfaceNV;
  GLuint glVDPAUSurfaceAccessNV;
  GLuint glVDPAUUnmapSurfacesNV;
  GLuint glVDPAUUnregisterSurfaceNV;

  /* GL_NV_vertex_array_range */

  GLuint glFlushVertexArrayRangeNV;
  GLuint glVertexArrayRangeNV;

  /* GL_NV_vertex_attrib_integer_64bit */

  GLuint glGetVertexAttribLi64vNV;
  GLuint glGetVertexAttribLui64vNV;
  GLuint glVertexAttribL1i64NV;
  GLuint glVertexAttribL1i64vNV;
  GLuint glVertexAttribL1ui64NV;
  GLuint glVertexAttribL1ui64vNV;
  GLuint glVertexAttribL2i64NV;
  GLuint glVertexAttribL2i64vNV;
  GLuint glVertexAttribL2ui64NV;
  GLuint glVertexAttribL2ui64vNV;
  GLuint glVertexAttribL3i64NV;
  GLuint glVertexAttribL3i64vNV;
  GLuint glVertexAttribL3ui64NV;
  GLuint glVertexAttribL3ui64vNV;
  GLuint glVertexAttribL4i64NV;
  GLuint glVertexAttribL4i64vNV;
  GLuint glVertexAttribL4ui64NV;
  GLuint glVertexAttribL4ui64vNV;
  GLuint glVertexAttribLFormatNV;

  /* GL_NV_vertex_buffer_unified_memory */

  GLuint glBufferAddressRangeNV;
  GLuint glColorFormatNV;
  GLuint glEdgeFlagFormatNV;
  GLuint glFogCoordFormatNV;
  GLuint glGetIntegerui64i_vNV;
  GLuint glIndexFormatNV;
  GLuint glNormalFormatNV;
  GLuint glSecondaryColorFormatNV;
  GLuint glTexCoordFormatNV;
  GLuint glVertexAttribFormatNV;
  GLuint glVertexAttribIFormatNV;
  GLuint glVertexFormatNV;

  /* GL_NV_vertex_program */

  GLuint glAreProgramsResidentNV;
  GLuint glBindProgramNV;
  GLuint glDeleteProgramsNV;
  GLuint glExecuteProgramNV;
  GLuint glGenProgramsNV;
  GLuint glGetProgramParameterdvNV;
  GLuint glGetProgramParameterfvNV;
  GLuint glGetProgramStringNV;
  GLuint glGetProgramivNV;
  GLuint glGetTrackMatrixivNV;
  GLuint glGetVertexAttribPointervNV;
  GLuint glGetVertexAttribdvNV;
  GLuint glGetVertexAttribfvNV;
  GLuint glGetVertexAttribivNV;
  GLuint glIsProgramNV;
  GLuint glLoadProgramNV;
  GLuint glProgramParameter4dNV;
  GLuint glProgramParameter4dvNV;
  GLuint glProgramParameter4fNV;
  GLuint glProgramParameter4fvNV;
  GLuint glProgramParameters4dvNV;
  GLuint glProgramParameters4fvNV;
  GLuint glRequestResidentProgramsNV;
  GLuint glTrackMatrixNV;
  GLuint glVertexAttrib1dNV;
  GLuint glVertexAttrib1dvNV;
  GLuint glVertexAttrib1fNV;
  GLuint glVertexAttrib1fvNV;
  GLuint glVertexAttrib1sNV;
  GLuint glVertexAttrib1svNV;
  GLuint glVertexAttrib2dNV;
  GLuint glVertexAttrib2dvNV;
  GLuint glVertexAttrib2fNV;
  GLuint glVertexAttrib2fvNV;
  GLuint glVertexAttrib2sNV;
  GLuint glVertexAttrib2svNV;
  GLuint glVertexAttrib3dNV;
  GLuint glVertexAttrib3dvNV;
  GLuint glVertexAttrib3fNV;
  GLuint glVertexAttrib3fvNV;
  GLuint glVertexAttrib3sNV;
  GLuint glVertexAttrib3svNV;
  GLuint glVertexAttrib4dNV;
  GLuint glVertexAttrib4dvNV;
  GLuint glVertexAttrib4fNV;
  GLuint glVertexAttrib4fvNV;
  GLuint glVertexAttrib4sNV;
  GLuint glVertexAttrib4svNV;
  GLuint glVertexAttrib4ubNV;
  GLuint glVertexAttrib4ubvNV;
  GLuint glVertexAttribPointerNV;
  GLuint glVertexAttribs1dvNV;
  GLuint glVertexAttribs1fvNV;
  GLuint glVertexAttribs1svNV;
  GLuint glVertexAttribs2dvNV;
  GLuint glVertexAttribs2fvNV;
  GLuint glVertexAttribs2svNV;
  GLuint glVertexAttribs3dvNV;
  GLuint glVertexAttribs3fvNV;
  GLuint glVertexAttribs3svNV;
  GLuint glVertexAttribs4dvNV;
  GLuint glVertexAttribs4fvNV;
  GLuint glVertexAttribs4svNV;
  GLuint glVertexAttribs4ubvNV;

  /* GL_NV_video_capture */

  GLuint glBeginVideoCaptureNV;
  GLuint glBindVideoCaptureStreamBufferNV;
  GLuint glBindVideoCaptureStreamTextureNV;
  GLuint glEndVideoCaptureNV;
  GLuint glGetVideoCaptureStreamdvNV;
  GLuint glGetVideoCaptureStreamfvNV;
  GLuint glGetVideoCaptureStreamivNV;
  GLuint glGetVideoCaptureivNV;
  GLuint glVideoCaptureNV;
  GLuint glVideoCaptureStreamParameterdvNV;
  GLuint glVideoCaptureStreamParameterfvNV;
  GLuint glVideoCaptureStreamParameterivNV;

  /* GL_OES_blend_equation_separate */

  GLuint glBlendEquationSeparateOES;

  /* GL_OES_blend_func_separate */

  GLuint glBlendFuncSeparateOES;

  /* GL_OES_blend_subtract */

  GLuint glBlendEquationOES;

  /* GL_OES_framebuffer_object */

  GLuint glBindFramebufferOES;
  GLuint glBindRenderbufferOES;
  GLuint glCheckFramebufferStatusOES;
  GLuint glDeleteFramebuffersOES;
  GLuint glDeleteRenderbuffersOES;
  GLuint glFramebufferRenderbufferOES;
  GLuint glFramebufferTexture2DOES;
  GLuint glGenFramebuffersOES;
  GLuint glGenRenderbuffersOES;
  GLuint glGenerateMipmapOES;
  GLuint glGetFramebufferAttachmentParameterivOES;
  GLuint glGetRenderbufferParameterivOES;
  GLuint glIsFramebufferOES;
  GLuint glIsRenderbufferOES;
  GLuint glRenderbufferStorageOES;

  /* GL_OES_get_program_binary */

  GLuint glGetProgramBinaryOES;
  GLuint glProgramBinaryOES;

  /* GL_OES_mapbuffer */

  GLuint glGetBufferPointervOES;
  GLuint glMapBufferOES;
  GLuint glUnmapBufferOES;

  /* GL_OES_matrix_palette */

  GLuint glCurrentPaletteMatrixOES;
  GLuint glMatrixIndexPointerOES;
  GLuint glWeightPointerOES;

  /* GL_OES_single_precision */

  GLuint glClearDepthfOES;
  GLuint glClipPlanefOES;
  GLuint glDepthRangefOES;
  GLuint glFrustumfOES;
  GLuint glGetClipPlanefOES;
  GLuint glOrthofOES;

  /* GL_OES_texture_3D */

  GLuint glCompressedTexImage3DOES;
  GLuint glCompressedTexSubImage3DOES;
  GLuint glCopyTexSubImage3DOES;
  GLuint glFramebufferTexture3DOES;
  GLuint glTexImage3DOES;
  GLuint glTexSubImage3DOES;

  /* GL_OES_texture_cube_map */

  GLuint glGetTexGenfvOES;
  GLuint glGetTexGenivOES;
  GLuint glGetTexGenxvOES;
  GLuint glTexGenfOES;
  GLuint glTexGenfvOES;
  GLuint glTexGeniOES;
  GLuint glTexGenivOES;
  GLuint glTexGenxOES;
  GLuint glTexGenxvOES;

  /* GL_OES_vertex_array_object */

  GLuint glBindVertexArrayOES;
  GLuint glDeleteVertexArraysOES;
  GLuint glGenVertexArraysOES;
  GLuint glIsVertexArrayOES;

  /* GL_PGI_misc_hints */

  GLuint glHintPGI;

  /* GL_QCOM_alpha_test */

  GLuint glAlphaFuncQCOM;

  /* GL_QCOM_driver_control */

  GLuint glDisableDriverControlQCOM;
  GLuint glEnableDriverControlQCOM;
  GLuint glGetDriverControlStringQCOM;
  GLuint glGetDriverControlsQCOM;

  /* GL_QCOM_extended_get */

  GLuint glExtGetBufferPointervQCOM;
  GLuint glExtGetBuffersQCOM;
  GLuint glExtGetFramebuffersQCOM;
  GLuint glExtGetRenderbuffersQCOM;
  GLuint glExtGetTexLevelParameterivQCOM;
  GLuint glExtGetTexSubImageQCOM;
  GLuint glExtGetTexturesQCOM;
  GLuint glExtTexObjectStateOverrideiQCOM;

  /* GL_QCOM_extended_get2 */

  GLuint glExtGetProgramBinarySourceQCOM;
  GLuint glExtGetProgramsQCOM;
  GLuint glExtGetShadersQCOM;
  GLuint glExtIsProgramBinaryQCOM;

  /* GL_QCOM_tiled_rendering */

  GLuint glEndTilingQCOM;
  GLuint glStartTilingQCOM;

  /* GL_REGAL_ES1_0_compatibility */

  GLuint glAlphaFuncx;
  GLuint glClearColorx;
  GLuint glClearDepthx;
  GLuint glColor4x;
  GLuint glDepthRangex;
  GLuint glFogx;
  GLuint glFogxv;
  GLuint glFrustumf;
  GLuint glFrustumx;
  GLuint glLightModelx;
  GLuint glLightModelxv;
  GLuint glLightx;
  GLuint glLightxv;
  GLuint glLineWidthx;
  GLuint glLoadMatrixx;
  GLuint glMaterialx;
  GLuint glMaterialxv;
  GLuint glMultMatrixx;
  GLuint glMultiTexCoord4x;
  GLuint glNormal3x;
  GLuint glOrthof;
  GLuint glOrthox;
  GLuint glPointSizex;
  GLuint glPolygonOffsetx;
  GLuint glRotatex;
  GLuint glSampleCoveragex;
  GLuint glScalex;
  GLuint glTexEnvx;
  GLuint glTexEnvxv;
  GLuint glTexParameterx;
  GLuint glTranslatex;

  /* GL_REGAL_ES1_1_compatibility */

  GLuint glClipPlanef;
  GLuint glClipPlanex;
  GLuint glGetClipPlanef;
  GLuint glGetClipPlanex;
  GLuint glGetFixedv;
  GLuint glGetLightxv;
  GLuint glGetMaterialxv;
  GLuint glGetTexEnvxv;
  GLuint glGetTexParameterxv;
  GLuint glPointParameterx;
  GLuint glPointParameterxv;
  GLuint glPointSizePointerOES;
  GLuint glTexParameterxv;

  /* GL_REGAL_log */

  GLuint glLogMessageCallbackREGAL;

  /* GL_SGIS_detail_texture */

  GLuint glDetailTexFuncSGIS;
  GLuint glGetDetailTexFuncSGIS;

  /* GL_SGIS_fog_function */

  GLuint glFogFuncSGIS;
  GLuint glGetFogFuncSGIS;

  /* GL_SGIS_multisample */

  GLuint glSampleMaskSGIS;
  GLuint glSamplePatternSGIS;

  /* GL_SGIS_pixel_texture */

  GLuint glGetPixelTexGenParameterfvSGIS;
  GLuint glGetPixelTexGenParameterivSGIS;
  GLuint glPixelTexGenParameterfSGIS;
  GLuint glPixelTexGenParameterfvSGIS;
  GLuint glPixelTexGenParameteriSGIS;
  GLuint glPixelTexGenParameterivSGIS;

  /* GL_SGIS_point_parameters */

  GLuint glPointParameterfSGIS;
  GLuint glPointParameterfvSGIS;

  /* GL_SGIS_sharpen_texture */

  GLuint glGetSharpenTexFuncSGIS;
  GLuint glSharpenTexFuncSGIS;

  /* GL_SGIS_texture4D */

  GLuint glTexImage4DSGIS;
  GLuint glTexSubImage4DSGIS;

  /* GL_SGIS_texture_color_mask */

  GLuint glTextureColorMaskSGIS;

  /* GL_SGIS_texture_filter4 */

  GLuint glGetTexFilterFuncSGIS;
  GLuint glTexFilterFuncSGIS;

  /* GL_SGIX_async */

  GLuint glAsyncMarkerSGIX;
  GLuint glDeleteAsyncMarkersSGIX;
  GLuint glFinishAsyncSGIX;
  GLuint glGenAsyncMarkersSGIX;
  GLuint glIsAsyncMarkerSGIX;
  GLuint glPollAsyncSGIX;

  /* GL_SGIX_flush_raster */

  GLuint glFlushRasterSGIX;

  /* GL_SGIX_fog_texture */

  GLuint glTextureFogSGIX;

  /* GL_SGIX_fragment_lighting */

  GLuint glFragmentColorMaterialSGIX;
  GLuint glFragmentLightModelfSGIX;
  GLuint glFragmentLightModelfvSGIX;
  GLuint glFragmentLightModeliSGIX;
  GLuint glFragmentLightModelivSGIX;
  GLuint glFragmentLightfSGIX;
  GLuint glFragmentLightfvSGIX;
  GLuint glFragmentLightiSGIX;
  GLuint glFragmentLightivSGIX;
  GLuint glFragmentMaterialfSGIX;
  GLuint glFragmentMaterialfvSGIX;
  GLuint glFragmentMaterialiSGIX;
  GLuint glFragmentMaterialivSGIX;
  GLuint glGetFragmentLightfvSGIX;
  GLuint glGetFragmentLightivSGIX;
  GLuint glGetFragmentMaterialfvSGIX;
  GLuint glGetFragmentMaterialivSGIX;
  GLuint glLightEnviSGIX;

  /* GL_SGIX_framezoom */

  GLuint glFrameZoomSGIX;

  /* GL_SGIX_igloo_interface */

  GLuint glIglooInterfaceSGIX;

  /* GL_SGIX_instruments */

  GLuint glGetInstrumentsSGIX;
  GLuint glInstrumentsBufferSGIX;
  GLuint glPollInstrumentsSGIX;
  GLuint glReadInstrumentsSGIX;
  GLuint glStartInstrumentsSGIX;
  GLuint glStopInstrumentsSGIX;

  /* GL_SGIX_list_priority */

  GLuint glGetListParameterfvSGIX;
  GLuint glGetListParameterivSGIX;
  GLuint glListParameterfSGIX;
  GLuint glListParameterfvSGIX;
  GLuint glListParameteriSGIX;
  GLuint glListParameterivSGIX;

  /* GL_SGIX_pixel_texture */

  GLuint glPixelTexGenSGIX;

  /* GL_SGIX_polynomial_ffd */

  GLuint glDeformSGIX;
  GLuint glDeformationMap3dSGIX;
  GLuint glDeformationMap3fSGIX;
  GLuint glLoadIdentityDeformationMapSGIX;

  /* GL_SGIX_reference_plane */

  GLuint glReferencePlaneSGIX;

  /* GL_SGIX_sprite */

  GLuint glSpriteParameterfSGIX;
  GLuint glSpriteParameterfvSGIX;
  GLuint glSpriteParameteriSGIX;
  GLuint glSpriteParameterivSGIX;

  /* GL_SGIX_tag_sample_buffer */

  GLuint glTagSampleBufferSGIX;

  /* GL_SGI_color_table */

  GLuint glColorTableParameterfvSGI;
  GLuint glColorTableParameterivSGI;
  GLuint glColorTableSGI;
  GLuint glCopyColorTableSGI;
  GLuint glGetColorTableParameterfvSGI;
  GLuint glGetColorTableParameterivSGI;
  GLuint glGetColorTableSGI;

  /* GL_SUNX_constant_data */

  GLuint glFinishTextureSUNX;

  /* GL_SUN_global_alpha */

  GLuint glGlobalAlphaFactorbSUN;
  GLuint glGlobalAlphaFactordSUN;
  GLuint glGlobalAlphaFactorfSUN;
  GLuint glGlobalAlphaFactoriSUN;
  GLuint glGlobalAlphaFactorsSUN;
  GLuint glGlobalAlphaFactorubSUN;
  GLuint glGlobalAlphaFactoruiSUN;
  GLuint glGlobalAlphaFactorusSUN;

  /* GL_SUN_mesh_array */

  GLuint glDrawMeshArraysSUN;

  /* GL_SUN_read_video_pixels */

  GLuint glReadVideoPixelsSUN;

  /* GL_SUN_triangle_list */

  GLuint glReplacementCodePointerSUN;
  GLuint glReplacementCodeubSUN;
  GLuint glReplacementCodeubvSUN;
  GLuint glReplacementCodeuiSUN;
  GLuint glReplacementCodeuivSUN;
  GLuint glReplacementCodeusSUN;
  GLuint glReplacementCodeusvSUN;

  /* GL_SUN_vertex */

  GLuint glColor3fVertex3fSUN;
  GLuint glColor3fVertex3fvSUN;
  GLuint glColor4fNormal3fVertex3fSUN;
  GLuint glColor4fNormal3fVertex3fvSUN;
  GLuint glColor4ubVertex2fSUN;
  GLuint glColor4ubVertex2fvSUN;
  GLuint glColor4ubVertex3fSUN;
  GLuint glColor4ubVertex3fvSUN;
  GLuint glNormal3fVertex3fSUN;
  GLuint glNormal3fVertex3fvSUN;
  GLuint glReplacementCodeuiColor3fVertex3fSUN;
  GLuint glReplacementCodeuiColor3fVertex3fvSUN;
  GLuint glReplacementCodeuiColor4fNormal3fVertex3fSUN;
  GLuint glReplacementCodeuiColor4fNormal3fVertex3fvSUN;
  GLuint glReplacementCodeuiColor4ubVertex3fSUN;
  GLuint glReplacementCodeuiColor4ubVertex3fvSUN;
  GLuint glReplacementCodeuiNormal3fVertex3fSUN;
  GLuint glReplacementCodeuiNormal3fVertex3fvSUN;
  GLuint glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fSUN;
  GLuint glReplacementCodeuiTexCoord2fColor4fNormal3fVertex3fvSUN;
  GLuint glReplacementCodeuiTexCoord2fNormal3fVertex3fSUN;
  GLuint glReplacementCodeuiTexCoord2fNormal3fVertex3fvSUN;
  GLuint glReplacementCodeuiTexCoord2fVertex3fSUN;
  GLuint glReplacementCodeuiTexCoord2fVertex3fvSUN;
  GLuint glReplacementCodeuiVertex3fSUN;
  GLuint glReplacementCodeuiVertex3fvSUN;
  GLuint glTexCoord2fColor3fVertex3fSUN;
  GLuint glTexCoord2fColor3fVertex3fvSUN;
  GLuint glTexCoord2fColor4fNormal3fVertex3fSUN;
  GLuint glTexCoord2fColor4fNormal3fVertex3fvSUN;
  GLuint glTexCoord2fColor4ubVertex3fSUN;
  GLuint glTexCoord2fColor4ubVertex3fvSUN;
  GLuint glTexCoord2fNormal3fVertex3fSUN;
  GLuint glTexCoord2fNormal3fVertex3fvSUN;
  GLuint glTexCoord2fVertex3fSUN;
  GLuint glTexCoord2fVertex3fvSUN;
  GLuint glTexCoord4fColor4fNormal3fVertex4fSUN;
  GLuint glTexCoord4fColor4fNormal3fVertex4fvSUN;
  GLuint glTexCoord4fVertex4fSUN;
  GLuint glTexCoord4fVertex4fvSUN;

  /* GL_WIN_swap_hint */

  GLuint glAddSwapHintRectWIN;

#if REGAL_SYS_WGL

  /* WGL_3DL_stereo_control */

  GLuint wglSetStereoEmitterState3DL;

  /* WGL_AMD_gpu_association */

  GLuint wglBlitContextFramebufferAMD;
  GLuint wglCreateAssociatedContextAMD;
  GLuint wglCreateAssociatedContextAttribsAMD;
  GLuint wglDeleteAssociatedContextAMD;
  GLuint wglGetContextGPUIDAMD;
  GLuint wglGetCurrentAssociatedContextAMD;
  GLuint wglGetGPUIDsAMD;
  GLuint wglGetGPUInfoAMD;
  GLuint wglMakeAssociatedContextCurrentAMD;

  /* WGL_ARB_buffer_region */

  GLuint wglCreateBufferRegionARB;
  GLuint wglDeleteBufferRegionARB;
  GLuint wglRestoreBufferRegionARB;
  GLuint wglSaveBufferRegionARB;

  /* WGL_ARB_create_context */

  GLuint wglCreateContextAttribsARB;

  /* WGL_ARB_extensions_string */

  GLuint wglGetExtensionsStringARB;

  /* WGL_ARB_make_current_read */

  GLuint wglGetCurrentReadDCARB;
  GLuint wglMakeContextCurrentARB;

  /* WGL_ARB_pbuffer */

  GLuint wglCreatePbufferARB;
  GLuint wglDestroyPbufferARB;
  GLuint wglGetPbufferDCARB;
  GLuint wglQueryPbufferARB;
  GLuint wglReleasePbufferDCARB;

  /* WGL_ARB_pixel_format */

  GLuint wglChoosePixelFormatARB;
  GLuint wglGetPixelFormatAttribfvARB;
  GLuint wglGetPixelFormatAttribivARB;

  /* WGL_ARB_render_texture */

  GLuint wglBindTexImageARB;
  GLuint wglReleaseTexImageARB;
  GLuint wglSetPbufferAttribARB;

  /* WGL_EXT_display_color_table */

  GLuint wglBindDisplayColorTableEXT;
  GLuint wglCreateDisplayColorTableEXT;
  GLuint wglDestroyDisplayColorTableEXT;
  GLuint wglLoadDisplayColorTableEXT;

  /* WGL_EXT_extensions_string */

  GLuint wglGetExtensionsStringEXT;

  /* WGL_EXT_make_current_read */

  GLuint wglGetCurrentReadDCEXT;
  GLuint wglMakeContextCurrentEXT;

  /* WGL_EXT_pbuffer */

  GLuint wglCreatePbufferEXT;
  GLuint wglDestroyPbufferEXT;
  GLuint wglGetPbufferDCEXT;
  GLuint wglQueryPbufferEXT;
  GLuint wglReleasePbufferDCEXT;

  /* WGL_EXT_pixel_format */

  GLuint wglChoosePixelFormatEXT;
  GLuint wglGetPixelFormatAttribfvEXT;
  GLuint wglGetPixelFormatAttribivEXT;

  /* WGL_EXT_swap_control */

  GLuint wglGetSwapIntervalEXT;
  GLuint wglSwapIntervalEXT;

  /* WGL_GDI */

  GLuint wglChoosePixelFormat;
  GLuint wglDescribePixelFormat;
  GLuint wglGetPixelFormat;
  GLuint wglSetPixelFormat;
  GLuint wglSwapBuffers;

  /* WGL_I3D_digital_video_control */

  GLuint wglGetDigitalVideoParametersI3D;
  GLuint wglSetDigitalVideoParametersI3D;

  /* WGL_I3D_gamma */

  GLuint wglGetGammaTableI3D;
  GLuint wglGetGammaTableParametersI3D;
  GLuint wglSetGammaTableI3D;
  GLuint wglSetGammaTableParametersI3D;

  /* WGL_I3D_genlock */

  GLuint wglDisableGenlockI3D;
  GLuint wglEnableGenlockI3D;
  GLuint wglGenlockSampleRateI3D;
  GLuint wglGenlockSourceDelayI3D;
  GLuint wglGenlockSourceEdgeI3D;
  GLuint wglGenlockSourceI3D;
  GLuint wglGetGenlockSampleRateI3D;
  GLuint wglGetGenlockSourceDelayI3D;
  GLuint wglGetGenlockSourceEdgeI3D;
  GLuint wglGetGenlockSourceI3D;
  GLuint wglIsEnabledGenlockI3D;
  GLuint wglQueryGenlockMaxSourceDelayI3D;

  /* WGL_I3D_image_buffer */

  GLuint wglAssociateImageBufferEventsI3D;
  GLuint wglCreateImageBufferI3D;
  GLuint wglDestroyImageBufferI3D;
  GLuint wglReleaseImageBufferEventsI3D;

  /* WGL_I3D_swap_frame_lock */

  GLuint wglDisableFrameLockI3D;
  GLuint wglEnableFrameLockI3D;
  GLuint wglIsEnabledFrameLockI3D;
  GLuint wglQueryFrameLockMasterI3D;

  /* WGL_I3D_swap_frame_usage */

  GLuint wglBeginFrameTrackingI3D;
  GLuint wglEndFrameTrackingI3D;
  GLuint wglGetFrameUsageI3D;
  GLuint wglQueryFrameTrackingI3D;

  /* WGL_NV_DX_interop */

  GLuint wglDXCloseDeviceNV;
  GLuint wglDXLockObjectsNV;
  GLuint wglDXObjectAccessNV;
  GLuint wglDXOpenDeviceNV;
  GLuint wglDXRegisterObjectNV;
  GLuint wglDXSetResourceShareHandleNV;
  GLuint wglDXUnlockObjectsNV;
  GLuint wglDXUnregisterObjectNV;

  /* WGL_NV_copy_image */

  GLuint wglCopyImageSubDataNV;

  /* WGL_NV_gpu_affinity */

  GLuint wglCreateAffinityDCNV;
  GLuint wglDeleteDCNV;
  GLuint wglEnumGpuDevicesNV;
  GLuint wglEnumGpusFromAffinityDCNV;
  GLuint wglEnumGpusNV;

  /* WGL_NV_present_video */

  GLuint wglBindVideoDeviceNV;
  GLuint wglEnumerateVideoDevicesNV;
  GLuint wglQueryCurrentContextNV;

  /* WGL_NV_swap_group */

  GLuint wglBindSwapBarrierNV;
  GLuint wglJoinSwapGroupNV;
  GLuint wglQueryFrameCountNV;
  GLuint wglQueryMaxSwapGroupsNV;
  GLuint wglQuerySwapGroupNV;
  GLuint wglResetFrameCountNV;

  /* WGL_NV_vertex_array_range */

  GLuint wglAllocateMemoryNV;
  GLuint wglFreeMemoryNV;

  /* WGL_NV_video_capture */

  GLuint wglBindVideoCaptureDeviceNV;
  GLuint wglEnumerateVideoCaptureDevicesNV;
  GLuint wglLockVideoCaptureDeviceNV;
  GLuint wglQueryVideoCaptureDeviceNV;
  GLuint wglReleaseVideoCaptureDeviceNV;

  /* WGL_NV_video_output */

  GLuint wglBindVideoImageNV;
  GLuint wglGetVideoDeviceNV;
  GLuint wglGetVideoInfoNV;
  GLuint wglReleaseVideoDeviceNV;
  GLuint wglReleaseVideoImageNV;
  GLuint wglSendPbufferToVideoNV;

  /* WGL_OML_sync_control */

  GLuint wglGetMscRateOML;
  GLuint wglGetSyncValuesOML;
  GLuint wglSwapBuffersMscOML;
  GLuint wglSwapLayerBuffersMscOML;
  GLuint wglWaitForMscOML;
  GLuint wglWaitForSbcOML;

  /* WGL_core */

  GLuint wglCopyContext;
  GLuint wglCreateContext;
  GLuint wglCreateLayerContext;
  GLuint wglDeleteContext;
  GLuint wglDescribeLayerPlane;
  GLuint wglGetCurrentContext;
  GLuint wglGetCurrentDC;
  GLuint wglGetDefaultProcAddress;
  GLuint wglGetLayerPaletteEntries;
  GLuint wglGetProcAddress;
  GLuint wglMakeCurrent;
  GLuint wglRealizeLayerPalette;
  GLuint wglSetLayerPaletteEntries;
  GLuint wglShareLists;
  GLuint wglSwapLayerBuffers;
  GLuint wglSwapMultipleBuffers;
  GLuint wglUseFontBitmapsA;
  GLuint wglUseFontBitmapsW;
  GLuint wglUseFontOutlinesA;
  GLuint wglUseFontOutlinesW;
#endif /* REGAL_SYS_WGL */

#if REGAL_SYS_GLX

  /* GLX_VERSION_1_0 */

  GLuint glXChooseVisual;
  GLuint glXCopyContext;
  GLuint glXCreateContext;
  GLuint glXCreateGLXPixmap;
  GLuint glXDestroyContext;
  GLuint glXDestroyGLXPixmap;
  GLuint glXGetConfig;
  GLuint glXGetCurrentContext;
  GLuint glXGetCurrentDrawable;
  GLuint glXIsDirect;
  GLuint glXMakeCurrent;
  GLuint glXQueryExtension;
  GLuint glXQueryVersion;
  GLuint glXSwapBuffers;
  GLuint glXUseXFont;
  GLuint glXWaitGL;
  GLuint glXWaitX;

  /* GLX_VERSION_1_1 */

  GLuint glXGetClientString;
  GLuint glXQueryExtensionsString;
  GLuint glXQueryServerString;

  /* GLX_VERSION_1_2 */

  GLuint glXGetCurrentDisplay;

  /* GLX_VERSION_1_3 */

  GLuint glXChooseFBConfig;
  GLuint glXCreateNewContext;
  GLuint glXCreatePbuffer;
  GLuint glXCreatePixmap;
  GLuint glXCreateWindow;
  GLuint glXDestroyPbuffer;
  GLuint glXDestroyPixmap;
  GLuint glXDestroyWindow;
  GLuint glXGetCurrentReadDrawable;
  GLuint glXGetFBConfigAttrib;
  GLuint glXGetFBConfigs;
  GLuint glXGetSelectedEvent;
  GLuint glXGetVisualFromFBConfig;
  GLuint glXMakeContextCurrent;
  GLuint glXQueryContext;
  GLuint glXQueryDrawable;
  GLuint glXSelectEvent;

  /* GLX_VERSION_1_4 */

  GLuint glXGetProcAddress;

  /* GLX_AMD_gpu_association */

  GLuint glXBlitContextFramebufferAMD;
  GLuint glXCreateAssociatedContextAMD;
  GLuint glXCreateAssociatedContextAttribsAMD;
  GLuint glXDeleteAssociatedContextAMD;
  GLuint glXGetContextGPUIDAMD;
  GLuint glXGetCurrentAssociatedContextAMD;
  GLuint glXGetGPUIDsAMD;
  GLuint glXGetGPUInfoAMD;
  GLuint glXMakeAssociatedContextCurrentAMD;

  /* GLX_ARB_create_context */

  GLuint glXCreateContextAttribsARB;

  /* GLX_ARB_get_proc_address */

  GLuint glXGetProcAddressARB;

  /* GLX_ATI_render_texture */

  GLuint glXBindTexImageATI;
  GLuint glXDrawableAttribATI;
  GLuint glXReleaseTexImageATI;

  /* GLX_EXT_import_context */

  GLuint glXFreeContextEXT;
  GLuint glXGetContextIDEXT;
  GLuint glXImportContextEXT;
  GLuint glXQueryContextInfoEXT;

  /* GLX_EXT_swap_control */

  GLuint glXSwapIntervalEXT;

  /* GLX_EXT_texture_from_pixmap */

  GLuint glXBindTexImageEXT;
  GLuint glXReleaseTexImageEXT;

  /* GLX_MESA_agp_offset */

  GLuint glXGetAGPOffsetMESA;

  /* GLX_MESA_copy_sub_buffer */

  GLuint glXCopySubBufferMESA;

  /* GLX_MESA_pixmap_colormap */

  GLuint glXCreateGLXPixmapMESA;

  /* GLX_MESA_release_buffers */

  GLuint glXReleaseBuffersMESA;

  /* GLX_MESA_set_3dfx_mode */

  GLuint glXSet3DfxModeMESA;

  /* GLX_MESA_swap_control */

  GLuint glXGetSwapIntervalMESA;
  GLuint glXSwapIntervalMESA;

  /* GLX_NV_copy_image */

  GLuint glXCopyImageSubDataNV;

  /* GLX_NV_present_video */

  GLuint glXBindVideoDeviceNV;
  GLuint glXEnumerateVideoDevicesNV;

  /* GLX_NV_swap_group */

  GLuint glXBindSwapBarrierNV;
  GLuint glXJoinSwapGroupNV;
  GLuint glXQueryFrameCountNV;
  GLuint glXQueryMaxSwapGroupsNV;
  GLuint glXQuerySwapGroupNV;
  GLuint glXResetFrameCountNV;

  /* GLX_NV_vertex_array_range */

  GLuint glXAllocateMemoryNV;
  GLuint glXFreeMemoryNV;

  /* GLX_NV_video_capture */

  GLuint glXBindVideoCaptureDeviceNV;
  GLuint glXEnumerateVideoCaptureDevicesNV;
  GLuint glXLockVideoCaptureDeviceNV;
  GLuint glXQueryVideoCaptureDeviceNV;
  GLuint glXReleaseVideoCaptureDeviceNV;

  /* GLX_NV_video_output */

  GLuint glXBindVideoImageNV;
  GLuint glXGetVideoDeviceNV;
  GLuint glXGetVideoInfoNV;
  GLuint glXReleaseVideoDeviceNV;
  GLuint glXReleaseVideoImageNV;
  GLuint glXSendPbufferToVideoNV;

  /* GLX_OML_sync_control */

  GLuint glXGetMscRateOML;
  GLuint glXGetSyncValuesOML;
  GLuint glXSwapBuffersMscOML;
  GLuint glXWaitForMscOML;
  GLuint glXWaitForSbcOML;

  /* GLX_SGIX_fbconfig */

  GLuint glXChooseFBConfigSGIX;
  GLuint glXCreateContextWithConfigSGIX;
  GLuint glXCreateGLXPixmapWithConfigSGIX;
  GLuint glXGetFBConfigAttribSGIX;
  GLuint glXGetFBConfigFromVisualSGIX;
  GLuint glXGetVisualFromFBConfigSGIX;

  /* GLX_SGIX_pbuffer */

  GLuint glXCreateGLXPbufferSGIX;
  GLuint glXDestroyGLXPbufferSGIX;
  GLuint glXGetSelectedEventSGIX;
  GLuint glXQueryGLXPbufferSGIX;
  GLuint glXSelectEventSGIX;

  /* GLX_SGIX_swap_barrier */

  GLuint glXBindSwapBarrierSGIX;
  GLuint glXQueryMaxSwapBarriersSGIX;

  /* GLX_SGIX_swap_group */

  GLuint glXJoinSwapGroupSGIX;

  /* GLX_SGIX_video_resize */

  GLuint glXBindChannelToWindowSGIX;
  GLuint glXChannelRectSGIX;
  GLuint glXChannelRectSyncSGIX;
  GLuint glXQueryChannelDeltasSGIX;
  GLuint glXQueryChannelRectSGIX;

  /* GLX_SGI_cushion */

  GLuint glXCushionSGI;

  /* GLX_SGI_make_current_read */

  GLuint glXGetCurrentReadDrawableSGI;
  GLuint glXMakeCurrentReadSGI;

  /* GLX_SGI_swap_control */

  GLuint glXSwapIntervalSGI;

  /* GLX_SGI_video_sync */

  GLuint glXGetVideoSyncSGI;
  GLuint glXWaitVideoSyncSGI;

  /* GLX_SUN_get_transparent_index */

  GLuint glXGetTransparentIndexSUN;

  /* GLX_SUN_video_resize */

  GLuint glXGetVideoResizeSUN;
  GLuint glXVideoResizeSUN;
#endif /* REGAL_SYS_GLX */

#if REGAL_SYS_OSX

  /* CGL_VERSION_1_0 */

  GLuint CGLChoosePixelFormat;
  GLuint CGLClearDrawable;
  GLuint CGLCopyContext;
  GLuint CGLCreateContext;
  GLuint CGLDescribePixelFormat;
  GLuint CGLDescribeRenderer;
  GLuint CGLDestroyContext;
  GLuint CGLDestroyPixelFormat;
  GLuint CGLDestroyRendererInfo;
  GLuint CGLDisable;
  GLuint CGLEnable;
  GLuint CGLErrorString;
  GLuint CGLFlushDrawable;
  GLuint CGLGetOffScreen;
  GLuint CGLGetOption;
  GLuint CGLGetParameter;
  GLuint CGLGetVersion;
  GLuint CGLGetVirtualScreen;
  GLuint CGLIsEnabled;
  GLuint CGLQueryRendererInfo;
  GLuint CGLSetFullScreen;
  GLuint CGLSetOffScreen;
  GLuint CGLSetOption;
  GLuint CGLSetParameter;
  GLuint CGLSetVirtualScreen;

  /* CGL_VERSION_1_1 */

  GLuint CGLCreatePBuffer;
  GLuint CGLDescribePBuffer;
  GLuint CGLDestroyPBuffer;
  GLuint CGLGetPBuffer;
  GLuint CGLSetPBuffer;
  GLuint CGLTexImagePBuffer;

  /* CGL_VERSION_1_2 */

  GLuint CGLGetContextRetainCount;
  GLuint CGLGetGlobalOption;
  GLuint CGLGetPBufferRetainCount;
  GLuint CGLGetPixelFormat;
  GLuint CGLGetPixelFormatRetainCount;
  GLuint CGLLockContext;
  GLuint CGLReleaseContext;
  GLuint CGLReleasePBuffer;
  GLuint CGLReleasePixelFormat;
  GLuint CGLRetainContext;
  GLuint CGLRetainPBuffer;
  GLuint CGLRetainPixelFormat;
  GLuint CGLSetGlobalOption;
  GLuint CGLUnlockContext;

  /* CGL_VERSION_1_3 */

  GLuint CGLGetCurrentContext;
  GLuint CGLGetShareGroup;
  GLuint CGLGetSurface;
  GLuint CGLSetCurrentContext;
  GLuint CGLSetSurface;
  GLuint CGLTexImageIOSurface2D;
  GLuint CGLUpdateContext;
#endif /* REGAL_SYS_OSX */

#if REGAL_SYS_EGL

  /* EGL_ANGLE_query_surface_pointer */

  GLuint eglQuerySurfacePointerANGLE;

  /* EGL_KHR_fence_sync */

  GLuint eglClientWaitSyncKHR;
  GLuint eglCreateSyncKHR;
  GLuint eglDestroySyncKHR;
  GLuint eglGetSyncAttribKHR;

  /* EGL_KHR_image_base */

  GLuint eglCreateImageKHR;
  GLuint eglDestroyImageKHR;

  /* EGL_KHR_lock_surface */

  GLuint eglLockSurfaceKHR;
  GLuint eglUnlockSurfaceKHR;

  /* EGL_KHR_stream_consumer_gltexture */

  GLuint eglStreamConsumerAcquireKHR;
  GLuint eglStreamConsumerGLTextureExternalKHR;
  GLuint eglStreamConsumerReleaseKHR;

  /* EGL_KHR_stream_cross_process_fd */

  GLuint eglCreateStreamFromFileDescriptorKHR;
  GLuint eglGetStreamFileDescriptorKHR;

  /* EGL_KHR_stream_producer_eglsurface */

  GLuint eglCreateStreamProducerSurfaceKHR;

  /* EGL_KHR_wait_sync */

  GLuint eglWaitSyncKHR;

  /* EGL_MESA_drm_image */

  GLuint eglCreateDRMImageMESA;
  GLuint eglExportDRMImageMESA;

  /* EGL_NV_coverage_sample */

  GLuint eglCoverageMaskNV;
  GLuint eglCoverageOperationNV;

  /* EGL_NV_post_sub_buffer */

  GLuint eglPostSubBufferNV;

  /* EGL_NV_sync */

  GLuint eglClientWaitSyncNV;
  GLuint eglCreateFenceSyncNV;
  GLuint eglDestroySyncNV;
  GLuint eglFenceNV;
  GLuint eglGetSyncAttribNV;
  GLuint eglSignalSyncNV;

  /* EGL_NV_system_time */

  GLuint eglGetSystemTimeFrequencyNV;
  GLuint eglGetSystemTimeNV;

  /* EGL_VERSION_1_0 */

  GLuint eglChooseConfig;
  GLuint eglCopyBuffers;
  GLuint eglCreateContext;
  GLuint eglCreatePbufferSurface;
  GLuint eglCreatePixmapSurface;
  GLuint eglCreateWindowSurface;
  GLuint eglDestroyContext;
  GLuint eglDestroySurface;
  GLuint eglGetConfigAttrib;
  GLuint eglGetConfigs;
  GLuint eglGetCurrentContext;
  GLuint eglGetCurrentDisplay;
  GLuint eglGetCurrentSurface;
  GLuint eglGetDisplay;
  GLuint eglGetError;
  GLuint eglGetProcAddress;
  GLuint eglInitialize;
  GLuint eglMakeCurrent;
  GLuint eglQueryContext;
  GLuint eglQueryString;
  GLuint eglQuerySurface;
  GLuint eglSwapBuffers;
  GLuint eglTerminate;
  GLuint eglWaitGL;
  GLuint eglWaitNative;

  /* EGL_VERSION_1_1 */

  GLuint eglBindTexImage;
  GLuint eglReleaseTexImage;

  /* EGL_VERSION_1_2 */

  GLuint eglBindAPI;
  GLuint eglCreatePbufferFromClientBuffer;
  GLuint eglQueryAPI;
  GLuint eglReleaseThread;
  GLuint eglSurfaceAttrib;
  GLuint eglSwapInterval;
  GLuint eglWaitClient;
#endif /* REGAL_SYS_EGL */

  GLuint enable_GL_BLEND;
  GLuint enable_GL_CLIP_DISTANCE0;
  GLuint enable_GL_CLIP_DISTANCE1;
  GLuint enable_GL_CLIP_DISTANCE2;
  GLuint enable_GL_CLIP_DISTANCE3;
  GLuint enable_GL_CLIP_DISTANCE4;
  GLuint enable_GL_CLIP_DISTANCE5;
  GLuint enable_GL_CLIP_DISTANCE6;
  GLuint enable_GL_CLIP_DISTANCE7;
  GLuint enable_GL_COLOR_LOGIC_OP;
  GLuint enable_GL_CULL_FACE;
  GLuint enable_GL_DEBUG_OUTPUT;
  GLuint enable_GL_DEBUG_OUTPUT_SYNCHRONOUS;
  GLuint enable_GL_DEPTH_CLAMP;
  GLuint enable_GL_DEPTH_TEST;
  GLuint enable_GL_DITHER;
  GLuint enable_GL_FRAMEBUFFER_SRGB;
  GLuint enable_GL_LINE_SMOOTH;
  GLuint enable_GL_MULTISAMPLE;
  GLuint enable_GL_POLYGON_OFFSET_FILL;
  GLuint enable_GL_POLYGON_OFFSET_LINE;
  GLuint enable_GL_POLYGON_OFFSET_POINT;
  GLuint enable_GL_POLYGON_SMOOTH;
  GLuint enable_GL_PRIMITIVE_RESTART;
  GLuint enable_GL_PRIMITIVE_RESTART_FIXED_INDEX;
  GLuint enable_GL_PROGRAM_POINT_SIZE;
  GLuint enable_GL_RESCALE_NORMAL;
  GLuint enable_GL_SAMPLE_ALPHA_TO_COVERAGE;
  GLuint enable_GL_SAMPLE_ALPHA_TO_ONE;
  GLuint enable_GL_SAMPLE_COVERAGE;
  GLuint enable_GL_SAMPLE_MASK;
  GLuint enable_GL_SCISSOR_TEST;
  GLuint enable_GL_STENCIL_TEST;
  GLuint enable_GL_TEXTURE_2D;
  GLuint enable_GL_TEXTURE_CUBE_MAP_SEAMLESS;

  GLuint disable_GL_BLEND;
  GLuint disable_GL_CLIP_DISTANCE0;
  GLuint disable_GL_CLIP_DISTANCE1;
  GLuint disable_GL_CLIP_DISTANCE2;
  GLuint disable_GL_CLIP_DISTANCE3;
  GLuint disable_GL_CLIP_DISTANCE4;
  GLuint disable_GL_CLIP_DISTANCE5;
  GLuint disable_GL_CLIP_DISTANCE6;
  GLuint disable_GL_CLIP_DISTANCE7;
  GLuint disable_GL_COLOR_LOGIC_OP;
  GLuint disable_GL_CULL_FACE;
  GLuint disable_GL_DEBUG_OUTPUT;
  GLuint disable_GL_DEBUG_OUTPUT_SYNCHRONOUS;
  GLuint disable_GL_DEPTH_CLAMP;
  GLuint disable_GL_DEPTH_TEST;
  GLuint disable_GL_DITHER;
  GLuint disable_GL_FRAMEBUFFER_SRGB;
  GLuint disable_GL_LINE_SMOOTH;
  GLuint disable_GL_MULTISAMPLE;
  GLuint disable_GL_POLYGON_OFFSET_FILL;
  GLuint disable_GL_POLYGON_OFFSET_LINE;
  GLuint disable_GL_POLYGON_OFFSET_POINT;
  GLuint disable_GL_POLYGON_SMOOTH;
  GLuint disable_GL_PRIMITIVE_RESTART;
  GLuint disable_GL_PRIMITIVE_RESTART_FIXED_INDEX;
  GLuint disable_GL_PROGRAM_POINT_SIZE;
  GLuint disable_GL_RESCALE_NORMAL;
  GLuint disable_GL_SAMPLE_ALPHA_TO_COVERAGE;
  GLuint disable_GL_SAMPLE_ALPHA_TO_ONE;
  GLuint disable_GL_SAMPLE_COVERAGE;
  GLuint disable_GL_SAMPLE_MASK;
  GLuint disable_GL_SCISSOR_TEST;
  GLuint disable_GL_STENCIL_TEST;
  GLuint disable_GL_TEXTURE_2D;
  GLuint disable_GL_TEXTURE_CUBE_MAP_SEAMLESS;

  bool dummy;
};

REGAL_NAMESPACE_END

#endif // REGAL_STATISTICS
#endif // __REGAL_STATISTICS_H__
